console.log("Tool created and designed by Mirco Schilling | ttv/miiriico");

function updateNum(e, dir) {
    var elmnt = e.target.parentNode.parentNode.querySelector(".inputNumBig");
    if (dir === "+") {
        elmnt.value = parseInt(elmnt.value) + 1
    } else if (dir === "-") {
        elmnt.value = parseInt(elmnt.value) - 1
    }
    elmnt.oninput();
}

// Open Nav Menu

var menuOpen;

function openNavMenu(item) {
    for (var i = 0; i < document.querySelectorAll(".navMenuWrapper").length; i++) {
        document.querySelectorAll(".navMenuWrapper")[i].setAttribute("data-open", "false");
        document.querySelectorAll(".navButton")[i + 1].setAttribute("data-active", "false");
    }
    
    if (menuOpen === item) {
        document.querySelectorAll(".navMenuWrapper")[item].setAttribute("data-open", "false");
        document.querySelectorAll(".navButton")[item + 1].setAttribute("data-active", "false");
        menuOpen = undefined;
    } else {
        document.querySelectorAll(".navMenuWrapper")[item].setAttribute("data-open", "true");
        document.querySelectorAll(".navButton")[item + 1].setAttribute("data-active", "true");
        menuOpen = item;
    }
}

// Open Settings

var openSettingNum = undefined;

function openSetting(num) {
    if (num === openSettingNum) {
        document.querySelectorAll(".setting")[openSettingNum].setAttribute("data-open", "false");
        document.querySelectorAll(".navSubButton")[openSettingNum].setAttribute("data-active", "false");

        openSettingNum = undefined;
    } else {
        if (openSettingNum !== undefined) {
            document.querySelectorAll(".setting")[openSettingNum].setAttribute("data-open", "false");
            document.querySelectorAll(".navSubButton")[openSettingNum].setAttribute("data-active", "false");
        }
        openSettingNum = num;
        document.querySelectorAll(".setting")[openSettingNum].setAttribute("data-open", "true");
        document.querySelectorAll(".navSubButton")[openSettingNum].setAttribute("data-active", "true");
    }
}

// colorPreset

function addPreset() {
    colorPreset.push({
        color: event.target.parentNode.parentNode.querySelector(".colorChangeInput").value,
        opacity: parseInt(event.target.parentNode.parentNode.querySelector(".colorChangeOpacity").value)
    });

    document.querySelectorAll(".presetList").forEach(list => {
        var newPreset = document.createElement("button");
            newPreset.className = "colorPreset";
            newPreset.setAttribute("onclick", "usePreset()");
            newPreset.innerHTML = `<div class="removePreset"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></div>`;
            newPreset.style.backgroundColor = `${colorPreset[colorPreset.length - 1].color}${dec2hex(colorPreset[colorPreset.length - 1].opacity)}`;

        list.appendChild(newPreset);
    });
}

function insertPreset() {
    var presetContent = ``;

    for (var i = 0; i < colorPreset.length; i++) {
        presetContent += `<button class="colorPreset" onclick="usePreset()" style="background-color:${colorPreset[i].color}${dec2hex(colorPreset[i].opacity)}"><div class="removePreset"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></div></button>`
    }

    return presetContent;
}

function usePreset() {
    var i = Array.from(event.target.parentNode.children).indexOf(event.target);
    
    event.target.parentNode.parentNode.parentNode.querySelector(".colorChangeInput").value = colorPreset[i].color;
    event.target.parentNode.parentNode.parentNode.querySelector(".colorChangeOpacity").value = colorPreset[i].opacity;
    event.target.parentNode.parentNode.parentNode.querySelector(".colorChangeOpacity").setAttribute("data-value", colorPreset[i].opacity);

    event.target.parentNode.parentNode.parentNode.querySelector(".colorChangeInput").oninput();
    event.target.parentNode.parentNode.parentNode.querySelector(".colorChangeOpacity").oninput();

    event.target.parentNode.parentNode.parentNode.querySelector(".colorChangeType").querySelectorAll("button")[0].onclick();
}

function removePreset() {
    var i = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);

    document.querySelectorAll(".presetList").forEach(list => {
        list.querySelectorAll(".colorPreset")[i].remove();
    });
    colorPreset.splice(i, 1);
}

function showDeletePreset() {
    if (event.target.parentNode.querySelector(".presetList").getAttribute("data-delete-show") === "false") {
        event.target.parentNode.querySelector(".presetList").setAttribute("data-delete-show", "true");
        event.target.parentNode.querySelectorAll(".colorPreset").forEach(preset => {
            preset.setAttribute("onclick", "removePreset()");
        });
        event.target.setAttribute("data-active", "true");
    } else {
        event.target.parentNode.querySelector(".presetList").setAttribute("data-delete-show", "false");
        event.target.parentNode.querySelectorAll(".colorPreset").forEach(preset => {
            preset.setAttribute("onclick", "usePreset()");
        });
        event.target.setAttribute("data-active", "false");
    }
}

// settings.genStreamerList

function updateStreamerList() {
    for (let i = 0; i < settings.genStreamerList.length; i++) {
        settings.genStreamerList[i] = document.querySelectorAll(".genStreamerListInput")[i].value;
    }
    client.channels = settings.genStreamerList;
}

function addStreamerList() {
    var newListItem = document.createElement("div"),
        newListInput = document.createElement("input"),
        newListRemove = document.createElement("button");

    newListItem.className = "inputTextListItem";

    newListInput.type = "text";
    newListInput.className = "inputTextListItemInput genStreamerListInput";
    newListInput.setAttribute("oninput", "updateStreamerList()");

    newListRemove.className = "inputTextListItemRemove icon";
    newListRemove.setAttribute("onclick", "this.parentNode.remove(); removeStreamerList();");
    newListRemove.innerHTML = `<img class="iconSVG" src="Icons/Diverse/Remove.svg">`;

    newListItem.appendChild(newListInput);
    newListItem.appendChild(newListRemove);
    document.querySelector("#genStreamerList").appendChild(newListItem);
    
    settings.genStreamerList.push("");

    updateStreamerList();
}

function removeStreamerList() {
    settings.genStreamerList.shift();
    updateStreamerList()
}

function connectStreamer() {
    if (client.ws === null) {
        document.querySelector("#ConnectButton").setAttribute("data-connected", "true")
        document.querySelector("#ConnectButton").innerHTML = "Disconnect";
        client.connect();
    } else {
        document.querySelector("#ConnectButton").setAttribute("data-connected", "false")
        document.querySelector("#ConnectButton").innerHTML = "Connect";
        client.disconnect();
    }
}

// settings.genChatDirection

function updateChatDir(dir) {
    if (dir === "up") {
        settings.genChatDirection = "up";
        document.querySelectorAll(".genChatDirectionBtn")[0].setAttribute("data-active", "true");
        document.querySelectorAll(".genChatDirectionBtn")[1].setAttribute("data-active", "false");
        document.querySelector("#Cnt").style.setProperty("--genChatDirection", "column");
    } else if (dir === "down") {
        settings.genChatDirection = "down";
        document.querySelectorAll(".genChatDirectionBtn")[1].setAttribute("data-active", "true");
        document.querySelectorAll(".genChatDirectionBtn")[0].setAttribute("data-active", "false");
        document.querySelector("#Cnt").style.setProperty("--genChatDirection", "column-reverse");
    }
}

// settings.genFilterUser

function updateFilterUser() {
    for (let i = 0; i < settings.genFilterUser.length; i++) {
        settings.genFilterUser[i] = document.querySelectorAll(".genFilterUserInput")[i].value.toLowerCase();
    }
}

function addFilterUser() {
    var newListItem = document.createElement("div"),
        newListInput = document.createElement("input"),
        newListRemove = document.createElement("button");

    newListItem.className = "inputTextListItem";

    newListInput.type = "text";
    newListInput.className = "inputTextListItemInput genFilterUserInput";
    newListInput.setAttribute("oninput", "updateFilterUser()");

    newListRemove.className = "inputTextListItemRemove icon";
    newListRemove.setAttribute("onclick", "this.parentNode.remove(); removeFilterUser();");
    newListRemove.innerHTML = `<img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg">`;

    newListItem.appendChild(newListInput);
    newListItem.appendChild(newListRemove);
    document.querySelector("#genFilterUser").appendChild(newListItem);
    
    settings.genFilterUser.push("");

    updateFilterUser();
}

function removeFilterUser() {
    settings.genFilterUser.shift();
    updateFilterUser()
}

// settings.genFilterMsg

function updateFilterMessage() {
    for (let i = 0; i < settings.genFilterMsg.length; i++) {
        settings.genFilterMsg[i] = document.querySelectorAll(".genFilterMessageInput")[i].value.toLowerCase();
    }
}

function addFilterMessage() {
    var newListItem = document.createElement("div"),
        newListInput = document.createElement("input"),
        newListRemove = document.createElement("button");

    newListItem.className = "inputTextListItem";

    newListInput.type = "text";
    newListInput.className = "inputTextListItemInput genFilterMessageInput";
    newListInput.setAttribute("oninput", "updateFilterMessage()");

    newListRemove.className = "inputTextListItemRemove icon";
    newListRemove.setAttribute("onclick", "this.parentNode.remove(); removeFilterMessage();");
    newListRemove.innerHTML = `<img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg">`;

    newListItem.appendChild(newListInput);
    newListItem.appendChild(newListRemove);
    document.querySelector("#genFilterMessage").appendChild(newListItem);
    
    settings.genFilterMsg.push("");

    updateFilterMessage();
}

function removeFilterMessage() {
    settings.genFilterMsg.shift();
    updateFilterMessage()
}

// settings.genMaxMessages

function updateMaxMsg() {
    settings.genMaxMessages = parseInt(document.querySelector("#genMaxMsgInput").value);
}

var roleList = [
        "user",
        "sub",
        "vip",
        "mod"
    ],
    activeRole = "user";

function changeActiveRole(val) {
    document.querySelectorAll(".roleBtn").forEach(roleBtn => {
        roleBtn.setAttribute("data-active", "false");
    });
    event.target.setAttribute("data-active", "true");

    activeRole = val;
    loadingRole = val;

    if (val === "user") {
        document.querySelector(":root").style.setProperty("--bg1", "#282828");
        document.querySelector(":root").style.setProperty("--bg2", "#111111");
        document.querySelectorAll(".roleHeaderDescr").forEach(h3 => {
            h3.innerHTML = "User"
        })
    } else if (val === "sub") {
        document.querySelector(":root").style.setProperty("--bg1", "#3a3505");
        document.querySelector(":root").style.setProperty("--bg2", "#221e02");
        document.querySelectorAll(".roleHeaderDescr").forEach(h3 => {
            h3.innerHTML = "Sub"
        })
    } else if (val === "vip") {
        document.querySelector(":root").style.setProperty("--bg1", "#190e4d");
        document.querySelector(":root").style.setProperty("--bg2", "#0b0429");
        document.querySelectorAll(".roleHeaderDescr").forEach(h3 => {
            h3.innerHTML = "VIP"
        })
    } else if (val === "mod") {
        document.querySelector(":root").style.setProperty("--bg1", "#7c1313");
        document.querySelector(":root").style.setProperty("--bg2", "#530808");
        document.querySelectorAll(".roleHeaderDescr").forEach(h3 => {
            h3.innerHTML = "Mod"
        })
    }

    loadingData();
}



function decompileCollection() {
    decompileCbxLayout();
    decompileCbxBG();
    decompileCbxMask()
    decompileCbxBorder();
    decompileCbxBorderRadius();
    decompileCbxShadow();
    decompileCbxSpacing();
    decompileCbxSizing();
    decompileUsnBG();
    decompileUsnMask()
    decompileUsnBorder();
    decompileUsnBorderRadius();
    decompileUsnShadow();
    decompileUsnSpacing();
    decompileUsnSizing();
    decompileUsnFont();
    decompileUsnFontShadow();
    decompileUsnContent();
    decompileMsgBG();
    decompileMsgMask()
    decompileMsgBorder();
    decompileMsgBorderRadius();
    decompileMsgShadow();
    decompileMsgSpacing();
    decompileMsgSizing();
    decompileMsgFont();
    decompileMsgFontShadow();
    decompileMsgContent();
    decompileOthEmotes();
    decompileOthBadges();
}

function switchRoleActive(dir) {
    if (event.target.getAttribute("data-active") === "false") {
        event.target.setAttribute("data-active", "true");
        eval(dir)[`${activeRole}`].active = true
    } else if (activeRole !== "user") {
        event.target.setAttribute("data-active", "false");
        eval(dir)[`${activeRole}`].active = false
    }
    decompileCollection();
}

var settingClipboard = {
    type: "",
    value: ""
};

function settingCopy() {
    settingClipboard.type = event.target.parentNode.getAttribute("data-type");
    settingClipboard.value = JSON.parse(JSON.stringify(eval(`${event.target.parentNode.getAttribute("data-copy")}["${activeRole}"].value`)))  ;
    
    document.querySelector("aside").setAttribute("data-setting-paste-active", "true");
}

function settingPaste() {
    console.log(event.target.parentNode.getAttribute("data-type"));
    console.log(settingClipboard.type);
    if (event.target.parentNode.getAttribute("data-type") === settingClipboard.type) {
        var confirmPaste = confirm("Do you want to overwrite the current settings?");
        if (confirmPaste === true) {
            eval(`${event.target.parentNode.getAttribute("data-copy")}`)[`${activeRole}`].value = settingClipboard.value;
            loadingData();
            decompileCollection();
        }
    } else {
        alert("The copied settings are not from the same type!")
    }
    document.querySelector("aside").setAttribute("data-setting-paste-active", "false");
}

// settings.cbxLayout

function decompileCbxLayout() {
    roleList.forEach(role => {
        if (settings.cbxLayout[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                cbxW.style.setProperty("--cbxLayout", settings.cbxLayout[`${role}`].value.type);
                if (settings.cbxLayout[`${role}`].value.type === "column" || settings.cbxLayout[`${role}`].value.type === "column-reverse") {
                    cbxW.querySelector(".usn").style.setProperty("--usnSizingH", settings.usnPosition[`${role}`].value.sizingH);
                    cbxW.querySelector(".usn").style.setProperty("--usnSizingV", settings.usnPosition[`${role}`].value.sizingV);
                    cbxW.querySelector(".msg").style.setProperty("--msgSizingH", settings.msgPosition[`${role}`].value.sizingH);
                    cbxW.querySelector(".msg").style.setProperty("--msgSizingV", settings.msgPosition[`${role}`].value.sizingV);
                } else if (settings.cbxLayout[`${role}`].value.type === "row" || settings.cbxLayout[`${role}`].value.type === "row-reverse") {
                    cbxW.querySelector(".usn").style.setProperty("--usnSizingH", settings.usnPosition[`${role}`].value.sizingV);
                    cbxW.querySelector(".usn").style.setProperty("--usnSizingV", settings.usnPosition[`${role}`].value.sizingH);
                    cbxW.querySelector(".msg").style.setProperty("--msgSizingH", settings.msgPosition[`${role}`].value.sizingV);
                    cbxW.querySelector(".msg").style.setProperty("--msgSizingV", settings.msgPosition[`${role}`].value.sizingH);
                }
                if (settings.cbxLayout[`${role}`].value.layoutRowSizing === "username") {
                    cbxW.style.setProperty("--usnFlexGrow", 1);
                    cbxW.style.setProperty("--msgFlexGrow", 0);
                } else if (settings.cbxLayout[`${role}`].value.layoutRowSizing === "space") {
                    cbxW.style.setProperty("--usnFlexGrow", 0);
                    cbxW.style.setProperty("--msgFlexGrow", 0);
                } else if (settings.cbxLayout[`${role}`].value.layoutRowSizing === "message") {
                    cbxW.style.setProperty("--usnFlexGrow", 0);
                    cbxW.style.setProperty("--msgFlexGrow", 1);
                }
            });
        }
    });
}

function updateLayout(type) {
    var index = Array.from(event.target.parentNode.children).indexOf(event.target);
    if (type === "main") {
        
        document.querySelectorAll(".layoutBtn").forEach(btn => {
            btn.setAttribute("data-active", "false");
        });
        
        event.target.setAttribute("data-active", "true");
    
        switch (index) {
            case 0:
                settings.cbxLayout[`${activeRole}`].value.type = "column";
                document.querySelector(".layoutRowOptions").setAttribute("data-active", "false");
            break;
            
            case 1:
                settings.cbxLayout[`${activeRole}`].value.type = "column-reverse";
                document.querySelector(".layoutRowOptions").setAttribute("data-active", "false");
            break;
            
            case 2:
                settings.cbxLayout[`${activeRole}`].value.type = "row";
                document.querySelector(".layoutRowOptions").setAttribute("data-active", "true");
            break;
                
            case 3:
                settings.cbxLayout[`${activeRole}`].value.type = "row-reverse";
                document.querySelector(".layoutRowOptions").setAttribute("data-active", "true");
            break;
        }
    } else if (type === "row") {
        document.querySelectorAll(".layoutHBtn").forEach(btn => {
            btn.setAttribute("data-active", "false");
        });
        
        event.target.setAttribute("data-active", "true");

        switch (index) {
            case 0:
                settings.cbxLayout[`${activeRole}`].value.layoutRowSizing = "username";
            break;

            case 1:
                settings.cbxLayout[`${activeRole}`].value.layoutRowSizing = "space";
            break;

            case 2:
                settings.cbxLayout[`${activeRole}`].value.layoutRowSizing = "message";
            break;
        }
    }

    decompileCbxLayout();
}
    
    // settings.cbxBackground
    
    var activeCbxBGGrad = 0;
    var activeCbxBGColor = 0;
    
function decompileCbxBG() {
    roleList.forEach(role => {
        if (settings.cbxBackground[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var cbxBackground = "",
                    cbxBackgroundPos = "",
                    cbxBackgroundSize = "";
                for (let i = 0; i < settings.cbxBackground[`${role}`].value.length; i++) {
                    if (settings.cbxBackground[`${role}`].value[i].type === "solid") {
                        if (settings.cbxBackground[`${role}`].value[i].colors[0].type === "custom") {
                            cbxBackground += `linear-gradient(${settings.cbxBackground[`${role}`].value[i].colors[0].color}${dec2hex(settings.cbxBackground[`${role}`].value[i].colors[0].opacity)}, ${settings.cbxBackground[`${role}`].value[i].colors[0].color}${dec2hex(settings.cbxBackground[`${role}`].value[i].colors[0].opacity)})`;
                        } else if (settings.cbxBackground[`${role}`].value[i].colors[0].type === "twitch") {
                            cbxBackground += `linear-gradient(${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxBackground[`${role}`].value[i].colors[0].opacity)}, ${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxBackground[`${role}`].value[i].colors[0].opacity)})`;
                        }
                    } else if (settings.cbxBackground[`${role}`].value[i].type === "linear") {
                        var sortedColors = [...settings.cbxBackground[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        cbxBackground += `linear-gradient(${settings.cbxBackground[`${role}`].value[i].rotate}deg, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            if (sortedColors[j].type === "custom") {
                                cbxBackground += `${sortedColors[j].color}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            } else if (sortedColors[j].type === "twitch") {
                                cbxBackground += `${cbxW.getAttribute("data-twitch")}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`
                            }
                            
                            if (j < settings.cbxBackground[`${role}`].value[i].colors.length - 1) {
                                cbxBackground += ", "
                            } else if (j === settings.cbxBackground[`${role}`].value[i].colors.length - 1) {
                                cbxBackground += ")";
                            }
                        }
                    } else if (settings.cbxBackground[`${role}`].value[i].type === "radial") {
                        var sortedColors = [...settings.cbxBackground[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        cbxBackground += `radial-gradient(${settings.cbxBackground[`${role}`].value[i].size} at ${settings.cbxBackground[`${role}`].value[i].x}% ${settings.cbxBackground[`${role}`].value[i].y}%, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            if (sortedColors[j].type === "custom") {
                                cbxBackground += `${sortedColors[j].color}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            } else if (sortedColors[j].type === "twitch") {
                                cbxBackground += `${cbxW.getAttribute("data-twitch")}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`
                            }
                            
                            if (j < settings.cbxBackground[`${role}`].value[i].colors.length - 1) {
                                cbxBackground += ", "
                            } else if (j === settings.cbxBackground[`${role}`].value[i].colors.length - 1) {
                                cbxBackground += ")";
                            }
                        }
                    }

                    cbxBackgroundPos += `calc(${settings.cbxBackground[`${role}`].value[i].posX.percent}% + ${settings.cbxBackground[`${role}`].value[i].posX.px}px) calc(${settings.cbxBackground[`${role}`].value[i].posY.percent}% + ${settings.cbxBackground[`${role}`].value[i].posY.px}px)`;
                    cbxBackgroundSize += `calc(${settings.cbxBackground[`${role}`].value[i].width.percent}% + ${settings.cbxBackground[`${role}`].value[i].width.px}px) calc(${settings.cbxBackground[`${role}`].value[i].height.percent}% + ${settings.cbxBackground[`${role}`].value[i].height.px}px)`;

                    if (i < settings.cbxBackground[`${role}`].value.length - 1) {
                        cbxBackground += `, `;
                        cbxBackgroundPos += `, `;
                        cbxBackgroundSize += `, `;
                    }
                }
                
                cbxW.style.setProperty(`--cbxBackground`, cbxBackground);
                cbxW.style.setProperty(`--cbxBackgroundPos`, cbxBackgroundPos);
                cbxW.style.setProperty(`--cbxBackgroundSize`, cbxBackgroundSize);
            });
        }
    });
}

function switchCbxMaskBG(type) {
    if (type === "BG") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.parentNode.querySelector(".backgroundCont").setAttribute("data-active", "true");
        event.target.parentNode.parentNode.querySelector(".maskCont").setAttribute("data-active", "false");
    } else if (type === "Mask") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "true");
        event.target.parentNode.parentNode.querySelector(".backgroundCont").setAttribute("data-active", "false");
        event.target.parentNode.parentNode.querySelector(".maskCont").setAttribute("data-active", "true");
    }
}

function updateColorSliderCbxBGBox() {
    for (let i = 0; i < document.querySelectorAll(".colorSliderCbxBGCont").length; i++) {
        if (settings.cbxBackground[`${activeRole}`].value[i].type !== "solid") {
            
            var cbxBGPrev = "linear-gradient(90deg, ",
                nodeList = document.querySelectorAll(".colorSliderCbxBGCont")[i].querySelectorAll(".colorSliderCbxBG"),
                colorList = settings.cbxBackground[`${activeRole}`].value[i].colors;

            for (let j = 0; j < settings.cbxBackground[`${activeRole}`].value[i].colors.length; j++) {
                settings.cbxBackground[`${activeRole}`].value[i].colors[j].count = 0;
                colorList[j].position = parseFloat(nodeList[j].value);
                nodeList[j].style.setProperty("--value", `${nodeList[j].value}%`);
                nodeList[j].style.setProperty("--valueTxt", `"${nodeList[j].value}"`);
            }

            for (let j = 0; j < settings.cbxBackground[`${activeRole}`].value[i].colors.length; j++) {
                for (let k = 0; k < settings.cbxBackground[`${activeRole}`].value[i].colors.length; k++) {
                    if (k !== j) {
                        if (settings.cbxBackground[`${activeRole}`].value[i].colors[j].position >= settings.cbxBackground[`${activeRole}`].value[i].colors[k].position) {
                            settings.cbxBackground[`${activeRole}`].value[i].colors[j].count += 1;
                        }
                    }
                }
            }

            for (let j = 0; j < settings.cbxBackground[`${activeRole}`].value[i].colors.length; j++) {
                var resultElmnt = settings.cbxBackground[`${activeRole}`].value[i].colors.find(findElmnt => findElmnt.count === j);
                cbxBGPrev += `${resultElmnt.color}${dec2hex(resultElmnt.opacity)} ${resultElmnt.position}%`;
                
                if (j < settings.cbxBackground[`${activeRole}`].value[i].colors.length - 1) {
                    cbxBGPrev += ", ";
                } else {
                    cbxBGPrev += ")";
                }
            }

            document.querySelectorAll(".colorSliderCbxBGCont")[i].style.backgroundImage = cbxBGPrev;
        } else {
            var cbxBGPrev = `${settings.cbxBackground[`${activeRole}`].value[i].colors[0].color}${dec2hex(settings.cbxBackground[`${activeRole}`].value[i].colors[0].opacity)}`;
            document.querySelectorAll(".colorSliderCbxBGCont")[i].style.backgroundColor = cbxBGPrev;
        }
    }
    decompileCbxBG();
}

function openColorCbxBGBox(grdNum, clrNum) {
    var open = true;

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });

    event.target.parentNode.setAttribute("data-color-show", open);
    
    activeCbxBGGrad = grdNum;
    activeCbxBGColor = clrNum;
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].setAttribute("data-color-show", "true");
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].setAttribute("data-set-show", "false");
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].setAttribute("data-size-show", "false");
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeInput").value = settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].color;
    if (settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].type === "custom") {
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
    } else if (settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].type === "twitch") {
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
    }
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeOpacity").value = settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].opacity;
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeOpacity").setAttribute("data-value", settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].opacity);
    document.querySelectorAll(".colorSliderCbxBG").forEach(cbxCont => {
        cbxCont.setAttribute("data-active", "false");
    });
    document.querySelectorAll(".colorSliderCbxBGCont")[activeCbxBGGrad].querySelectorAll(".colorSliderCbxBG")[activeCbxBGColor].setAttribute("data-active", "true");
}

function updateNameCbxBGBox() {
    for (var i = 0; i < document.querySelectorAll(".backgroundNameCbxBG").length; i++) {
        settings.cbxBackground[`${activeRole}`].value[i].name = document.querySelectorAll(".backgroundNameCbxBG")[i].value;
    }
}

function updateColorCbxBGBox(type) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    if (type) {settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].type = type;}
    
    if (type === "custom") {
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");

    } else if (type === "twitch") {
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
    }
    settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].color = document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeInput").value;
    settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors[activeCbxBGColor].opacity = parseInt(document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelector(".colorChangeOpacity").value);
    updateColorSliderCbxBGBox();

    decompileCbxBG();
}

function deleteColorCbxBGBox() {
    settings.cbxBackground[`${activeRole}`].value[activeCbxBGGrad].colors.splice(activeCbxBGColor, 1);
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelectorAll(".colorSliderCbxBG")[activeCbxBGColor].remove();
    updateColorSliderCbxBGBox();
    for (let i = 0; i < document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelectorAll(".colorSliderCbxBG").length; i++) {
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].querySelectorAll(".colorSliderCbxBG")[i].setAttribute("onpointerdown", `openColorCbxBGBox(${activeCbxBGGrad}, ${i})`);
    }
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[activeCbxBGGrad].setAttribute("data-color-show", "false");
    activeCbxBGGrad = undefined;
    activeCbxBGColor = undefined;

    for (let j = 0; j < settings.cbxBackground[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.cbxBackground[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorCbxBGBox(${j}, ${k})`)
        }
    }

    decompileCbxBG();
}

function addColorSliderCbxBG(e) {
    i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    document.querySelectorAll(".colorSlider").forEach(slider => {
        slider.setAttribute("data-active", "false");
    })
    var newSlider = document.createElement("input");newSlider.className = "colorSlider colorSliderCbxBG";newSlider.setAttribute("oninput", "updateColorSliderCbxBGBox()");newSlider.setAttribute("onpointerdown", `openColorCbxBGBox(${i}, ${e.target.parentNode.querySelectorAll(".colorSlider").length})`);newSlider.type = "range";newSlider.value = (e.layerX / e.target.clientWidth) * 100;newSlider.min = "0";newSlider.max = "100";newSlider.step = "0.1";newSlider.setAttribute("data-active", "true");
                
    document.querySelectorAll(".colorSliderCbxBGCont")[i].appendChild(newSlider);

    settings.cbxBackground[`${activeRole}`].value[i].colors.push({
        position: newSlider.value, // In %
        type: "custom",
        color: "#ffffff",
        opacity: 255, // In Hex
        count: 0
    });
    updateColorSliderCbxBGBox();
    openColorCbxBGBox(i, e.target.parentNode.querySelectorAll(".colorSlider").length - 1);
    
    updateColorSliderCbxBGBox();
    
    decompileCbxBG();
}

function hideColorCbxBGBox() {
    document.querySelectorAll(".colorSliderCbxBGCont")[activeCbxBGGrad].querySelectorAll(".colorSliderCbxBG")[activeCbxBGColor].setAttribute("data-active", "false");
    activeCbxBGGrad = undefined;
    activeCbxBGColor = undefined;
    event.target.parentNode.parentNode.setAttribute("data-color-show", "false");
}

function switchSetCbxBGBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-set-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderCbxBG").forEach(cbxCont => {
        cbxCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-set-show", open);
}

function switchSizeCbxBGBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-size-show") === "true") {
        open = false;
    }
    
    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderCbxBG").forEach(cbxCont => {
        cbxCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-size-show", open);
}

function addGradientCbxBG(type, index) {
    var indexPlace;
    if (index === undefined) {
        indexPlace = 0;
        if (type === "solid") {
            settings.cbxBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "solid",
                name: `Background ${settings.cbxBackground[`${activeRole}`].value.length + 1}`,
                colors: [
                    {
                        position:0,
                        type: "custom",
                        color:"#ffffff",
                        opacity:255,
                        count:0
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameCbxBG backgroundName" type="text" value="${settings.cbxBackground[`${activeRole}`].value[0].name}" oninput="updateNameCbxBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientCbxBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderCbxBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderCbxBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderCbxBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Solid</div>
                            <div class="colorSliderAdd colorSliderCbxBGAdd"></div>
                            <div class="colorSliderCont colorSliderCbxBGCont" style="background-color:#ffffff;">
                                <input class="colorSlider colorSliderCbxBG" oninput="updateColorSliderCbxBGBox()" onpointerdown="openColorCbxBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorCbxBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorCbxBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorCbxBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorCbxBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorCbxBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorCbxBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeCbxBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "linear") {
            settings.cbxBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "linear",
                name: `Background ${settings.cbxBackground[`${activeRole}`].value.length + 1}`,
                rotate: 90, // In deg
                colors: [
                    {
                        position: 0, // In %
                        type: "custom",
                        color: "#000000",
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        type: "custom",
                        color: "#ffffff",
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameCbxBG backgroundName" type="text" value="${settings.cbxBackground[`${activeRole}`].value[0].name}" oninput="updateNameCbxBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientCbxBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderCbxBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderCbxBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderCbxBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Linear</div>
                            <div class="colorSliderAdd colorSliderCbxBGAdd" onclick="addColorSliderCbxBG(event)"></div>
                            <div class="colorSliderCont colorSliderCbxBGCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderCbxBG" oninput="updateColorSliderCbxBGBox()" onpointerdown="openColorCbxBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderCbxBG" oninput="updateColorSliderCbxBGBox()" onpointerdown="openColorCbxBGBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorCbxBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorCbxBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorCbxBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorCbxBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorCbxBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorCbxBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetCbxBGBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">rotation:</span>
                                <input class="numContInput" type="number" value="90" oninput="updateLinearRotCbxBG(event)">
                                <span class="numContUnit">°</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeCbxBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "radial") {
            settings.cbxBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "radial",
                name: `Background ${settings.cbxBackground[`${activeRole}`].value.length + 1}`,
                size: "farthest-corner", // farthest/closest - corner/side, circle
                x: 50, // In %
                y: 50, // In %
                colors: [
                    {
                        position: 0, // In %
                        type: "custom",
                        color: "#000000",
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        type: "custom",
                        color: "#ffffff",
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameCbxBG backgroundName" type="text" value="${settings.cbxBackground[`${activeRole}`].value[0].name}" oninput="updateNameCbxBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientCbxBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderCbxBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderCbxBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderCbxBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Radial</div>
                            <div class="colorSliderAdd colorSliderCbxBGAdd" onclick="addColorSliderCbxBG(event)"></div>
                            <div class="colorSliderCont colorSliderCbxBGCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderCbxBG" oninput="updateColorSliderCbxBGBox()" onpointerdown="openColorCbxBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderCbxBG" oninput="updateColorSliderCbxBGBox()" onpointerdown="openColorCbxBGBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorCbxBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorCbxBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorCbxBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorCbxBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorCbxBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorCbxBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetCbxBGBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="singleChoiceList gradRadialPosContCbxBG">
                            <button data-active="true" onclick="updateRadialTypeCbxBG(event, 'farthest-corner')">Farthest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeCbxBG(event, 'farthest-side')">Farthest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeCbxBG(event, 'closest-corner')">Closest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeCbxBG(event, 'closest-side')">Closest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeCbxBG(event, 'circle')">Circle</button>
                        </div>
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">x:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosCbxBG(event, 'x')">
                                <span class="numContUnit">%</span>
                            </div>
                            <div class="numCont">
                                <span class="numContDescr">y:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosCbxBG(event, 'y')">
                                <span class="numContUnit">%</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeCbxBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        }
        document.querySelector(".colorMenuColCbxBG").insertBefore(colorMenu, document.querySelector(".colorMenuColCbxBG").children[indexPlace]);
    } else {
        indexPlace = index;

        var menuOpt = JSON.parse(JSON.stringify(settings.cbxBackground[`${activeRole}`].value[indexPlace]));
        settings.cbxBackground[`${activeRole}`].value.splice(indexPlace, 0, menuOpt);

        var colorMenuNode = document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[indexPlace].cloneNode(true);
        colorMenuNode.setAttribute("data-color-show", "false");
        colorMenuNode.setAttribute("data-set-show", "false");
        colorMenuNode.setAttribute("data-size-show", "false");
        document.querySelector(".colorMenuColCbxBG").insertBefore(colorMenuNode, document.querySelector(".colorMenuColCbxBG").children[indexPlace]);
    }
    
    for (var i = 0; i < document.querySelectorAll(".colorSliderCbxBGCont").length; i++) {
        for (var j = 0; j < document.querySelectorAll(".colorSliderCbxBGCont")[i].querySelectorAll(".colorSlider").length; j++) {
            document.querySelectorAll(".colorSliderCbxBGCont")[i].querySelectorAll(".colorSlider")[j].setAttribute("onpointerdown", `openColorCbxBGBox(${i}, ${j})`);
        }
    }
    
    updateColorSliderCbxBGBox();
    decompileCbxBG();
}

function removeGradientCbxBG(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode);
    if (i < activeCbxBGGrad) {
        activeCbxBGGrad -= 1;
    }
    settings.cbxBackground[`${activeRole}`].value.splice(i, 1);
    document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[i].remove();
    for (let j = 0; j < document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu").length; j++) {
        for (let k = 0; k < document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider").length; k++) {
            document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorCbxBGBox(${j}, ${k})`)
        }
    }
    
    decompileCbxBG();
}

function updateRadialTypeCbxBG(e, size) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    settings.cbxBackground[`${activeRole}`].value[i].size = size;
    for (let j = 0; j < settings.cbxBackground[`${activeRole}`].value.length; j++) {
        if (settings.cbxBackground[`${activeRole}`].value[j].type === "radial") {
            for (let k = 0; k < document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContCbxBG").querySelectorAll("button").length; k++) {
                document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContCbxBG").querySelectorAll("button")[k].setAttribute("data-active", "false");
            }
            e.target.setAttribute("data-active", "true");
        }
    }
    
    decompileCbxBG();
}

function updateLinearRotCbxBG(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    settings.cbxBackground[`${activeRole}`].value[i].rotate = parseInt(e.target.value);
    
    decompileCbxBG();
}

function updateRadialPosCbxBG(e, xy) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    if (xy === "x") {
        settings.cbxBackground[`${activeRole}`].value[i].x = parseInt(e.target.value);
    } else if (xy === "y") {
        settings.cbxBackground[`${activeRole}`].value[i].y = parseInt(e.target.value);
    }
    
    decompileCbxBG();
}

function moveColorSliderCbxBG(e, dir) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    if (dir === "up" && i > 0) {
        var elmnt = settings.cbxBackground[`${activeRole}`].value[i];
        settings.cbxBackground[`${activeRole}`].value.splice(i, 1);
        settings.cbxBackground[`${activeRole}`].value.splice(i - 1, 0, elmnt);
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[i - 1].before(document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[i]);
        if (activeCbxBGGrad === i) {
            activeCbxBGGrad -= 1;
        } else if (activeCbxBGGrad === i - 1) {
            activeCbxBGGrad += 1;
        }
    } else if (dir === "down" && i < settings.cbxBackground[`${activeRole}`].value.length - 1) {
        var elmnt = settings.cbxBackground[`${activeRole}`].value[i];
        settings.cbxBackground[`${activeRole}`].value.splice(i, 1);
        settings.cbxBackground[`${activeRole}`].value.splice(i + 1, 0, elmnt);
        document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[i + 1].after(document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[i]);
        if (activeCbxBGGrad === i) {
            activeCbxBGGrad += 1;
        } else if (activeCbxBGGrad === i + 1) {
            activeCbxBGGrad -= 1;
        }
    }

    for (let j = 0; j < settings.cbxBackground[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.cbxBackground[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColCbxBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorCbxBGBox(${j}, ${k})`)
        }
    }
    
    decompileCbxBG();
}

function duplicateColorSliderCbxBG() {
    activeCbxBGGrad += 1;
    var i = Array.from(event.target.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode);
    var type = settings.cbxBackground[`${activeRole}`].value[i].type;

    addGradientCbxBG(type, i);
}

function updateCbxBGSizePos(cat, value) {
    var i = Array.from(event.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode.parentNode);
    if (cat === "posX") {
        if (value === "%") {
            settings.cbxBackground[`${activeRole}`].value[i].posX.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackground[`${activeRole}`].value[i].posX.px = parseInt(event.target.value);
        }
    } else if (cat === "posY") {
        if (value === "%") {
            settings.cbxBackground[`${activeRole}`].value[i].posY.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackground[`${activeRole}`].value[i].posY.px = parseInt(event.target.value);
        }
    } else if (cat === "width") {
        if (value === "%") {
            settings.cbxBackground[`${activeRole}`].value[i].width.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackground[`${activeRole}`].value[i].width.px = parseInt(event.target.value);
        }
    } else if (cat === "height") {
        if (value === "%") {
            settings.cbxBackground[`${activeRole}`].value[i].height.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackground[`${activeRole}`].value[i].height.px = parseInt(event.target.value);
        }
    }
    
    decompileCbxBG();
}

// settings.cbxBackgroundMask

var activeCbxMaskGrad = 0;
var activeCbxMaskColor = 0;

function decompileCbxMask() {
    roleList.forEach(role => {
        if (settings.cbxBackgroundMask[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var cbxBackgroundMask = "",
                    cbxBackgroundMaskPos = "",
                    cbxBackgroundMaskSize = "";
                for (let i = 0; i < settings.cbxBackgroundMask[`${role}`].value.length; i++) {
                    if (settings.cbxBackgroundMask[`${role}`].value[i].type === "solid") {
                        cbxBackgroundMask += `linear-gradient(#ffffff${dec2hex(settings.cbxBackgroundMask[`${role}`].value[i].colors[0].opacity)}, #ffffff${dec2hex(settings.cbxBackgroundMask[`${role}`].value[i].colors[0].opacity)})`;
                    } else if (settings.cbxBackgroundMask[`${role}`].value[i].type === "linear") {
                        var sortedColors = [...settings.cbxBackgroundMask[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        cbxBackgroundMask += `linear-gradient(${settings.cbxBackgroundMask[`${role}`].value[i].rotate}deg, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            cbxBackgroundMask += `#ffffff${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            
                            if (j < settings.cbxBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                cbxBackgroundMask += ", "
                            } else if (j === settings.cbxBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                cbxBackgroundMask += ")";
                            }
                        }
                    } else if (settings.cbxBackgroundMask[`${role}`].value[i].type === "radial") {
                        var sortedColors = [...settings.cbxBackgroundMask[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        cbxBackgroundMask += `radial-gradient(${settings.cbxBackgroundMask[`${role}`].value[i].size} at ${settings.cbxBackgroundMask[`${role}`].value[i].x}% ${settings.cbxBackgroundMask[`${role}`].value[i].y}%, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            cbxBackgroundMask += `#ffffff${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            
                            if (j < settings.cbxBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                cbxBackgroundMask += ", "
                            } else if (j === settings.cbxBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                cbxBackgroundMask += ")";
                            }
                        }
                    }

                    cbxBackgroundMaskPos += `calc(${settings.cbxBackgroundMask[`${role}`].value[i].posX.percent}% + ${settings.cbxBackgroundMask[`${role}`].value[i].posX.px}px) calc(${settings.cbxBackgroundMask[`${role}`].value[i].posY.percent}% + ${settings.cbxBackgroundMask[`${role}`].value[i].posY.px}px)`;
                    cbxBackgroundMaskSize += `calc(${settings.cbxBackgroundMask[`${role}`].value[i].width.percent}% + ${settings.cbxBackgroundMask[`${role}`].value[i].width.px}px) calc(${settings.cbxBackgroundMask[`${role}`].value[i].height.percent}% + ${settings.cbxBackgroundMask[`${role}`].value[i].height.px}px)`;

                    if (i < settings.cbxBackgroundMask[`${role}`].value.length - 1) {
                        cbxBackgroundMask += `, `;
                        cbxBackgroundMaskPos += `, `;
                        cbxBackgroundMaskSize += `, `;
                    }
                }
                
                cbxW.style.setProperty(`--cbxBackgroundMask`, cbxBackgroundMask);
                cbxW.style.setProperty(`--cbxBackgroundMaskPos`, cbxBackgroundMaskPos);
                cbxW.style.setProperty(`--cbxBackgroundMaskSize`, cbxBackgroundMaskSize);
            });
        }
    });
}

function updateColorSliderCbxMaskBox() {
    for (let i = 0; i < document.querySelectorAll(".colorSliderCbxMaskCont").length; i++) {
        if (settings.cbxBackgroundMask[`${activeRole}`].value[i].type !== "solid") {
            
            var cbxMaskPrev = "linear-gradient(90deg, ",
                nodeList = document.querySelectorAll(".colorSliderCbxMaskCont")[i].querySelectorAll(".colorSliderCbxMask"),
                colorList = settings.cbxBackgroundMask[`${activeRole}`].value[i].colors;

            for (let j = 0; j < settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                settings.cbxBackgroundMask[`${activeRole}`].value[i].colors[j].count = 0;
                colorList[j].position = parseFloat(nodeList[j].value);
                nodeList[j].style.setProperty("--value", `${nodeList[j].value}%`);
                nodeList[j].style.setProperty("--valueTxt", `"${nodeList[j].value}"`);
            }

            for (let j = 0; j < settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                for (let k = 0; k < settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.length; k++) {
                    if (k !== j) {
                        if (settings.cbxBackgroundMask[`${activeRole}`].value[i].colors[j].position >= settings.cbxBackgroundMask[`${activeRole}`].value[i].colors[k].position) {
                            settings.cbxBackgroundMask[`${activeRole}`].value[i].colors[j].count += 1;
                        }
                    }
                }
            }

            for (let j = 0; j < settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                var resultElmnt = settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.find(findElmnt => findElmnt.count === j);
                cbxMaskPrev += `#ffffff${dec2hex(resultElmnt.opacity)} ${resultElmnt.position}%`;
                
                if (j < settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.length - 1) {
                    cbxMaskPrev += ", ";
                } else {
                    cbxMaskPrev += ")";
                }
            }

            document.querySelectorAll(".colorSliderCbxMaskCont")[i].style.backgroundImage = cbxMaskPrev;
        } else {
            var cbxMaskPrev = `#ffffff${dec2hex(settings.cbxBackgroundMask[`${activeRole}`].value[i].colors[0].opacity)}`;
            document.querySelectorAll(".colorSliderCbxMaskCont")[i].style.backgroundColor = cbxMaskPrev;
        }
    }
    decompileCbxMask();
}

function openColorCbxMaskBox(grdNum, clrNum) {
    var open = true;

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });

    event.target.parentNode.setAttribute("data-color-show", open);
    
    activeCbxMaskGrad = grdNum;
    activeCbxMaskColor = clrNum;
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].setAttribute("data-color-show", "true");
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].setAttribute("data-set-show", "false");
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].setAttribute("data-size-show", "false");
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].querySelector(".colorChangeOpacity").value = settings.cbxBackgroundMask[`${activeRole}`].value[activeCbxMaskGrad].colors[activeCbxMaskColor].opacity;
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].querySelector(".colorChangeOpacity").setAttribute("data-value", settings.cbxBackgroundMask[`${activeRole}`].value[activeCbxMaskGrad].colors[activeCbxMaskColor].opacity);
    document.querySelectorAll(".colorSliderCbxMask").forEach(cbxCont => {
        cbxCont.setAttribute("data-active", "false");
    });
    document.querySelectorAll(".colorSliderCbxMaskCont")[activeCbxMaskGrad].querySelectorAll(".colorSliderCbxMask")[activeCbxMaskColor].setAttribute("data-active", "true");
}

function updateNameCbxMaskBox() {
    for (var i = 0; i < document.querySelectorAll(".backgroundNameCbxMask").length; i++) {
        settings.cbxBackgroundMask[`${activeRole}`].value[i].name = document.querySelectorAll(".backgroundNameCbxMask")[i].value;
    }
}

function updateColorCbxMaskBox(type) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    
    settings.cbxBackgroundMask[`${activeRole}`].value[activeCbxMaskGrad].colors[activeCbxMaskColor].opacity = parseInt(document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].querySelector(".colorChangeOpacity").value);
    updateColorSliderCbxMaskBox();

    decompileCbxMask();
}

function deleteColorCbxMaskBox() {
    settings.cbxBackgroundMask[`${activeRole}`].value[activeCbxMaskGrad].colors.splice(activeCbxMaskColor, 1);
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].querySelectorAll(".colorSliderCbxMask")[activeCbxMaskColor].remove();
    updateColorSliderCbxMaskBox();
    for (let i = 0; i < document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].querySelectorAll(".colorSliderCbxMask").length; i++) {
        document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].querySelectorAll(".colorSliderCbxMask")[i].setAttribute("onpointerdown", `openColorCbxMaskBox(${activeCbxMaskGrad}, ${i})`);
    }
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[activeCbxMaskGrad].setAttribute("data-color-show", "false");
    activeCbxMaskGrad = undefined;
    activeCbxMaskColor = undefined;

    for (let j = 0; j < settings.cbxBackgroundMask[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.cbxBackgroundMask[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorCbxMaskBox(${j}, ${k})`)
        }
    }

    decompileCbxMask();
}

function addColorSliderCbxMask(e) {
    i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    document.querySelectorAll(".colorSlider").forEach(slider => {
        slider.setAttribute("data-active", "false");
    })
    var newSlider = document.createElement("input");newSlider.className = "colorSlider colorSliderCbxMask";newSlider.setAttribute("oninput", "updateColorSliderCbxMaskBox()");newSlider.setAttribute("onpointerdown", `openColorCbxMaskBox(${i}, ${e.target.parentNode.querySelectorAll(".colorSlider").length})`);newSlider.type = "range";newSlider.value = (e.layerX / e.target.clientWidth) * 100;newSlider.min = "0";newSlider.max = "100";newSlider.step = "0.1";newSlider.setAttribute("data-active", "true");
                
    document.querySelectorAll(".colorSliderCbxMaskCont")[i].appendChild(newSlider);

    settings.cbxBackgroundMask[`${activeRole}`].value[i].colors.push({
        position: newSlider.value, // In %
        opacity: 255, // In Hex
        count: 0
    });
    updateColorSliderCbxMaskBox();
    openColorCbxMaskBox(i, e.target.parentNode.querySelectorAll(".colorSlider").length - 1);
    
    updateColorSliderCbxMaskBox();
    
    decompileCbxMask();
}

function hideColorCbxMaskBox() {
    document.querySelectorAll(".colorSliderCbxMaskCont")[activeCbxMaskGrad].querySelectorAll(".colorSliderCbxMask")[activeCbxMaskColor].setAttribute("data-active", "false");
    activeCbxMaskGrad = undefined;
    activeCbxMaskColor = undefined;
    event.target.parentNode.parentNode.setAttribute("data-color-show", "false");
}

function switchSetCbxMaskBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-set-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderCbxMask").forEach(cbxCont => {
        cbxCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-set-show", open);
}

function switchSizeCbxMaskBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-size-show") === "true") {
        open = false;
    }
    
    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderCbxMask").forEach(cbxCont => {
        cbxCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-size-show", open);
}

function addGradientCbxMask(type, index) {
    var indexPlace;
    if (index === undefined) {
        indexPlace = 0;
        if (type === "solid") {
            settings.cbxBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "solid",
                name: `Mask ${settings.cbxBackgroundMask[`${activeRole}`].value.length + 1}`,
                colors: [
                    {
                        position:0,
                        opacity:255,
                        count:0
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameCbxMask backgroundName" type="text" value="${settings.cbxBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameCbxMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientCbxMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderCbxMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderCbxMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderCbxMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Solid</div>
                            <div class="colorSliderAdd colorSliderCbxMaskAdd"></div>
                            <div class="colorSliderCont colorSliderCbxMaskCont" style="background-color:#ffffff;">
                                <input class="colorSlider colorSliderCbxMask" oninput="updateColorSliderCbxMaskBox()" onpointerdown="openColorCbxMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorCbxMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorCbxMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorCbxMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeCbxMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "linear") {
            settings.cbxBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "linear",
                name: `Mask ${settings.cbxBackgroundMask[`${activeRole}`].value.length + 1}`,
                rotate: 90, // In deg
                colors: [
                    {
                        position: 0, // In %
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameCbxMask backgroundName" type="text" value="${settings.cbxBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameCbxMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientCbxMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderCbxMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderCbxMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderCbxMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Linear</div>
                            <div class="colorSliderAdd colorSliderCbxMaskAdd" onclick="addColorSliderCbxMask(event)"></div>
                            <div class="colorSliderCont colorSliderCbxMaskCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderCbxMask" oninput="updateColorSliderCbxMaskBox()" onpointerdown="openColorCbxMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderCbxMask" oninput="updateColorSliderCbxMaskBox()" onpointerdown="openColorCbxMaskBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorCbxMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorCbxMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorCbxMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetCbxMaskBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">rotation:</span>
                                <input class="numContInput" type="number" value="90" oninput="updateLinearRotCbxMask(event)">
                                <span class="numContUnit">°</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeCbxMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "radial") {
            settings.cbxBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "radial",
                name: `Mask ${settings.cbxBackgroundMask[`${activeRole}`].value.length + 1}`,
                size: "farthest-corner", // farthest/closest - corner/side, circle
                x: 50, // In %
                y: 50, // In %
                colors: [
                    {
                        position: 0, // In %
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameCbxMask backgroundName" type="text" value="${settings.cbxBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameCbxMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientCbxMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderCbxMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderCbxMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderCbxMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Radial</div>
                            <div class="colorSliderAdd colorSliderCbxMaskAdd" onclick="addColorSliderCbxMask(event)"></div>
                            <div class="colorSliderCont colorSliderCbxMaskCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderCbxMask" oninput="updateColorSliderCbxMaskBox()" onpointerdown="openColorCbxMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderCbxMask" oninput="updateColorSliderCbxMaskBox()" onpointerdown="openColorCbxMaskBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorCbxMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorCbxMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorCbxMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetCbxMaskBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="singleChoiceList gradRadialPosContCbxMask">
                            <button data-active="true" onclick="updateRadialTypeCbxMask(event, 'farthest-corner')">Farthest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeCbxMask(event, 'farthest-side')">Farthest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeCbxMask(event, 'closest-corner')">Closest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeCbxMask(event, 'closest-side')">Closest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeCbxMask(event, 'circle')">Circle</button>
                        </div>
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">x:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosCbxMask(event, 'x')">
                                <span class="numContUnit">%</span>
                            </div>
                            <div class="numCont">
                                <span class="numContDescr">y:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosCbxMask(event, 'y')">
                                <span class="numContUnit">%</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeCbxMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateCbxMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateCbxMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateCbxMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        }
        document.querySelector(".colorMenuColCbxMask").insertBefore(colorMenu, document.querySelector(".colorMenuColCbxMask").children[indexPlace]);
    } else {
        indexPlace = index;

        var menuOpt = JSON.parse(JSON.stringify(settings.cbxBackgroundMask[`${activeRole}`].value[indexPlace]));
        settings.cbxBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, menuOpt);

        var colorMenuNode = document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[indexPlace].cloneNode(true);
        colorMenuNode.setAttribute("data-color-show", "false");
        colorMenuNode.setAttribute("data-set-show", "false");
        colorMenuNode.setAttribute("data-size-show", "false");
        document.querySelector(".colorMenuColCbxMask").insertBefore(colorMenuNode, document.querySelector(".colorMenuColCbxMask").children[indexPlace]);
    }
    
    for (var i = 0; i < document.querySelectorAll(".colorSliderCbxMaskCont").length; i++) {
        for (var j = 0; j < document.querySelectorAll(".colorSliderCbxMaskCont")[i].querySelectorAll(".colorSlider").length; j++) {
            document.querySelectorAll(".colorSliderCbxMaskCont")[i].querySelectorAll(".colorSlider")[j].setAttribute("onpointerdown", `openColorCbxMaskBox(${i}, ${j})`);
        }
    }
    
    updateColorSliderCbxMaskBox();
    decompileCbxMask();
}

function removeGradientCbxMask(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode);
    if (i < activeCbxMaskGrad) {
        activeCbxMaskGrad -= 1;
    }
    settings.cbxBackgroundMask[`${activeRole}`].value.splice(i, 1);
    document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[i].remove();
    for (let j = 0; j < document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu").length; j++) {
        for (let k = 0; k < document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider").length; k++) {
            document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorCbxMaskBox(${j}, ${k})`)
        }
    }
    
    decompileCbxMask();
}

function updateRadialTypeCbxMask(e, size) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    settings.cbxBackgroundMask[`${activeRole}`].value[i].size = size;
    for (let j = 0; j < settings.cbxBackgroundMask[`${activeRole}`].value.length; j++) {
        if (settings.cbxBackgroundMask[`${activeRole}`].value[j].type === "radial") {
            for (let k = 0; k < document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContCbxMask").querySelectorAll("button").length; k++) {
                document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContCbxMask").querySelectorAll("button")[k].setAttribute("data-active", "false");
            }
            e.target.setAttribute("data-active", "true");
        }
    }
    
    decompileCbxMask();
}

function updateLinearRotCbxMask(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    settings.cbxBackgroundMask[`${activeRole}`].value[i].rotate = parseInt(e.target.value);
    
    decompileCbxMask();
}

function updateRadialPosCbxMask(e, xy) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    if (xy === "x") {
        settings.cbxBackgroundMask[`${activeRole}`].value[i].x = parseInt(e.target.value);
    } else if (xy === "y") {
        settings.cbxBackgroundMask[`${activeRole}`].value[i].y = parseInt(e.target.value);
    }
    
    decompileCbxMask();
}

function moveColorSliderCbxMask(e, dir) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    if (dir === "up" && i > 0) {
        var elmnt = settings.cbxBackgroundMask[`${activeRole}`].value[i];
        settings.cbxBackgroundMask[`${activeRole}`].value.splice(i, 1);
        settings.cbxBackgroundMask[`${activeRole}`].value.splice(i - 1, 0, elmnt);
        document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[i - 1].before(document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[i]);
        if (activeCbxMaskGrad === i) {
            activeCbxMaskGrad -= 1;
        } else if (activeCbxMaskGrad === i - 1) {
            activeCbxMaskGrad += 1;
        }
    } else if (dir === "down" && i < settings.cbxBackgroundMask[`${activeRole}`].value.length - 1) {
        var elmnt = settings.cbxBackgroundMask[`${activeRole}`].value[i];
        settings.cbxBackgroundMask[`${activeRole}`].value.splice(i, 1);
        settings.cbxBackgroundMask[`${activeRole}`].value.splice(i + 1, 0, elmnt);
        document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[i + 1].after(document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[i]);
        if (activeCbxMaskGrad === i) {
            activeCbxMaskGrad += 1;
        } else if (activeCbxMaskGrad === i + 1) {
            activeCbxMaskGrad -= 1;
        }
    }

    for (let j = 0; j < settings.cbxBackgroundMask[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.cbxBackgroundMask[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColCbxMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorCbxMaskBox(${j}, ${k})`)
        }
    }
    
    decompileCbxMask();
}

function duplicateColorSliderCbxMask() {
    activeCbxMaskGrad += 1;
    var i = Array.from(event.target.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode);
    var type = settings.cbxBackgroundMask[`${activeRole}`].value[i].type;

    addGradientCbxMask(type, i);
}

function updateCbxMaskSizePos(cat, value) {
    var i = Array.from(event.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode.parentNode);
    if (cat === "posX") {
        if (value === "%") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].posX.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].posX.px = parseInt(event.target.value);
        }
    } else if (cat === "posY") {
        if (value === "%") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].posY.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].posY.px = parseInt(event.target.value);
        }
    } else if (cat === "width") {
        if (value === "%") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].width.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].width.px = parseInt(event.target.value);
        }
    } else if (cat === "height") {
        if (value === "%") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].height.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.cbxBackgroundMask[`${activeRole}`].value[i].height.px = parseInt(event.target.value);
        }
    }
    
    decompileCbxMask();
}

// settings.cbxBorder

function decompileCbxBorder() {
    roleList.forEach(role => {
        if (settings.cbxBorder[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                if (settings.cbxBorder[`${role}`].value.top.color.type === "custom") {
                    cbxW.style.setProperty(`--cbxBorderTop`, `${settings.cbxBorder[`${role}`].value.top.type} ${settings.cbxBorder[`${role}`].value.top.width}px ${settings.cbxBorder[`${role}`].value.top.color.color}${dec2hex(settings.cbxBorder[`${role}`].value.top.color.opacity)}`);
                } else if (settings.cbxBorder[`${role}`].value.top.color.type === "twitch") {
                    cbxW.style.setProperty(`--cbxBorderTop`, `${settings.cbxBorder[`${role}`].value.top.type} ${settings.cbxBorder[`${role}`].value.top.width}px ${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxBorder[`${role}`].value.top.color.opacity)}`);
                }

                if (settings.cbxBorder[`${role}`].value.right.color.type === "custom") {
                    cbxW.style.setProperty(`--cbxBorderRight`, `${settings.cbxBorder[`${role}`].value.right.type} ${settings.cbxBorder[`${role}`].value.right.width}px ${settings.cbxBorder[`${role}`].value.right.color.color}${dec2hex(settings.cbxBorder[`${role}`].value.right.color.opacity)}`);
                } else if (settings.cbxBorder[`${role}`].value.right.color.type === "twitch") {
                    cbxW.style.setProperty(`--cbxBorderRight`, `${settings.cbxBorder[`${role}`].value.right.type} ${settings.cbxBorder[`${role}`].value.right.width}px ${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxBorder[`${role}`].value.right.color.opacity)}`);
                }

                if (settings.cbxBorder[`${role}`].value.bottom.color.type === "custom") {
                    cbxW.style.setProperty(`--cbxBorderBottom`, `${settings.cbxBorder[`${role}`].value.bottom.type} ${settings.cbxBorder[`${role}`].value.bottom.width}px ${settings.cbxBorder[`${role}`].value.bottom.color.color}${dec2hex(settings.cbxBorder[`${role}`].value.bottom.color.opacity)}`);
                } else if (settings.cbxBorder[`${role}`].value.bottom.color.type === "twitch") {
                    cbxW.style.setProperty(`--cbxBorderBottom`, `${settings.cbxBorder[`${role}`].value.bottom.type} ${settings.cbxBorder[`${role}`].value.bottom.width}px ${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxBorder[`${role}`].value.bottom.color.opacity)}`);
                }

                if (settings.cbxBorder[`${role}`].value.left.color.type === "custom") {
                    cbxW.style.setProperty(`--cbxBorderLeft`, `${settings.cbxBorder[`${role}`].value.left.type} ${settings.cbxBorder[`${role}`].value.left.width}px ${settings.cbxBorder[`${role}`].value.left.color.color}${dec2hex(settings.cbxBorder[`${role}`].value.left.color.opacity)}`);
                } else if (settings.cbxBorder[`${role}`].value.left.color.type === "twitch") {
                    cbxW.style.setProperty(`--cbxBorderLeft`, `${settings.cbxBorder[`${role}`].value.left.type} ${settings.cbxBorder[`${role}`].value.left.width}px ${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxBorder[`${role}`].value.left.color.opacity)}`);
                }
            });
        }
    });
}

var activeCbxBorder = ""

function openBorderMenuCbx(pos) {
    document.querySelector("#borderGridCbx").querySelectorAll(".borderSelect").forEach(elmnt => {
        elmnt.setAttribute("data-active", "false");
    });

    event.target.setAttribute("data-active", "true");

    var borderMenu = event.target.parentNode.parentNode.parentNode.querySelector(".borderEdgeMenu"),
        cornerMenu = event.target.parentNode.parentNode.parentNode.querySelector(".borderCornerMenu");
    activeCbxBorder = pos;
    if (activeCbxBorder === "top" || activeCbxBorder === "bottom" || activeCbxBorder === "left" || activeCbxBorder === "right") {
        borderMenu.setAttribute("data-active", "true");
        cornerMenu.setAttribute("data-active", "false");

        borderMenu.querySelectorAll(".borderTypeBtn").forEach(elmnt => {
            elmnt.setAttribute("data-active", "false")
        });

        if (settings.cbxBorder[`${activeRole}`].value[`${pos}`].color.type === "custom") {
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
        } else if (settings.cbxBorder[`${activeRole}`].value[`${pos}`].color.type === "twitch") {
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
        }

        borderMenu.querySelector(`.borderTypeBtn[data-type="${settings.cbxBorder[`${activeRole}`].value[`${pos}`].type}"]`).setAttribute("data-active", "true");
        borderMenu.querySelector(".borderWidthCont").querySelector(".inputNumBig").value = settings.cbxBorder[`${activeRole}`].value[`${pos}`].width;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeInput").value = settings.cbxBorder[`${activeRole}`].value[`${pos}`].color.color;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").value = settings.cbxBorder[`${activeRole}`].value[`${pos}`].color.opacity;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").setAttribute("data-value", borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").value);
        
    } else if (activeCbxBorder === "tl" || activeCbxBorder === "tr" || activeCbxBorder === "bl" || activeCbxBorder === "br") {
        cornerMenu.setAttribute("data-active", "true");
        borderMenu.setAttribute("data-active", "false");

        cornerMenu.querySelector(".inputNumBig").value = settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`];
    }
}

function updateBorderCbx(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    if (type === "type") {
        Array.from(event.target.parentNode.parentNode.children).forEach(elmnt => {
            elmnt.setAttribute("data-active", "false");
        });
        event.target.parentNode.setAttribute("data-active", "true");
        settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].type = value;
    } else if (type === "width") {
        settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].width = parseInt(document.querySelector("#cbxBorderWidth").value);
    } else if (type === "color") {
        settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.color = document.querySelector("#cbxBorderColor").value;
    } else if (type === "colorType") {
        settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.type = value;
        if (value === "custom") {
            document.querySelector(".borderEdgeMenuCbx").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".borderEdgeMenuCbx").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".borderEdgeMenuCbx").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".borderEdgeMenuCbx").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "opacity") {
        settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.opacity = parseInt(document.querySelector("#cbxBorderOpacity").value);
    } else if (type === "all") {
        settings.cbxBorder[`${activeRole}`].value["top"].type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].type;
        settings.cbxBorder[`${activeRole}`].value["bottom"].type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].type;
        settings.cbxBorder[`${activeRole}`].value["left"].type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].type;
        settings.cbxBorder[`${activeRole}`].value["right"].type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].type;

        settings.cbxBorder[`${activeRole}`].value["top"].width = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].width;
        settings.cbxBorder[`${activeRole}`].value["bottom"].width = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].width;
        settings.cbxBorder[`${activeRole}`].value["left"].width = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].width;
        settings.cbxBorder[`${activeRole}`].value["right"].width = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].width;
        
        settings.cbxBorder[`${activeRole}`].value["top"].color.color = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.color;
        settings.cbxBorder[`${activeRole}`].value["bottom"].color.color = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.color;
        settings.cbxBorder[`${activeRole}`].value["left"].color.color = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.color;
        settings.cbxBorder[`${activeRole}`].value["right"].color.color = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.color;

        settings.cbxBorder[`${activeRole}`].value["top"].color.type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.type;
        settings.cbxBorder[`${activeRole}`].value["bottom"].color.type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.type;
        settings.cbxBorder[`${activeRole}`].value["left"].color.type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.type;
        settings.cbxBorder[`${activeRole}`].value["right"].color.type = "" + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.type;

        settings.cbxBorder[`${activeRole}`].value["top"].color.opacity = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.opacity
        settings.cbxBorder[`${activeRole}`].value["bottom"].color.opacity = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.opacity
        settings.cbxBorder[`${activeRole}`].value["left"].color.opacity = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.opacity
        settings.cbxBorder[`${activeRole}`].value["right"].color.opacity = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`].color.opacity
    }

    decompileCbxBorder();
}

function decompileCbxBorderRadius() {
    roleList.forEach(role => {
        if (settings.cbxBorder[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                cbxW.style.setProperty(`--cbxBRtl`, `${settings.cbxBorder[`${role}`].value.tl}px`);
                cbxW.style.setProperty(`--cbxBRtr`, `${settings.cbxBorder[`${role}`].value.tr}px`);
                cbxW.style.setProperty(`--cbxBRbr`, `${settings.cbxBorder[`${role}`].value.br}px`);
                cbxW.style.setProperty(`--cbxBRbl`, `${settings.cbxBorder[`${role}`].value.bl}px`);
            });
        }
    });
}

function updateCornerCbx(type) {
    if (type === "corner") {
        settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`] = parseInt(document.querySelector("#cbxCornerRadius").value);
    } else if (type === "all") {
        settings.cbxBorder[`${activeRole}`].value["tl"] = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`];
        settings.cbxBorder[`${activeRole}`].value["tr"] = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`];
        settings.cbxBorder[`${activeRole}`].value["bl"] = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`];
        settings.cbxBorder[`${activeRole}`].value["br"] = 0 + settings.cbxBorder[`${activeRole}`].value[`${activeCbxBorder}`];
    }

    decompileCbxBorderRadius();
}

// settings.cbxShadow

function decompileCbxShadow() {
    roleList.forEach(role => {
        if (settings.cbxShadow[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var cbxShadow = "";

                for (let i = 0; i < settings.cbxShadow[`${role}`].value.length; i++) {
                    cbxShadow += `${settings.cbxShadow[`${role}`].value[i].x}px ${settings.cbxShadow[`${role}`].value[i].y}px ${settings.cbxShadow[`${role}`].value[i].blur}px ${settings.cbxShadow[`${role}`].value[i].expand}px `;
                    if (settings.cbxShadow[`${role}`].value[i].color.type === "custom") {
                        cbxShadow += `${settings.cbxShadow[`${role}`].value[i].color.color}${dec2hex(settings.cbxShadow[`${role}`].value[i].color.opacity)}`;
                    } else if (settings.cbxShadow[`${role}`].value[i].color.type === "twitch") {
                        cbxShadow += `${cbxW.getAttribute("data-twitch")}${dec2hex(settings.cbxShadow[`${role}`].value[i].color.opacity)}`;
                    }
                    if (settings.cbxShadow[`${role}`].value[i].inset === true) {
                        cbxShadow += " inset";
                    }
                    if (i < settings.cbxShadow[`${role}`].value.length - 1) {
                        cbxShadow += ", ";
                    }
                }

                cbxW.style.setProperty(`--cbxBS`, cbxShadow);
            });
        }
    });
}

var activeCbxShadow = -1;

function openShadowCbx(triggerAdd) {
    for (let i = 0; i < settings.cbxShadow[`${activeRole}`].value.length; i++) {
        document.querySelector(".shadowColCbx").querySelectorAll(".shadowElmnt")[i].setAttribute("data-active", "false");
    }
    
    if (!triggerAdd) {
        activeCbxShadow = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);
    }
    
    if (activeCbxShadow >= 0) {
        document.querySelector(".shadowSettingsCbx").setAttribute("data-active", "true");
        document.querySelector(".shadowColCbx").querySelectorAll(".shadowElmnt")[activeCbxShadow].setAttribute("data-active", "true");
        
        
        document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[0].value = settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].x;
        document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[1].value = settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].y;
        document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[2].value = settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].blur;
        document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[3].value = settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].expand;
        document.querySelector(".shadowSettingsCbx").querySelector(".cbxShadowInset").setAttribute("data-active", settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].inset);
        
        if (settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.type === "custom") {
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.type === "twitch") {
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
        
        document.querySelector("#cbxShadowOpacity").value = settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.opacity;
        document.querySelector("#cbxShadowOpacity").setAttribute("data-value", settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.opacity);
        
        document.querySelector("#cbxShadowColor").value = settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.color;
    } else if (activeCbxShadow === -1) {
        document.querySelector(".shadowSettingsCbx").setAttribute("data-active", "false");
    }
}

function addShadowCbx() {
    var shadowElmnt = document.createElement("div");
        shadowElmnt.className = "shadowElmnt";

        shadowElmnt.innerHTML = `
            <button class="shadowElmntBtn" onclick="openShadowCbx()"></button>
            <button class="shadowElmntRmv icon" onclick="removeShadowCbx()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
        `;

    document.querySelector(".shadowColCbx").appendChild(shadowElmnt);

    settings.cbxShadow[`${activeRole}`].value.push({
        x: 0, // In px
        y: 0, // In px
        blur: 0, // In px
        expand: 0, // In px
        color: {
            type: "custom",
            color: "#000000",
            opacity: 255 // In Hex
        },
        inset: false
    });

    activeCbxShadow = settings.cbxShadow[`${activeRole}`].value.length - 1;
    openShadowCbx(true);
    
    decompileCbxShadow();
}

function updateShadowCbx(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].x    = parseInt(document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[0].value);
    settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].y    = parseInt(document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[1].value);
    settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].blur    = parseInt(document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[2].value);
    settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].expand  = parseInt(document.querySelector(".shadowSettingsCbx").querySelectorAll(".numContInput")[3].value);
    
    settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.opacity = parseInt(document.querySelector("#cbxShadowOpacity").value);
    document.querySelector("#cbxShadowOpacity").setAttribute("data-value", document.querySelector("#cbxShadowOpacity").value);
    
    if (document.querySelector(".shadowSettingsCbx").querySelector(".cbxShadowInset").getAttribute("data-active") === "false") {
        settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].inset = false;
    } else {
        settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].inset = true;
    }

    if (type === "colorType") {
        settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.type = value;
        if (value === "custom") {
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsCbx").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "color") {
        settings.cbxShadow[`${activeRole}`].value[activeCbxShadow].color.color = document.querySelector("#cbxShadowColor").value;
    }

    for (let i = 0; i < settings.cbxShadow[`${activeRole}`].value.length; i++) {
        var cbxStyle = `${settings.cbxShadow[`${activeRole}`].value[i].x}px ${settings.cbxShadow[`${activeRole}`].value[i].y}px ${settings.cbxShadow[`${activeRole}`].value[i].blur}px ${settings.cbxShadow[`${activeRole}`].value[i].expand}px ${settings.cbxShadow[`${activeRole}`].value[i].color.color}${dec2hex(settings.cbxShadow[`${activeRole}`].value[i].color.opacity)}`;
        if (settings.cbxShadow[`${activeRole}`].value[i].inset === true) {
            cbxStyle += " inset";
        }

        document.querySelector(".shadowColCbx").querySelectorAll(".shadowElmnt")[i].style.boxShadow = cbxStyle;
    }
    
    decompileCbxShadow();
}

function removeSwitchShadowCbx() {
    if (document.querySelector(".shadowColCbx").getAttribute("data-delete-active") === "false") {
        document.querySelector(".shadowColCbx").setAttribute("data-delete-active", "true");
    } else {
        document.querySelector(".shadowColCbx").setAttribute("data-delete-active", "false");
    }
    
    decompileCbxShadow();
}

function removeShadowCbx() {
    var i = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);

    if (i <= activeCbxShadow) {
        activeCbxShadow -= 1;
    }
    settings.cbxShadow[`${activeRole}`].value.splice(i, 1);

    document.querySelector(".shadowColCbx").querySelectorAll(".shadowElmnt")[i].remove();

    openShadowCbx(true);
    
    decompileCbxShadow();
}

// settings.cbxSpacing

function decompileCbxSpacing() {
    roleList.forEach(role => {
        if (settings.cbxPosition[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                cbxW.style.setProperty(`--cbxSpacingOT`, `${settings.cbxPosition[`${role}`].value.spacing.outer.top}px`);
                cbxW.style.setProperty(`--cbxSpacingOR`, `${settings.cbxPosition[`${role}`].value.spacing.outer.right}px`);
                cbxW.style.setProperty(`--cbxSpacingOB`, `${settings.cbxPosition[`${role}`].value.spacing.outer.bottom}px`);
                cbxW.style.setProperty(`--cbxSpacingOL`, `${settings.cbxPosition[`${role}`].value.spacing.outer.left}px`);

                cbxW.style.setProperty(`--cbxSpacingIT`, `${settings.cbxPosition[`${role}`].value.spacing.inner.top}px`);
                cbxW.style.setProperty(`--cbxSpacingIR`, `${settings.cbxPosition[`${role}`].value.spacing.inner.right}px`);
                cbxW.style.setProperty(`--cbxSpacingIB`, `${settings.cbxPosition[`${role}`].value.spacing.inner.bottom}px`);
                cbxW.style.setProperty(`--cbxSpacingIL`, `${settings.cbxPosition[`${role}`].value.spacing.inner.left}px`);
            });
        }
    });
}

function updateCbxSpacing(pos) {
    if (pos === "OT") {
        settings.cbxPosition[`${activeRole}`].value.spacing.outer.top = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridOuter")[0].value);
    } else if (pos === "OL") {
        settings.cbxPosition[`${activeRole}`].value.spacing.outer.left = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridOuter")[1].value);
    } else if (pos === "OR") {
        settings.cbxPosition[`${activeRole}`].value.spacing.outer.right = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridOuter")[2].value);
    } else if (pos === "OB") {
        settings.cbxPosition[`${activeRole}`].value.spacing.outer.bottom = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridOuter")[3].value);
    } else if (pos === "IT") {
        settings.cbxPosition[`${activeRole}`].value.spacing.inner.top = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridInner")[0].value);
    } else if (pos === "IL") {
        settings.cbxPosition[`${activeRole}`].value.spacing.inner.left = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridInner")[1].value);
    } else if (pos === "IR") {
        settings.cbxPosition[`${activeRole}`].value.spacing.inner.right = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridInner")[2].value);
    } else if (pos === "IB") {
        settings.cbxPosition[`${activeRole}`].value.spacing.inner.bottom = parseInt(document.querySelector(".spacingGridCbx").querySelectorAll(".spacingGridInner")[3].value);
    }

    decompileCbxSpacing();
}

// settings.cbxSizing

function decompileCbxSizing() {
    roleList.forEach(role => {
        if (settings.cbxPosition[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                cbxW.style.setProperty(`--cbxSizing`, settings.cbxPosition[`${role}`].value.sizing);
            });
        }
    });
}

function updateCbxSizing(type) {
    if (type === "stretch") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-start") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "center") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-end") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "true");
    }
    
    settings.cbxPosition[`${activeRole}`].value.sizing = type;

    decompileCbxSizing();
}

// settings.usnBackground

function decompileUsnBG() {
    roleList.forEach(role => {
        if (settings.usnBackground[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                var usnBackground = "",
                    usnBackgroundPos = "",
                    usnBackgroundSize = "";
                for (let i = 0; i < settings.usnBackground[`${role}`].value.length; i++) {
                    if (settings.usnBackground[`${role}`].value[i].type === "solid") {
                        if (settings.usnBackground[`${role}`].value[i].colors[0].type === "custom") {
                            usnBackground += `linear-gradient(${settings.usnBackground[`${role}`].value[i].colors[0].color}${dec2hex(settings.usnBackground[`${role}`].value[i].colors[0].opacity)}, ${settings.usnBackground[`${role}`].value[i].colors[0].color}${dec2hex(settings.usnBackground[`${role}`].value[i].colors[0].opacity)})`;
                        } else if (settings.usnBackground[`${role}`].value[i].colors[0].type === "twitch") {
                            usnBackground += `linear-gradient(${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnBackground[`${role}`].value[i].colors[0].opacity)}, ${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnBackground[`${role}`].value[i].colors[0].opacity)})`;
                        }
                    } else if (settings.usnBackground[`${role}`].value[i].type === "linear") {
                        var sortedColors = [...settings.usnBackground[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        usnBackground += `linear-gradient(${settings.usnBackground[`${role}`].value[i].rotate}deg, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            if (sortedColors[j].type === "custom") {
                                usnBackground += `${sortedColors[j].color}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            } else if (sortedColors[j].type === "twitch") {
                                usnBackground += `${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`
                            }
                            
                            if (j < settings.usnBackground[`${role}`].value[i].colors.length - 1) {
                                usnBackground += ", "
                            } else if (j === settings.usnBackground[`${role}`].value[i].colors.length - 1) {
                                usnBackground += ")";
                            }
                        }
                    } else if (settings.usnBackground[`${role}`].value[i].type === "radial") {
                        var sortedColors = [...settings.usnBackground[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        usnBackground += `radial-gradient(${settings.usnBackground[`${role}`].value[i].size} at ${settings.usnBackground[`${role}`].value[i].x}% ${settings.usnBackground[`${role}`].value[i].y}%, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            if (sortedColors[j].type === "custom") {
                                usnBackground += `${sortedColors[j].color}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            } else if (sortedColors[j].type === "twitch") {
                                usnBackground += `${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`
                            }
                            
                            if (j < settings.usnBackground[`${role}`].value[i].colors.length - 1) {
                                usnBackground += ", "
                            } else if (j === settings.usnBackground[`${role}`].value[i].colors.length - 1) {
                                usnBackground += ")";
                            }
                        }
                    }

                    usnBackgroundPos += `calc(${settings.usnBackground[`${role}`].value[i].posX.percent}% + ${settings.usnBackground[`${role}`].value[i].posX.px}px) calc(${settings.usnBackground[`${role}`].value[i].posY.percent}% + ${settings.usnBackground[`${role}`].value[i].posY.px}px)`;
                    usnBackgroundSize += `calc(${settings.usnBackground[`${role}`].value[i].width.percent}% + ${settings.usnBackground[`${role}`].value[i].width.px}px) calc(${settings.usnBackground[`${role}`].value[i].height.percent}% + ${settings.usnBackground[`${role}`].value[i].height.px}px)`;

                    if (i < settings.usnBackground[`${role}`].value.length - 1) {
                        usnBackground += `, `;
                        usnBackgroundPos += `, `;
                        usnBackgroundSize += `, `;
                    }
                }
                
                cbxW.style.setProperty(`--usnBackground`, usnBackground);
                cbxW.style.setProperty(`--usnBackgroundPos`, usnBackgroundPos);
                cbxW.style.setProperty(`--usnBackgroundSize`, usnBackgroundSize);
            });
        }
    });
}

function updateColorSliderUsnBGBox() {
    for (let i = 0; i < document.querySelectorAll(".colorSliderUsnBGCont").length; i++) {
        if (settings.usnBackground[`${activeRole}`].value[i].type !== "solid") {
            
            var usnBGPrev = "linear-gradient(90deg, ",
                nodeList = document.querySelectorAll(".colorSliderUsnBGCont")[i].querySelectorAll(".colorSliderUsnBG"),
                colorList = settings.usnBackground[`${activeRole}`].value[i].colors;

            for (let j = 0; j < settings.usnBackground[`${activeRole}`].value[i].colors.length; j++) {
                settings.usnBackground[`${activeRole}`].value[i].colors[j].count = 0;
                colorList[j].position = parseFloat(nodeList[j].value);
                nodeList[j].style.setProperty("--value", `${nodeList[j].value}%`);
                nodeList[j].style.setProperty("--valueTxt", `"${nodeList[j].value}"`);
            }

            for (let j = 0; j < settings.usnBackground[`${activeRole}`].value[i].colors.length; j++) {
                for (let k = 0; k < settings.usnBackground[`${activeRole}`].value[i].colors.length; k++) {
                    if (k !== j) {
                        if (settings.usnBackground[`${activeRole}`].value[i].colors[j].position >= settings.usnBackground[`${activeRole}`].value[i].colors[k].position) {
                            settings.usnBackground[`${activeRole}`].value[i].colors[j].count += 1;
                        }
                    }
                }
            }

            for (let j = 0; j < settings.usnBackground[`${activeRole}`].value[i].colors.length; j++) {
                var resultElmnt = settings.usnBackground[`${activeRole}`].value[i].colors.find(findElmnt => findElmnt.count === j);
                usnBGPrev += `${resultElmnt.color}${dec2hex(resultElmnt.opacity)} ${resultElmnt.position}%`;
                
                if (j < settings.usnBackground[`${activeRole}`].value[i].colors.length - 1) {
                    usnBGPrev += ", ";
                } else {
                    usnBGPrev += ")";
                }
            }

            document.querySelectorAll(".colorSliderUsnBGCont")[i].style.backgroundImage = usnBGPrev;
        } else {
            var usnBGPrev = `${settings.usnBackground[`${activeRole}`].value[i].colors[0].color}${dec2hex(settings.usnBackground[`${activeRole}`].value[i].colors[0].opacity)}`;
            document.querySelectorAll(".colorSliderUsnBGCont")[i].style.backgroundColor = usnBGPrev;
        }
    }
    decompileUsnBG();
}

var activeUsnBGGrad = 0;
var activeUsnBGColor = 0;

function openColorUsnBGBox(grdNum, clrNum) {
    var open = true;

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });

    event.target.parentNode.setAttribute("data-color-show", open);

    activeUsnBGGrad = grdNum;
    activeUsnBGColor = clrNum;
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].setAttribute("data-color-show", "true");
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].setAttribute("data-set-show", "false");
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].setAttribute("data-size-show", "false");
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeInput").value = settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].color;
    if (settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].type === "custom") {
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
    } else if (settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].type === "twitch") {
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
    }
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeOpacity").value = settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].opacity;
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeOpacity").setAttribute("data-value", settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].opacity);
    document.querySelectorAll(".colorSliderUsnBG").forEach(usnCont => {
        usnCont.setAttribute("data-active", "false");
    });
    document.querySelectorAll(".colorSliderUsnBGCont")[activeUsnBGGrad].querySelectorAll(".colorSliderUsnBG")[activeUsnBGColor].setAttribute("data-active", "true");
}

function updateNameUsnBGBox() {
    for (var i = 0; i < document.querySelectorAll(".backgroundNameUsnBG").length; i++) {
        settings.usnBackground[`${activeRole}`].value[i].name = document.querySelectorAll(".backgroundNameUsnBG")[i].value;
    }
}

function updateColorUsnBGBox(type) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    if (type) {settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].type = type;}
    
    if (type === "custom") {
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");

    } else if (type === "twitch") {
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
    }
    settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].color = document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeInput").value;
    settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors[activeUsnBGColor].opacity = parseInt(document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelector(".colorChangeOpacity").value);
    updateColorSliderUsnBGBox();

    decompileUsnBG();
}

function deleteColorUsnBGBox() {
    settings.usnBackground[`${activeRole}`].value[activeUsnBGGrad].colors.splice(activeUsnBGColor, 1);
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelectorAll(".colorSliderUsnBG")[activeUsnBGColor].remove();
    updateColorSliderUsnBGBox();
    for (let i = 0; i < document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelectorAll(".colorSliderUsnBG").length; i++) {
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].querySelectorAll(".colorSliderUsnBG")[i].setAttribute("onpointerdown", `openColorUsnBGBox(${activeUsnBGGrad}, ${i})`);
    }
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[activeUsnBGGrad].setAttribute("data-color-show", "false");
    activeUsnBGGrad = undefined;
    activeUsnBGColor = undefined;

    for (let j = 0; j < settings.usnBackground[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.usnBackground[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorUsnBGBox(${j}, ${k})`)
        }
    }

    decompileUsnBG();
}

function addColorSliderUsnBG(e) {
    i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    var newSlider = document.createElement("input");newSlider.className = "colorSlider colorSliderUsnBG";newSlider.setAttribute("oninput", "updateColorSliderUsnBGBox()");newSlider.setAttribute("onpointerdown", `openColorUsnBGBox(${i}, ${e.target.parentNode.querySelectorAll(".colorSlider").length})`);newSlider.type = "range";newSlider.value = (e.layerX / e.target.clientWidth) * 100;newSlider.min = "0";newSlider.max = "100";newSlider.step = "0.1";newSlider.setAttribute("data-active", "true");
                
    document.querySelectorAll(".colorSliderUsnBGCont")[i].appendChild(newSlider);

    settings.usnBackground[`${activeRole}`].value[i].colors.push({
        position: newSlider.value, // In %
        type: "custom",
        color: "#ffffff",
        opacity: 255, // In Hex
        count: 0
    });
    updateColorSliderUsnBGBox();
    openColorUsnBGBox(i, e.target.parentNode.querySelectorAll(".colorSlider").length - 1);
    
    updateColorSliderUsnBGBox();

    decompileUsnBG();
}

function hideColorUsnBGBox() {
    document.querySelectorAll(".colorSliderUsnBGCont")[activeUsnBGGrad].querySelectorAll(".colorSliderUsnBG")[activeUsnBGColor].setAttribute("data-active", "false");
    activeUsnBGGrad = undefined;
    activeUsnBGColor = undefined;
    event.target.parentNode.parentNode.setAttribute("data-color-show", "false");
}

function switchSetUsnBGBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-set-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderUsnBG").forEach(usnCont => {
        usnCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-set-show", open);
}

function switchSizeUsnBGBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-size-show") === "true") {
        open = false;
    }
    
    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderUsnBG").forEach(usnCont => {
        usnCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-size-show", open);
}

function addGradientUsnBG(type, index) {
    var indexPlace;
    if (index === undefined) {
        indexPlace = 0;
        if (type === "solid") {
            settings.usnBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "solid",
                name: `Background ${settings.usnBackground[`${activeRole}`].value.length + 1}`,
                colors: [
                    {
                        position:0,
                        type: "custom",
                        color:"#ffffff",
                        opacity:255,
                        count:0
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameUsnBG backgroundName" type="text" value="${settings.usnBackground[`${activeRole}`].value[0].name}" oninput="updateNameUsnBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientUsnBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderUsnBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderUsnBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderUsnBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Solid</div>
                            <div class="colorSliderAdd colorSliderUsnBGAdd"></div>
                            <div class="colorSliderCont colorSliderUsnBGCont" style="background-color:#ffffff;">
                                <input class="colorSlider colorSliderUsnBG" oninput="updateColorSliderUsnBGBox()" onpointerdown="openColorUsnBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorUsnBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorUsnBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorUsnBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorUsnBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorUsnBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorUsnBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeUsnBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "linear") {
            settings.usnBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "linear",
                name: `Background ${settings.usnBackground[`${activeRole}`].value.length + 1}`,
                rotate: 90, // In deg
                colors: [
                    {
                        position: 0, // In %
                        type: "custom",
                        color: "#000000",
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        type: "custom",
                        color: "#ffffff",
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameUsnBG backgroundName" type="text" value="${settings.usnBackground[`${activeRole}`].value[0].name}" oninput="updateNameUsnBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientUsnBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderUsnBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderUsnBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderUsnBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Linear</div>
                            <div class="colorSliderAdd colorSliderUsnBGAdd" onclick="addColorSliderUsnBG(event)"></div>
                            <div class="colorSliderCont colorSliderUsnBGCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderUsnBG" oninput="updateColorSliderUsnBGBox()" onpointerdown="openColorUsnBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderUsnBG" oninput="updateColorSliderUsnBGBox()" onpointerdown="openColorUsnBGBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorUsnBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorUsnBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorUsnBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorUsnBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorUsnBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorUsnBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetUsnBGBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">rotation:</span>
                                <input class="numContInput" type="number" value="90" oninput="updateLinearRotUsnBG(event)">
                                <span class="numContUnit">°</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeUsnBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "radial") {
            settings.usnBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "radial",
                name: `Background ${settings.usnBackground[`${activeRole}`].value.length + 1}`,
                size: "farthest-corner", // farthest/closest - corner/side, circle
                x: 50, // In %
                y: 50, // In %
                colors: [
                    {
                        position: 0, // In %
                        type: "custom",
                        color: "#000000",
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        type: "custom",
                        color: "#ffffff",
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameUsnBG backgroundName" type="text" value="${settings.usnBackground[`${activeRole}`].value[0].name}" oninput="updateNameUsnBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientUsnBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderUsnBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderUsnBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderUsnBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Radial</div>
                            <div class="colorSliderAdd colorSliderUsnBGAdd" onclick="addColorSliderUsnBG(event)"></div>
                            <div class="colorSliderCont colorSliderUsnBGCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderUsnBG" oninput="updateColorSliderUsnBGBox()" onpointerdown="openColorUsnBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderUsnBG" oninput="updateColorSliderUsnBGBox()" onpointerdown="openColorUsnBGBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorUsnBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorUsnBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorUsnBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorUsnBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorUsnBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorUsnBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetUsnBGBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="singleChoiceList gradRadialPosContUsnBG">
                            <button data-active="true" onclick="updateRadialTypeUsnBG(event, 'farthest-corner')">Farthest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeUsnBG(event, 'farthest-side')">Farthest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeUsnBG(event, 'closest-corner')">Closest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeUsnBG(event, 'closest-side')">Closest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeUsnBG(event, 'circle')">Circle</button>
                        </div>
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">x:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosUsnBG(event, 'x')">
                                <span class="numContUnit">%</span>
                            </div>
                            <div class="numCont">
                                <span class="numContDescr">y:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosUsnBG(event, 'y')">
                                <span class="numContUnit">%</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeUsnBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        }
        document.querySelector(".colorMenuColUsnBG").prepend(colorMenu);
    } else {
        indexPlace = index;

        var menuOpt = JSON.parse(JSON.stringify(settings.usnBackground[`${activeRole}`].value[indexPlace]));
        settings.usnBackground[`${activeRole}`].value.splice(indexPlace, 0, menuOpt);

        var colorMenuNode = document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[indexPlace].cloneNode(true);
        colorMenuNode.setAttribute("data-color-show", "false");
        colorMenuNode.setAttribute("data-set-show", "false");
        colorMenuNode.setAttribute("data-size-show", "false");
        document.querySelector(".colorMenuColUsnBG").insertBefore(colorMenuNode, document.querySelector(".colorMenuColUsnBG").children[indexPlace]);
    }
    
    for (var i = 0; i < document.querySelectorAll(".colorSliderUsnBGCont").length; i++) {
        for (var j = 0; j < document.querySelectorAll(".colorSliderUsnBGCont")[i].querySelectorAll(".colorSlider").length; j++) {
            document.querySelectorAll(".colorSliderUsnBGCont")[i].querySelectorAll(".colorSlider")[j].setAttribute("onpointerdown", `openColorUsnBGBox(${i}, ${j})`);
        }
    }
    
    updateColorSliderUsnBGBox();
    decompileUsnBG();
}

function removeGradientUsnBG(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode);
    if (i < activeUsnBGGrad) {
        activeUsnBGGrad -= 1;
    }
    settings.usnBackground[`${activeRole}`].value.splice(i, 1);
    document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[i].remove();
    for (let j = 0; j < document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu").length; j++) {
        for (let k = 0; k < document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider").length; k++) {
            document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorUsnBGBox(${j}, ${k})`)
        }
    }

    decompileUsnBG();
}

function updateRadialTypeUsnBG(e, size) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    settings.usnBackground[`${activeRole}`].value[i].size = size;
    for (let j = 0; j < settings.usnBackground[`${activeRole}`].value.length; j++) {
        if (settings.usnBackground[`${activeRole}`].value[j].type === "radial") {
            for (let k = 0; k < document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContUsnBG").querySelectorAll("button").length; k++) {
                document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContUsnBG").querySelectorAll("button")[k].setAttribute("data-active", "false");
            }
            e.target.setAttribute("data-active", "true");
        }
    }

    decompileUsnBG();
}

function updateLinearRotUsnBG(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    settings.usnBackground[`${activeRole}`].value[i].rotate = parseInt(e.target.value);

    decompileUsnBG();
}

function updateRadialPosUsnBG(e, xy) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    if (xy === "x") {
        settings.usnBackground[`${activeRole}`].value[i].x = parseInt(e.target.value);
    } else if (xy === "y") {
        settings.usnBackground[`${activeRole}`].value[i].y = parseInt(e.target.value);
    }

    decompileUsnBG();
}

function moveColorSliderUsnBG(e, dir) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    if (dir === "up" && i > 0) {
        var elmnt = settings.usnBackground[`${activeRole}`].value[i];
        settings.usnBackground[`${activeRole}`].value.splice(i, 1);
        settings.usnBackground[`${activeRole}`].value.splice(i - 1, 0, elmnt);
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[i - 1].before(document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[i]);
        if (activeUsnBGGrad === i) {
            activeUsnBGGrad -= 1;
        } else if (activeUsnBGGrad === i - 1) {
            activeUsnBGGrad += 1;
        }
    } else if (dir === "down" && i < settings.usnBackground[`${activeRole}`].value.length - 1) {
        var elmnt = settings.usnBackground[`${activeRole}`].value[i];
        settings.usnBackground[`${activeRole}`].value.splice(i, 1);
        settings.usnBackground[`${activeRole}`].value.splice(i + 1, 0, elmnt);
        document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[i + 1].after(document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[i]);
        if (activeUsnBGGrad === i) {
            activeUsnBGGrad += 1;
        } else if (activeUsnBGGrad === i + 1) {
            activeUsnBGGrad -= 1;
        }
    }

    for (let j = 0; j < settings.usnBackground[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.usnBackground[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColUsnBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorUsnBGBox(${j}, ${k})`)
        }
    }

    decompileUsnBG();
}

function duplicateColorSliderUsnBG() {
    activeUsnBGGrad += 1;
    var i = Array.from(event.target.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode);
    var type = settings.usnBackground[`${activeRole}`].value[i].type;

    addGradientUsnBG(type, i);
}

function updateUsnBGSizePos(cat, value) {
    var i = Array.from(event.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode.parentNode);
    if (cat === "posX") {
        if (value === "%") {
            settings.usnBackground[`${activeRole}`].value[i].posX.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackground[`${activeRole}`].value[i].posX.px = parseInt(event.target.value);
        }
    } else if (cat === "posY") {
        if (value === "%") {
            settings.usnBackground[`${activeRole}`].value[i].posY.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackground[`${activeRole}`].value[i].posY.px = parseInt(event.target.value);
        }
    } else if (cat === "width") {
        if (value === "%") {
            settings.usnBackground[`${activeRole}`].value[i].width.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackground[`${activeRole}`].value[i].width.px = parseInt(event.target.value);
        }
    } else if (cat === "height") {
        if (value === "%") {
            settings.usnBackground[`${activeRole}`].value[i].height.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackground[`${activeRole}`].value[i].height.px = parseInt(event.target.value);
        }
    }

    decompileUsnBG();
}

// settings.usnBackgroundMask

var activeUsnMaskGrad = 0;
var activeUsnMaskColor = 0;

function decompileUsnMask() {
    roleList.forEach(role => {
        if (settings.usnBackgroundMask[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usnBackgroundMask = "",
                    usnBackgroundMaskPos = "",
                    usnBackgroundMaskSize = "";
                for (let i = 0; i < settings.usnBackgroundMask[`${role}`].value.length; i++) {
                    if (settings.usnBackgroundMask[`${role}`].value[i].type === "solid") {
                        usnBackgroundMask += `linear-gradient(#ffffff${dec2hex(settings.usnBackgroundMask[`${role}`].value[i].colors[0].opacity)}, #ffffff${dec2hex(settings.usnBackgroundMask[`${role}`].value[i].colors[0].opacity)})`;
                    } else if (settings.usnBackgroundMask[`${role}`].value[i].type === "linear") {
                        var sortedColors = [...settings.usnBackgroundMask[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        usnBackgroundMask += `linear-gradient(${settings.usnBackgroundMask[`${role}`].value[i].rotate}deg, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            usnBackgroundMask += `#ffffff${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            
                            if (j < settings.usnBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                usnBackgroundMask += ", "
                            } else if (j === settings.usnBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                usnBackgroundMask += ")";
                            }
                        }
                    } else if (settings.usnBackgroundMask[`${role}`].value[i].type === "radial") {
                        var sortedColors = [...settings.usnBackgroundMask[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        usnBackgroundMask += `radial-gradient(${settings.usnBackgroundMask[`${role}`].value[i].size} at ${settings.usnBackgroundMask[`${role}`].value[i].x}% ${settings.usnBackgroundMask[`${role}`].value[i].y}%, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            usnBackgroundMask += `#ffffff${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            
                            if (j < settings.usnBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                usnBackgroundMask += ", "
                            } else if (j === settings.usnBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                usnBackgroundMask += ")";
                            }
                        }
                    }

                    usnBackgroundMaskPos += `calc(${settings.usnBackgroundMask[`${role}`].value[i].posX.percent}% + ${settings.usnBackgroundMask[`${role}`].value[i].posX.px}px) calc(${settings.usnBackgroundMask[`${role}`].value[i].posY.percent}% + ${settings.usnBackgroundMask[`${role}`].value[i].posY.px}px)`;
                    usnBackgroundMaskSize += `calc(${settings.usnBackgroundMask[`${role}`].value[i].width.percent}% + ${settings.usnBackgroundMask[`${role}`].value[i].width.px}px) calc(${settings.usnBackgroundMask[`${role}`].value[i].height.percent}% + ${settings.usnBackgroundMask[`${role}`].value[i].height.px}px)`;

                    if (i < settings.usnBackgroundMask[`${role}`].value.length - 1) {
                        usnBackgroundMask += `, `;
                        usnBackgroundMaskPos += `, `;
                        usnBackgroundMaskSize += `, `;
                    }
                }
                
                cbxW.style.setProperty(`--usnBackgroundMask`, usnBackgroundMask);
                cbxW.style.setProperty(`--usnBackgroundMaskPos`, usnBackgroundMaskPos);
                cbxW.style.setProperty(`--usnBackgroundMaskSize`, usnBackgroundMaskSize);
            });
        }
    });
}

function updateColorSliderUsnMaskBox() {
    for (let i = 0; i < document.querySelectorAll(".colorSliderUsnMaskCont").length; i++) {
        if (settings.usnBackgroundMask[`${activeRole}`].value[i].type !== "solid") {
            
            var usnMaskPrev = "linear-gradient(90deg, ",
                nodeList = document.querySelectorAll(".colorSliderUsnMaskCont")[i].querySelectorAll(".colorSliderUsnMask"),
                colorList = settings.usnBackgroundMask[`${activeRole}`].value[i].colors;

            for (let j = 0; j < settings.usnBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                settings.usnBackgroundMask[`${activeRole}`].value[i].colors[j].count = 0;
                colorList[j].position = parseFloat(nodeList[j].value);
                nodeList[j].style.setProperty("--value", `${nodeList[j].value}%`);
                nodeList[j].style.setProperty("--valueTxt", `"${nodeList[j].value}"`);
            }

            for (let j = 0; j < settings.usnBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                for (let k = 0; k < settings.usnBackgroundMask[`${activeRole}`].value[i].colors.length; k++) {
                    if (k !== j) {
                        if (settings.usnBackgroundMask[`${activeRole}`].value[i].colors[j].position >= settings.usnBackgroundMask[`${activeRole}`].value[i].colors[k].position) {
                            settings.usnBackgroundMask[`${activeRole}`].value[i].colors[j].count += 1;
                        }
                    }
                }
            }

            for (let j = 0; j < settings.usnBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                var resultElmnt = settings.usnBackgroundMask[`${activeRole}`].value[i].colors.find(findElmnt => findElmnt.count === j);
                usnMaskPrev += `#ffffff${dec2hex(resultElmnt.opacity)} ${resultElmnt.position}%`;
                
                if (j < settings.usnBackgroundMask[`${activeRole}`].value[i].colors.length - 1) {
                    usnMaskPrev += ", ";
                } else {
                    usnMaskPrev += ")";
                }
            }

            document.querySelectorAll(".colorSliderUsnMaskCont")[i].style.backgroundImage = usnMaskPrev;
        } else {
            var usnMaskPrev = `#ffffff${dec2hex(settings.usnBackgroundMask[`${activeRole}`].value[i].colors[0].opacity)}`;
            document.querySelectorAll(".colorSliderUsnMaskCont")[i].style.backgroundColor = usnMaskPrev;
        }
    }
    decompileUsnMask();
}

function openColorUsnMaskBox(grdNum, clrNum) {
    var open = true;

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });

    event.target.parentNode.setAttribute("data-color-show", open);
    
    activeUsnMaskGrad = grdNum;
    activeUsnMaskColor = clrNum;
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].setAttribute("data-color-show", "true");
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].setAttribute("data-set-show", "false");
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].setAttribute("data-size-show", "false");
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].querySelector(".colorChangeOpacity").value = settings.usnBackgroundMask[`${activeRole}`].value[activeUsnMaskGrad].colors[activeUsnMaskColor].opacity;
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].querySelector(".colorChangeOpacity").setAttribute("data-value", settings.usnBackgroundMask[`${activeRole}`].value[activeUsnMaskGrad].colors[activeUsnMaskColor].opacity);
    document.querySelectorAll(".colorSliderUsnMask").forEach(usnCont => {
        usnCont.setAttribute("data-active", "false");
    });
    document.querySelectorAll(".colorSliderUsnMaskCont")[activeUsnMaskGrad].querySelectorAll(".colorSliderUsnMask")[activeUsnMaskColor].setAttribute("data-active", "true");
}

function updateNameUsnMaskBox() {
    for (var i = 0; i < document.querySelectorAll(".backgroundNameUsnMask").length; i++) {
        settings.usnBackgroundMask[`${activeRole}`].value[i].name = document.querySelectorAll(".backgroundNameUsnMask")[i].value;
    }
}

function updateColorUsnMaskBox(type) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    
    settings.usnBackgroundMask[`${activeRole}`].value[activeUsnMaskGrad].colors[activeUsnMaskColor].opacity = parseInt(document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].querySelector(".colorChangeOpacity").value);
    updateColorSliderUsnMaskBox();

    decompileUsnMask();
}

function deleteColorUsnMaskBox() {
    settings.usnBackgroundMask[`${activeRole}`].value[activeUsnMaskGrad].colors.splice(activeUsnMaskColor, 1);
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].querySelectorAll(".colorSliderUsnMask")[activeUsnMaskColor].remove();
    updateColorSliderUsnMaskBox();
    for (let i = 0; i < document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].querySelectorAll(".colorSliderUsnMask").length; i++) {
        document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].querySelectorAll(".colorSliderUsnMask")[i].setAttribute("onpointerdown", `openColorUsnMaskBox(${activeUsnMaskGrad}, ${i})`);
    }
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[activeUsnMaskGrad].setAttribute("data-color-show", "false");
    activeUsnMaskGrad = undefined;
    activeUsnMaskColor = undefined;

    for (let j = 0; j < settings.usnBackgroundMask[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.usnBackgroundMask[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorUsnMaskBox(${j}, ${k})`)
        }
    }

    decompileUsnMask();
}

function addColorSliderUsnMask(e) {
    i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    document.querySelectorAll(".colorSlider").forEach(slider => {
        slider.setAttribute("data-active", "false");
    })
    var newSlider = document.createElement("input");newSlider.className = "colorSlider colorSliderUsnMask";newSlider.setAttribute("oninput", "updateColorSliderUsnMaskBox()");newSlider.setAttribute("onpointerdown", `openColorUsnMaskBox(${i}, ${e.target.parentNode.querySelectorAll(".colorSlider").length})`);newSlider.type = "range";newSlider.value = (e.layerX / e.target.clientWidth) * 100;newSlider.min = "0";newSlider.max = "100";newSlider.step = "0.1";newSlider.setAttribute("data-active", "true");
                
    document.querySelectorAll(".colorSliderUsnMaskCont")[i].appendChild(newSlider);

    settings.usnBackgroundMask[`${activeRole}`].value[i].colors.push({
        position: newSlider.value, // In %
        opacity: 255, // In Hex
        count: 0
    });
    updateColorSliderUsnMaskBox();
    openColorUsnMaskBox(i, e.target.parentNode.querySelectorAll(".colorSlider").length - 1);
    
    updateColorSliderUsnMaskBox();
    
    decompileUsnMask();
}

function hideColorUsnMaskBox() {
    document.querySelectorAll(".colorSliderUsnMaskCont")[activeUsnMaskGrad].querySelectorAll(".colorSliderUsnMask")[activeUsnMaskColor].setAttribute("data-active", "false");
    activeUsnMaskGrad = undefined;
    activeUsnMaskColor = undefined;
    event.target.parentNode.parentNode.setAttribute("data-color-show", "false");
}

function switchSetUsnMaskBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-set-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderUsnMask").forEach(usnCont => {
        usnCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-set-show", open);
}

function switchSizeUsnMaskBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-size-show") === "true") {
        open = false;
    }
    
    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderUsnMask").forEach(usnCont => {
        usnCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-size-show", open);
}

function addGradientUsnMask(type, index) {
    var indexPlace;
    if (index === undefined) {
        indexPlace = 0;
        if (type === "solid") {
            settings.usnBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "solid",
                name: `Mask ${settings.usnBackgroundMask[`${activeRole}`].value.length + 1}`,
                colors: [
                    {
                        position:0,
                        opacity:255,
                        count:0
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameUsnMask backgroundName" type="text" value="${settings.usnBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameUsnMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientUsnMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderUsnMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderUsnMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderUsnMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Solid</div>
                            <div class="colorSliderAdd colorSliderUsnMaskAdd"></div>
                            <div class="colorSliderCont colorSliderUsnMaskCont" style="background-color:#ffffff;">
                                <input class="colorSlider colorSliderUsnMask" oninput="updateColorSliderUsnMaskBox()" onpointerdown="openColorUsnMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorUsnMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorUsnMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorUsnMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeUsnMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "linear") {
            settings.usnBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "linear",
                name: `Mask ${settings.usnBackgroundMask[`${activeRole}`].value.length + 1}`,
                rotate: 90, // In deg
                colors: [
                    {
                        position: 0, // In %
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameUsnMask backgroundName" type="text" value="${settings.usnBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameUsnMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientUsnMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderUsnMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderUsnMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderUsnMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Linear</div>
                            <div class="colorSliderAdd colorSliderUsnMaskAdd" onclick="addColorSliderUsnMask(event)"></div>
                            <div class="colorSliderCont colorSliderUsnMaskCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderUsnMask" oninput="updateColorSliderUsnMaskBox()" onpointerdown="openColorUsnMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderUsnMask" oninput="updateColorSliderUsnMaskBox()" onpointerdown="openColorUsnMaskBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorUsnMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorUsnMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorUsnMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetUsnMaskBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">rotation:</span>
                                <input class="numContInput" type="number" value="90" oninput="updateLinearRotUsnMask(event)">
                                <span class="numContUnit">°</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeUsnMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "radial") {
            settings.usnBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "radial",
                name: `Mask ${settings.usnBackgroundMask[`${activeRole}`].value.length + 1}`,
                size: "farthest-corner", // farthest/closest - corner/side, circle
                x: 50, // In %
                y: 50, // In %
                colors: [
                    {
                        position: 0, // In %
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameUsnMask backgroundName" type="text" value="${settings.usnBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameUsnMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientUsnMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderUsnMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderUsnMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderUsnMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Radial</div>
                            <div class="colorSliderAdd colorSliderUsnMaskAdd" onclick="addColorSliderUsnMask(event)"></div>
                            <div class="colorSliderCont colorSliderUsnMaskCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderUsnMask" oninput="updateColorSliderUsnMaskBox()" onpointerdown="openColorUsnMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderUsnMask" oninput="updateColorSliderUsnMaskBox()" onpointerdown="openColorUsnMaskBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorUsnMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorUsnMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorUsnMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetUsnMaskBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="singleChoiceList gradRadialPosContUsnMask">
                            <button data-active="true" onclick="updateRadialTypeUsnMask(event, 'farthest-corner')">Farthest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeUsnMask(event, 'farthest-side')">Farthest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeUsnMask(event, 'closest-corner')">Closest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeUsnMask(event, 'closest-side')">Closest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeUsnMask(event, 'circle')">Circle</button>
                        </div>
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">x:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosUsnMask(event, 'x')">
                                <span class="numContUnit">%</span>
                            </div>
                            <div class="numCont">
                                <span class="numContDescr">y:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosUsnMask(event, 'y')">
                                <span class="numContUnit">%</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeUsnMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateUsnMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateUsnMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateUsnMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        }
        document.querySelector(".colorMenuColUsnMask").insertBefore(colorMenu, document.querySelector(".colorMenuColUsnMask").children[indexPlace]);
    } else {
        indexPlace = index;

        var menuOpt = JSON.parse(JSON.stringify(settings.usnBackgroundMask[`${activeRole}`].value[indexPlace]));
        settings.usnBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, menuOpt);

        var colorMenuNode = document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[indexPlace].cloneNode(true);
        colorMenuNode.setAttribute("data-color-show", "false");
        colorMenuNode.setAttribute("data-set-show", "false");
        colorMenuNode.setAttribute("data-size-show", "false");
        document.querySelector(".colorMenuColUsnMask").insertBefore(colorMenuNode, document.querySelector(".colorMenuColUsnMask").children[indexPlace]);
    }
    
    for (var i = 0; i < document.querySelectorAll(".colorSliderUsnMaskCont").length; i++) {
        for (var j = 0; j < document.querySelectorAll(".colorSliderUsnMaskCont")[i].querySelectorAll(".colorSlider").length; j++) {
            document.querySelectorAll(".colorSliderUsnMaskCont")[i].querySelectorAll(".colorSlider")[j].setAttribute("onpointerdown", `openColorUsnMaskBox(${i}, ${j})`);
        }
    }
    
    updateColorSliderUsnMaskBox();
    decompileUsnMask();
}

function removeGradientUsnMask(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode);
    if (i < activeUsnMaskGrad) {
        activeUsnMaskGrad -= 1;
    }
    settings.usnBackgroundMask[`${activeRole}`].value.splice(i, 1);
    document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[i].remove();
    for (let j = 0; j < document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu").length; j++) {
        for (let k = 0; k < document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider").length; k++) {
            document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorUsnMaskBox(${j}, ${k})`)
        }
    }
    
    decompileUsnMask();
}

function updateRadialTypeUsnMask(e, size) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    settings.usnBackgroundMask[`${activeRole}`].value[i].size = size;
    for (let j = 0; j < settings.usnBackgroundMask[`${activeRole}`].value.length; j++) {
        if (settings.usnBackgroundMask[`${activeRole}`].value[j].type === "radial") {
            for (let k = 0; k < document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContUsnMask").querySelectorAll("button").length; k++) {
                document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContUsnMask").querySelectorAll("button")[k].setAttribute("data-active", "false");
            }
            e.target.setAttribute("data-active", "true");
        }
    }
    
    decompileUsnMask();
}

function updateLinearRotUsnMask(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    settings.usnBackgroundMask[`${activeRole}`].value[i].rotate = parseInt(e.target.value);
    
    decompileUsnMask();
}

function updateRadialPosUsnMask(e, xy) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    if (xy === "x") {
        settings.usnBackgroundMask[`${activeRole}`].value[i].x = parseInt(e.target.value);
    } else if (xy === "y") {
        settings.usnBackgroundMask[`${activeRole}`].value[i].y = parseInt(e.target.value);
    }
    
    decompileUsnMask();
}

function moveColorSliderUsnMask(e, dir) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    if (dir === "up" && i > 0) {
        var elmnt = settings.usnBackgroundMask[`${activeRole}`].value[i];
        settings.usnBackgroundMask[`${activeRole}`].value.splice(i, 1);
        settings.usnBackgroundMask[`${activeRole}`].value.splice(i - 1, 0, elmnt);
        document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[i - 1].before(document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[i]);
        if (activeUsnMaskGrad === i) {
            activeUsnMaskGrad -= 1;
        } else if (activeUsnMaskGrad === i - 1) {
            activeUsnMaskGrad += 1;
        }
    } else if (dir === "down" && i < settings.usnBackgroundMask[`${activeRole}`].value.length - 1) {
        var elmnt = settings.usnBackgroundMask[`${activeRole}`].value[i];
        settings.usnBackgroundMask[`${activeRole}`].value.splice(i, 1);
        settings.usnBackgroundMask[`${activeRole}`].value.splice(i + 1, 0, elmnt);
        document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[i + 1].after(document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[i]);
        if (activeUsnMaskGrad === i) {
            activeUsnMaskGrad += 1;
        } else if (activeUsnMaskGrad === i + 1) {
            activeUsnMaskGrad -= 1;
        }
    }

    for (let j = 0; j < settings.usnBackgroundMask[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.usnBackgroundMask[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColUsnMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorUsnMaskBox(${j}, ${k})`)
        }
    }
    
    decompileUsnMask();
}

function duplicateColorSliderUsnMask() {
    activeUsnMaskGrad += 1;
    var i = Array.from(event.target.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode);
    var type = settings.usnBackgroundMask[`${activeRole}`].value[i].type;

    addGradientUsnMask(type, i);
}

function updateUsnMaskSizePos(cat, value) {
    var i = Array.from(event.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode.parentNode);
    if (cat === "posX") {
        if (value === "%") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].posX.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].posX.px = parseInt(event.target.value);
        }
    } else if (cat === "posY") {
        if (value === "%") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].posY.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].posY.px = parseInt(event.target.value);
        }
    } else if (cat === "width") {
        if (value === "%") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].width.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].width.px = parseInt(event.target.value);
        }
    } else if (cat === "height") {
        if (value === "%") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].height.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.usnBackgroundMask[`${activeRole}`].value[i].height.px = parseInt(event.target.value);
        }
    }
    
    decompileUsnMask();
}

// settings.usnBorder

function decompileUsnBorder() {
    roleList.forEach(role => {
        if (settings.usnBorder[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn")
                if (settings.usnBorder[`${role}`].value.top.color.type === "custom") {
                    usn.style.setProperty(`--usnBorderTop`, `${settings.usnBorder[`${role}`].value.top.type} ${settings.usnBorder[`${role}`].value.top.width}px ${settings.usnBorder[`${role}`].value.top.color.color}${dec2hex(settings.usnBorder[`${role}`].value.top.color.opacity)}`);
                } else if (settings.usnBorder[`${role}`].value.top.color.type === "twitch") {
                    usn.style.setProperty(`--usnBorderTop`, `${settings.usnBorder[`${role}`].value.top.type} ${settings.usnBorder[`${role}`].value.top.width}px ${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnBorder[`${role}`].value.top.color.opacity)}`);
                }

                if (settings.usnBorder[`${role}`].value.right.color.type === "custom") {
                    usn.style.setProperty(`--usnBorderRight`, `${settings.usnBorder[`${role}`].value.right.type} ${settings.usnBorder[`${role}`].value.right.width}px ${settings.usnBorder[`${role}`].value.right.color.color}${dec2hex(settings.usnBorder[`${role}`].value.right.color.opacity)}`);
                } else if (settings.usnBorder[`${role}`].value.right.color.type === "twitch") {
                    usn.style.setProperty(`--usnBorderRight`, `${settings.usnBorder[`${role}`].value.right.type} ${settings.usnBorder[`${role}`].value.right.width}px ${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnBorder[`${role}`].value.right.color.opacity)}`);
                }

                if (settings.usnBorder[`${role}`].value.bottom.color.type === "custom") {
                    usn.style.setProperty(`--usnBorderBottom`, `${settings.usnBorder[`${role}`].value.bottom.type} ${settings.usnBorder[`${role}`].value.bottom.width}px ${settings.usnBorder[`${role}`].value.bottom.color.color}${dec2hex(settings.usnBorder[`${role}`].value.bottom.color.opacity)}`);
                } else if (settings.usnBorder[`${role}`].value.bottom.color.type === "twitch") {
                    usn.style.setProperty(`--usnBorderBottom`, `${settings.usnBorder[`${role}`].value.bottom.type} ${settings.usnBorder[`${role}`].value.bottom.width}px ${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnBorder[`${role}`].value.bottom.color.opacity)}`);
                }

                if (settings.usnBorder[`${role}`].value.left.color.type === "custom") {
                    usn.style.setProperty(`--usnBorderLeft`, `${settings.usnBorder[`${role}`].value.left.type} ${settings.usnBorder[`${role}`].value.left.width}px ${settings.usnBorder[`${role}`].value.left.color.color}${dec2hex(settings.usnBorder[`${role}`].value.left.color.opacity)}`);
                } else if (settings.usnBorder[`${role}`].value.left.color.type === "twitch") {
                    usn.style.setProperty(`--usnBorderLeft`, `${settings.usnBorder[`${role}`].value.left.type} ${settings.usnBorder[`${role}`].value.left.width}px ${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnBorder[`${role}`].value.left.color.opacity)}`);
                }
            });
        }
    });
}

var activeUsnBorder = ""

function openBorderMenuUsn(pos) {
    document.querySelector("#borderGridUsn").querySelectorAll(".borderSelect").forEach(elmnt => {
        elmnt.setAttribute("data-active", "false");
    });

    event.target.setAttribute("data-active", "true");

    var borderMenu = event.target.parentNode.parentNode.parentNode.querySelector(".borderEdgeMenu"),
        cornerMenu = event.target.parentNode.parentNode.parentNode.querySelector(".borderCornerMenu");
    activeUsnBorder = pos;
    if (activeUsnBorder === "top" || activeUsnBorder === "bottom" || activeUsnBorder === "left" || activeUsnBorder === "right") {
        borderMenu.setAttribute("data-active", "true");
        cornerMenu.setAttribute("data-active", "false");

        borderMenu.querySelectorAll(".borderTypeBtn").forEach(elmnt => {
            elmnt.setAttribute("data-active", "false")
        });

        if (settings.usnBorder[`${activeRole}`].value[`${pos}`].color.type === "custom") {
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
        } else if (settings.usnBorder[`${activeRole}`].value[`${pos}`].color.type === "twitch") {
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
        }

        borderMenu.querySelector(`.borderTypeBtn[data-type="${settings.usnBorder[`${activeRole}`].value[`${pos}`].type}"]`).setAttribute("data-active", "true");
        borderMenu.querySelector(".borderWidthCont").querySelector(".inputNumBig").value = settings.usnBorder[`${activeRole}`].value[`${pos}`].width;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeInput").value = settings.usnBorder[`${activeRole}`].value[`${pos}`].color.color;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").value = settings.usnBorder[`${activeRole}`].value[`${pos}`].color.opacity;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").setAttribute("data-value", borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").value);
        
    } else if (activeUsnBorder === "tl" || activeUsnBorder === "tr" || activeUsnBorder === "bl" || activeUsnBorder === "br") {
        cornerMenu.setAttribute("data-active", "true");
        borderMenu.setAttribute("data-active", "false");

        cornerMenu.querySelector(".inputNumBig").value = settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`];
    }
}

function updateBorderUsn(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    if (type === "type") {
        Array.from(event.target.parentNode.parentNode.children).forEach(elmnt => {
            elmnt.setAttribute("data-active", "false");
        });
        event.target.parentNode.setAttribute("data-active", "true");
        settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].type = value;
    } else if (type === "width") {
        settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].width = parseInt(document.querySelector("#usnBorderWidth").value);
    } else if (type === "color") {
        settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.color = document.querySelector("#usnBorderColor").value;
    } else if (type === "colorType") {
        settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.type = value;
        if (value === "custom") {
            document.querySelector(".borderEdgeMenuUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".borderEdgeMenuUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".borderEdgeMenuUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".borderEdgeMenuUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "opacity") {
        settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.opacity = parseInt(document.querySelector("#usnBorderOpacity").value);
    } else if (type === "all") {
        settings.usnBorder[`${activeRole}`].value["top"].type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].type;
        settings.usnBorder[`${activeRole}`].value["bottom"].type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].type;
        settings.usnBorder[`${activeRole}`].value["left"].type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].type;
        settings.usnBorder[`${activeRole}`].value["right"].type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].type;

        settings.usnBorder[`${activeRole}`].value["top"].width = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].width;
        settings.usnBorder[`${activeRole}`].value["bottom"].width = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].width;
        settings.usnBorder[`${activeRole}`].value["left"].width = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].width;
        settings.usnBorder[`${activeRole}`].value["right"].width = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].width;
        
        settings.usnBorder[`${activeRole}`].value["top"].color.color = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.color;
        settings.usnBorder[`${activeRole}`].value["bottom"].color.color = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.color;
        settings.usnBorder[`${activeRole}`].value["left"].color.color = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.color;
        settings.usnBorder[`${activeRole}`].value["right"].color.color = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.color;

        settings.usnBorder[`${activeRole}`].value["top"].color.type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.type;
        settings.usnBorder[`${activeRole}`].value["bottom"].color.type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.type;
        settings.usnBorder[`${activeRole}`].value["left"].color.type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.type;
        settings.usnBorder[`${activeRole}`].value["right"].color.type = "" + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.type;

        settings.usnBorder[`${activeRole}`].value["top"].color.opacity = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.opacity
        settings.usnBorder[`${activeRole}`].value["bottom"].color.opacity = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.opacity
        settings.usnBorder[`${activeRole}`].value["left"].color.opacity = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.opacity
        settings.usnBorder[`${activeRole}`].value["right"].color.opacity = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`].color.opacity
    }

    decompileUsnBorder();
}

// settings.usnBorder[`${activeRole}`].value

function decompileUsnBorderRadius() {
    roleList.forEach(role => {
        if (settings.usnBorder[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                usn.style.setProperty(`--usnBRtl`, `${settings.usnBorder[`${role}`].value.tl}px`);
                usn.style.setProperty(`--usnBRtr`, `${settings.usnBorder[`${role}`].value.tr}px`);
                usn.style.setProperty(`--usnBRbr`, `${settings.usnBorder[`${role}`].value.br}px`);
                usn.style.setProperty(`--usnBRbl`, `${settings.usnBorder[`${role}`].value.bl}px`);
            });
        }
    });
}

function updateCornerUsn(type) {
    if (type === "corner") {
        settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`] = parseInt(document.querySelector("#usnCornerRadius").value);
    } else if (type === "all") {
        settings.usnBorder[`${activeRole}`].value["tl"] = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`];
        settings.usnBorder[`${activeRole}`].value["tr"] = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`];
        settings.usnBorder[`${activeRole}`].value["bl"] = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`];
        settings.usnBorder[`${activeRole}`].value["br"] = 0 + settings.usnBorder[`${activeRole}`].value[`${activeUsnBorder}`];
    }

    decompileUsnBorderRadius();
}

// settings.usnShadow

function decompileUsnShadow() {
    roleList.forEach(role => {
        if (settings.usnShadow[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                var usnShadow = "";

                for (let i = 0; i < settings.usnShadow[`${role}`].value.length; i++) {
                    usnShadow += `${settings.usnShadow[`${role}`].value[i].x}px ${settings.usnShadow[`${role}`].value[i].y}px ${settings.usnShadow[`${role}`].value[i].blur}px ${settings.usnShadow[`${role}`].value[i].expand}px `;
                    if (settings.usnShadow[`${role}`].value[i].color.type === "custom") {
                        usnShadow += `${settings.usnShadow[`${role}`].value[i].color.color}${dec2hex(settings.usnShadow[`${role}`].value[i].color.opacity)}`;
                    } else if (settings.usnShadow[`${role}`].value[i].color.type === "twitch") {
                        usnShadow += `${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnShadow[`${role}`].value[i].color.opacity)}`;
                    }
                    if (settings.usnShadow[`${role}`].value[i].inset === true) {
                        usnShadow += " inset";
                    }
                    if (i < settings.usnShadow[`${role}`].value.length - 1) {
                        usnShadow += ", ";
                    }
                }

                usn.style.setProperty(`--usnBS`, usnShadow);
            });
        }
    });
}

var activeUsnShadow = -1;

function openShadowUsn(triggerAdd) {
    for (let i = 0; i < settings.usnShadow[`${activeRole}`].value.length; i++) {
        document.querySelector(".shadowColUsn").querySelectorAll(".shadowElmnt")[i].setAttribute("data-active", "false");
    }
    
    if (!triggerAdd) {
        activeUsnShadow = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);
    }
    
    if (activeUsnShadow >= 0) {
        document.querySelector(".shadowSettingsUsn").setAttribute("data-active", "true");
        document.querySelector(".shadowColUsn").querySelectorAll(".shadowElmnt")[activeUsnShadow].setAttribute("data-active", "true");
        
        
        document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[0].value = settings.usnShadow[`${activeRole}`].value[activeUsnShadow].x;
        document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[1].value = settings.usnShadow[`${activeRole}`].value[activeUsnShadow].y;
        document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[2].value = settings.usnShadow[`${activeRole}`].value[activeUsnShadow].blur;
        document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[3].value = settings.usnShadow[`${activeRole}`].value[activeUsnShadow].expand;
        document.querySelector(".shadowSettingsUsn").querySelector(".usnShadowInset").setAttribute("data-active", settings.usnShadow[`${activeRole}`].value[activeUsnShadow].inset);
        
        if (settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.type === "custom") {
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.type === "twitch") {
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
        
        document.querySelector("#usnShadowOpacity").value = settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.opacity;
        document.querySelector("#usnShadowOpacity").setAttribute("data-value", settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.opacity);
        
        document.querySelector("#usnShadowColor").value = settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.color;
    } else if (activeUsnShadow === -1) {
        document.querySelector(".shadowSettingsUsn").setAttribute("data-active", "false");
    }
}

function addShadowUsn() {
    var shadowElmnt = document.createElement("div");
        shadowElmnt.className = "shadowElmnt";

        shadowElmnt.innerHTML = `
            <button class="shadowElmntBtn" onclick="openShadowUsn()"></button>
            <button class="shadowElmntRmv icon" onclick="removeShadowUsn()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
        `;

    document.querySelector(".shadowColUsn").appendChild(shadowElmnt);

    settings.usnShadow[`${activeRole}`].value.push({
        x: 0, // In px
        y: 0, // In px
        blur: 0, // In px
        expand: 0, // In px
        color: {
            type: "custom",
            color: "#000000",
            opacity: 255 // In Hex
        },
        inset: false
    });

    activeUsnShadow = settings.usnShadow[`${activeRole}`].value.length - 1;
    openShadowUsn(true);
    
    decompileUsnShadow();
}

function updateShadowUsn(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.usnShadow[`${activeRole}`].value[activeUsnShadow].x    = parseInt(document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[0].value);
    settings.usnShadow[`${activeRole}`].value[activeUsnShadow].y    = parseInt(document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[1].value);
    settings.usnShadow[`${activeRole}`].value[activeUsnShadow].blur    = parseInt(document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[2].value);
    settings.usnShadow[`${activeRole}`].value[activeUsnShadow].expand  = parseInt(document.querySelector(".shadowSettingsUsn").querySelectorAll(".numContInput")[3].value);
    
    settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.opacity = parseInt(document.querySelector("#usnShadowOpacity").value);
    document.querySelector("#usnShadowOpacity").setAttribute("data-value", document.querySelector("#usnShadowOpacity").value);
    
    if (document.querySelector(".shadowSettingsUsn").querySelector(".usnShadowInset").getAttribute("data-active") === "false") {
        settings.usnShadow[`${activeRole}`].value[activeUsnShadow].inset = false;
    } else {
        settings.usnShadow[`${activeRole}`].value[activeUsnShadow].inset = true;
    }

    if (type === "colorType") {
        settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.type = value;
        if (value === "custom") {
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "color") {
        settings.usnShadow[`${activeRole}`].value[activeUsnShadow].color.color = document.querySelector("#usnShadowColor").value;
    }

    for (let i = 0; i < settings.usnShadow[`${activeRole}`].value.length; i++) {
        var usnStyle = `${settings.usnShadow[`${activeRole}`].value[i].x}px ${settings.usnShadow[`${activeRole}`].value[i].y}px ${settings.usnShadow[`${activeRole}`].value[i].blur}px ${settings.usnShadow[`${activeRole}`].value[i].expand}px ${settings.usnShadow[`${activeRole}`].value[i].color.color}${dec2hex(settings.usnShadow[`${activeRole}`].value[i].color.opacity)}`;
        if (settings.usnShadow[`${activeRole}`].value[i].inset === true) {
            usnStyle += " inset";
        }

        document.querySelector(".shadowColUsn").querySelectorAll(".shadowElmnt")[i].style.boxShadow = usnStyle;
    }
    
    decompileUsnShadow();
}

function removeSwitchShadowUsn() {
    if (document.querySelector(".shadowColUsn").getAttribute("data-delete-active") === "false") {
        document.querySelector(".shadowColUsn").setAttribute("data-delete-active", "true");
    } else {
        document.querySelector(".shadowColUsn").setAttribute("data-delete-active", "false");
    }
    
    decompileUsnShadow();
}

function removeShadowUsn() {
    var i = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);

    if (i <= activeUsnShadow) {
        activeUsnShadow -= 1;
    }
    settings.usnShadow[`${activeRole}`].value.splice(i, 1);

    document.querySelector(".shadowColUsn").querySelectorAll(".shadowElmnt")[i].remove();

    openShadowUsn(true);
    
    decompileUsnShadow();
}

// settings.usnSpacing

function decompileUsnSpacing() {
    roleList.forEach(role => {
        if (settings.usnPosition[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                usn.style.setProperty(`--usnSpacingOT`, `${settings.usnPosition[`${role}`].value.spacing.outer.top}px`);
                usn.style.setProperty(`--usnSpacingOR`, `${settings.usnPosition[`${role}`].value.spacing.outer.right}px`);
                usn.style.setProperty(`--usnSpacingOB`, `${settings.usnPosition[`${role}`].value.spacing.outer.bottom}px`);
                usn.style.setProperty(`--usnSpacingOL`, `${settings.usnPosition[`${role}`].value.spacing.outer.left}px`);

                usn.style.setProperty(`--usnSpacingIT`, `${settings.usnPosition[`${role}`].value.spacing.inner.top}px`);
                usn.style.setProperty(`--usnSpacingIR`, `${settings.usnPosition[`${role}`].value.spacing.inner.right}px`);
                usn.style.setProperty(`--usnSpacingIB`, `${settings.usnPosition[`${role}`].value.spacing.inner.bottom}px`);
                usn.style.setProperty(`--usnSpacingIL`, `${settings.usnPosition[`${role}`].value.spacing.inner.left}px`);
            });
        }
    });
}

function updateUsnSpacing(pos) {
    if (pos === "OT") {
        settings.usnPosition[`${activeRole}`].value.spacing.outer.top = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridOuter")[0].value);
    } else if (pos === "OL") {
        settings.usnPosition[`${activeRole}`].value.spacing.outer.left = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridOuter")[1].value);
    } else if (pos === "OR") {
        settings.usnPosition[`${activeRole}`].value.spacing.outer.right = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridOuter")[2].value);
    } else if (pos === "OB") {
        settings.usnPosition[`${activeRole}`].value.spacing.outer.bottom = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridOuter")[3].value);
    } else if (pos === "IT") {
        settings.usnPosition[`${activeRole}`].value.spacing.inner.top = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridInner")[0].value);
    } else if (pos === "IL") {
        settings.usnPosition[`${activeRole}`].value.spacing.inner.left = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridInner")[1].value);
    } else if (pos === "IR") {
        settings.usnPosition[`${activeRole}`].value.spacing.inner.right = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridInner")[2].value);
    } else if (pos === "IB") {
        settings.usnPosition[`${activeRole}`].value.spacing.inner.bottom = parseInt(document.querySelector(".spacingGridUsn").querySelectorAll(".spacingGridInner")[3].value);
    }

    decompileUsnSpacing();
}

// settings.usnSizing
// settings.usnPosition

function decompileUsnSizing() {
    roleList.forEach(role => {
        if (settings.usnPosition[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                if (settings.cbxLayout[`${role}`].value.type === "column" || settings.cbxLayout[`${role}`].value.type === "column-reverse") {
                    usn.style.setProperty(`--usnSizingH`, settings.usnPosition[`${role}`].value.sizingH);
                    usn.style.setProperty(`--usnSizingV`, settings.usnPosition[`${role}`].value.sizingV);
                } else if (settings.cbxLayout[`${role}`].value.type === "row" || settings.cbxLayout[`${role}`].value.type === "row-reverse") {
                    usn.style.setProperty(`--usnSizingH`, settings.usnPosition[`${role}`].value.sizingV);
                    usn.style.setProperty(`--usnSizingV`, settings.usnPosition[`${role}`].value.sizingH);
                }
            });
        }
    });
}

function updateUsnSizingH(type) {
    if (type === "stretch") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-start") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "center") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-end") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "true");
    }
    
    settings.usnPosition[`${activeRole}`].value.sizingH = type;

    decompileUsnSizing();
}

function updateUsnSizingV(type) {
    if (type === "stretch") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-start") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "center") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-end") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "true");
    }
    
    settings.usnPosition[`${activeRole}`].value.sizingV = type;

    decompileUsnSizing();
}

// settings.usnFont

function decompileUsnFont() {
    roleList.forEach(role => {
        if (settings.usnFont[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                usn.style.setProperty("--usnFontFamily", `"${settings.usnFont[`${role}`].value.family}"`);

                if (settings.usnFont[`${role}`].value.color.type === "custom") {
                    usn.style.setProperty(`--usnFontColor`, `${settings.usnFont[`${role}`].value.color.color}${dec2hex(settings.usnFont[`${role}`].value.color.opacity)}`);
                } else if (settings.usnFont[`${role}`].value.color.type === "twitch") {
                    usn.style.setProperty(`--usnFontColor`, `${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnFont[`${role}`].value.color.opacity)}`);
                }

                usn.style.setProperty(`--usnFontSize`, `${settings.usnFont[`${role}`].value.size}px`);

                usn.style.setProperty(`--usnFontWeight`, settings.usnFont[`${role}`].value.weight);

                if (settings.usnFont[`${role}`].value.italic === true) {
                    usn.style.setProperty(`--usnFontItalic`, "italic");
                } else {
                    usn.style.setProperty(`--usnFontItalic`, "normal");
                }

                var usnFontLines = ""

                if (settings.usnFont[`${role}`].value.lines.upperLine === true) {
                    usnFontLines += "overline "
                }
                if (settings.usnFont[`${role}`].value.lines.crossLine === true) {
                    usnFontLines += "line-through "
                }
                if (settings.usnFont[`${role}`].value.lines.underLine === true) {
                    usnFontLines += "underline"
                }

                usn.style.setProperty(`--usnFontLines`, usnFontLines);

                if (settings.usnFont[`${role}`].value.height.auto === true) {
                    usn.style.setProperty(`--usnFontHeight`, "normal");
                } else if (settings.usnFont[`${role}`].value.height.auto === false) {
                    usn.style.setProperty(`--usnFontHeight`, `${settings.usnFont[`${role}`].value.height.height}px`);
                }

                usn.style.setProperty(`--usnFontSpacing`, `${settings.usnFont[`${role}`].value.spacing}px`);

                usn.style.setProperty(`--usnFontHAlign`, settings.usnFont[`${role}`].value.hAlign);
            });
        }
    });
}

function updateUsnFont(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.usnFont[`${activeRole}`].value.family = document.querySelector("#usnFontFamInp").value;
    settings.usnFont[`${activeRole}`].value.size = document.querySelector("#usnFontSizeInp").value;
    settings.usnFont[`${activeRole}`].value.weight = document.querySelector("#usnFontWeightInp").value;
    settings.usnFont[`${activeRole}`].value.height.height = document.querySelector("#usnFontHeightInp").value;
    settings.usnFont[`${activeRole}`].value.spacing = document.querySelector("#usnFontSpaceInp").value;

    if (type === "style") {
        var styleRow = document.querySelector(".usnFontStyleRow");

        if (event.target.getAttribute("data-active") === "false") {
            event.target.setAttribute("data-active", "true");
        } else {
            event.target.setAttribute("data-active", "false");
        }

        if (styleRow.querySelectorAll("button")[0].getAttribute("data-active") === "true") {
            settings.usnFont[`${activeRole}`].value.lines.upperLine = true;
        } else {
            settings.usnFont[`${activeRole}`].value.lines.upperLine = false;
        }
        if (styleRow.querySelectorAll("button")[1].getAttribute("data-active") === "true") {
            settings.usnFont[`${activeRole}`].value.lines.crossLine = true;
        } else {
            settings.usnFont[`${activeRole}`].value.lines.crossLine = false;
        }
        if (styleRow.querySelectorAll("button")[2].getAttribute("data-active") === "true") {
            settings.usnFont[`${activeRole}`].value.lines.underLine = true;
        } else {
            settings.usnFont[`${activeRole}`].value.lines.underLine = false;
        }
        if (styleRow.querySelectorAll("button")[3].getAttribute("data-active") === "true") {
            settings.usnFont[`${activeRole}`].value.italic = true;
        } else {
            settings.usnFont[`${activeRole}`].value.italic = false;
        }
    } else if (type === "hAlign") {
        Array.from(event.target.parentNode.children).forEach(elmnt => {
            elmnt.setAttribute("data-active", "false");
        });
        event.target.setAttribute("data-active", "true");

        settings.usnFont[`${activeRole}`].value.hAlign = event.target.getAttribute("data-value");
    } else if (type === "autoheight") {
        if (event.target.getAttribute("data-active") === "true") {
            event.target.setAttribute("data-active", "false");
            settings.usnFont[`${activeRole}`].value.height.auto = false;
        } else {
            event.target.setAttribute("data-active", "true");
            settings.usnFont[`${activeRole}`].value.height.auto = true;
        }
    } else if (type === "colorType") {
        settings.usnFont[`${activeRole}`].value.color.type = value;
        if (value === "custom") {
            document.querySelector(".fontColorUsnMenu").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".fontColorUsnMenu").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".fontColorUsnMenu").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".fontColorUsnMenu").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "color") {
        settings.usnFont[`${activeRole}`].value.color.color = document.querySelector("#usnFontColor").value;
    }
    
    settings.usnFont[`${activeRole}`].value.color.opacity = parseInt(document.querySelector("#usnFontOpacity").value);

    decompileUsnFont();
}

// settings.usnFontShadow

function decompileUsnFontShadow() {
    roleList.forEach(role => {
        if (settings.usnFontShadow[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");
                var usnFontShadow = "";

                for (let i = 0; i < settings.usnFontShadow[`${role}`].value.length; i++) {
                    usnFontShadow += `${settings.usnFontShadow[`${role}`].value[i].x}px ${settings.usnFontShadow[`${role}`].value[i].y}px ${settings.usnFontShadow[`${role}`].value[i].blur}px `;
                    if (settings.usnFontShadow[`${role}`].value[i].color.type === "custom") {
                        usnFontShadow += `${settings.usnFontShadow[`${role}`].value[i].color.color}${dec2hex(settings.usnFontShadow[`${role}`].value[i].color.opacity)}`;
                    } else if (settings.usnFontShadow[`${role}`].value[i].color.type === "twitch") {
                        usnFontShadow += `${usn.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.usnFontShadow[`${role}`].value[i].color.opacity)}`;
                    }
                    if (i < settings.usnFontShadow[`${role}`].value.length - 1) {
                        usnFontShadow += ", ";
                    }
                }
                usn.style.setProperty(`--usnFontShadow`, usnFontShadow);
            });
        }
    });
}

var activeUsnFontShadow = -1;

function openFontShadowUsn(triggerAdd) {
    for (let i = 0; i < settings.usnFontShadow[`${activeRole}`].value.length; i++) {
        document.querySelector(".fontShadowColUsn").querySelectorAll(".fontShadowElmnt")[i].setAttribute("data-active", "false");
    }
    
    if (!triggerAdd) {
        activeUsnFontShadow = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);
    }
    
    if (activeUsnFontShadow >= 0) {
        document.querySelector(".fontShadowSettingsUsn").setAttribute("data-active", "true");
        document.querySelector(".fontShadowColUsn").querySelectorAll(".fontShadowElmnt")[activeUsnFontShadow].setAttribute("data-active", "true");
        
        
        document.querySelector(".fontShadowSettingsUsn").querySelectorAll(".numContInput")[0].value = settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].x;
        document.querySelector(".fontShadowSettingsUsn").querySelectorAll(".numContInput")[1].value = settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].y;
        document.querySelector(".fontShadowSettingsUsn").querySelectorAll(".numContInput")[2].value = settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].blur;
        
        if (settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.type === "custom") {
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.type === "twitch") {
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
        
        document.querySelector("#usnFontShadowOpacity").value = settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.opacity;
        document.querySelector("#usnFontShadowOpacity").setAttribute("data-value", settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.opacity);
        
        document.querySelector("#usnFontShadowColor").value = settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.color;
    } else if (activeUsnFontShadow === -1) {
        document.querySelector(".fontShadowSettingsUsn").setAttribute("data-active", "false");
    }
}

function addFontShadowUsn() {
    var fontShadowElmnt = document.createElement("div");
        fontShadowElmnt.className = "fontShadowElmnt";

        fontShadowElmnt.innerHTML = `
            <button class="fontShadowElmntBtn" onclick="openFontShadowUsn()"></button>
            <button class="fontShadowElmntRmv icon" onclick="removeFontShadowUsn()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
        `;

    document.querySelector(".fontShadowColUsn").appendChild(fontShadowElmnt);

    settings.usnFontShadow[`${activeRole}`].value.push({
        x: 0, // In px
        y: 0, // In px
        blur: 0, // In px
        color: {
            type: "custom",
            color: "#000000",
            opacity: 255 // In Hex
        }
    });

    activeUsnFontShadow = settings.usnFontShadow[`${activeRole}`].value.length - 1;
    openFontShadowUsn(true);
    
    decompileUsnFontShadow();
}

function updateFontShadowUsn(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].x = parseInt(document.querySelector(".fontShadowSettingsUsn").querySelectorAll(".numContInput")[0].value);
    settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].y = parseInt(document.querySelector(".fontShadowSettingsUsn").querySelectorAll(".numContInput")[1].value);
    settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].blur = parseInt(document.querySelector(".fontShadowSettingsUsn").querySelectorAll(".numContInput")[2].value);
    
    settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.opacity = parseInt(document.querySelector("#usnFontShadowOpacity").value);
    
    if (type === "colorType") {
        settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.type = value;
        if (value === "custom") {
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
        } else if (value === "twitch") {
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
            document.querySelector(".fontShadowSettingsUsn").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
        }
    } else if (type === "color") {
        settings.usnFontShadow[`${activeRole}`].value[activeUsnFontShadow].color.color = document.querySelector("#usnFontShadowColor").value;
    }

    for (let i = 0; i < settings.usnFontShadow[`${activeRole}`].value.length; i++) {
        var usnStyle = `${settings.usnFontShadow[`${activeRole}`].value[i].x}px ${settings.usnFontShadow[`${activeRole}`].value[i].y}px ${settings.usnFontShadow[`${activeRole}`].value[i].blur}px ${settings.usnFontShadow[`${activeRole}`].value[i].color.color}${dec2hex(settings.usnFontShadow[`${activeRole}`].value[i].color.opacity)}`;
        

        document.querySelector(".fontShadowColUsn").querySelectorAll(".fontShadowElmnt")[i].style.boxShadow = usnStyle;
    }
    
    decompileUsnFontShadow();
}

function removeSwitchFontShadowUsn() {
    if (document.querySelector(".fontShadowColUsn").getAttribute("data-delete-active") === "false") {
        document.querySelector(".fontShadowColUsn").setAttribute("data-delete-active", "true");
    } else {
        document.querySelector(".fontShadowColUsn").setAttribute("data-delete-active", "false");
    }
    
    decompileUsnFontShadow();
}

function removeFontShadowUsn() {
    var i = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);

    if (i <= activeUsnFontShadow) {
        activeUsnFontShadow -= 1;
    }
    settings.usnFontShadow[`${activeRole}`].value.splice(i, 1);

    document.querySelector(".fontShadowColUsn").querySelectorAll(".fontShadowElmnt")[i].remove();

    openFontShadowUsn(true);
    
    decompileUsnFontShadow();
}

// settings.usnContent

function decompileUsnContent() {
    roleList.forEach(role => {
        if (settings.usnContent[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn");

                var usnContentFinal = "" + settings.usnContent[`${role}`].value;

                usnContentFinal = usnContentFinal.replace(/{usn}/g, usn.parentNode.parentNode.getAttribute("data-username"));

                usnContentFinal = usnContentFinal.replace(/{msg}/g, usn.parentNode.parentNode.getAttribute("data-message"));

                usnContentFinal = usnContentFinal.replace(/{streamer}/g, usn.parentNode.parentNode.getAttribute("data-streamer"));
                
                usnContentFinal = usnContentFinal.replace(/{h}/g, usn.parentNode.parentNode.getAttribute("data-h"));
                
                usnContentFinal = usnContentFinal.replace(/{hh}/g, usn.parentNode.parentNode.getAttribute("data-hh"));

                usnContentFinal = usnContentFinal.replace(/{h12}/g, usn.parentNode.parentNode.getAttribute("data-h12"));

                usnContentFinal = usnContentFinal.replace(/{hh12}/g, usn.parentNode.parentNode.getAttribute("data-hh12"));

                usnContentFinal = usnContentFinal.replace(/{apm}/g, usn.parentNode.parentNode.getAttribute("data-apm"));
                
                usnContentFinal = usnContentFinal.replace(/{m}/g, usn.parentNode.parentNode.getAttribute("data-m"));
                
                usnContentFinal = usnContentFinal.replace(/{mm}/g, usn.parentNode.parentNode.getAttribute("data-mm"));
                
                usnContentFinal = usnContentFinal.replace(/{s}/g, usn.parentNode.parentNode.getAttribute("data-s"));
                
                usnContentFinal = usnContentFinal.replace(/{ss}/g, usn.parentNode.parentNode.getAttribute("data-ss"));

                usnContentFinal = usnContentFinal.replace(/{badges}/g, usn.parentNode.parentNode.getAttribute("data-badges"));

                usn.innerHTML = usnContentFinal;
            });
        }
    });
}

function updateUsnContent() {
    settings.usnContent[`${activeRole}`].value = document.querySelector(".usnContentInp").value;

    decompileUsnContent();
}

// settings.msgBackground

function decompileMsgBG() {
    roleList.forEach(role => {
        if (settings.msgBackground[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                msgBackground = "",
                msgBackgroundPos = "",
                msgBackgroundSize = "";
                for (let i = 0; i < settings.msgBackground[`${role}`].value.length; i++) {
                    if (settings.msgBackground[`${role}`].value[i].type === "solid") {
                        if (settings.msgBackground[`${role}`].value[i].colors[0].type === "custom") {
                            msgBackground += `linear-gradient(${settings.msgBackground[`${role}`].value[i].colors[0].color}${dec2hex(settings.msgBackground[`${role}`].value[i].colors[0].opacity)}, ${settings.msgBackground[`${role}`].value[i].colors[0].color}${dec2hex(settings.msgBackground[`${role}`].value[i].colors[0].opacity)})`;
                        } else if (settings.msgBackground[`${role}`].value[i].colors[0].type === "twitch") {
                            msgBackground += `linear-gradient(${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgBackground[`${role}`].value[i].colors[0].opacity)}, ${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgBackground[`${role}`].value[i].colors[0].opacity)})`;
                        }
                    } else if (settings.msgBackground[`${role}`].value[i].type === "linear") {
                        var sortedColors = [...settings.msgBackground[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        msgBackground += `linear-gradient(${settings.msgBackground[`${role}`].value[i].rotate}deg, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            if (sortedColors[j].type === "custom") {
                                msgBackground += `${sortedColors[j].color}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            } else if (sortedColors[j].type === "twitch") {
                                msgBackground += `${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`
                            }
                            
                            if (j < settings.msgBackground[`${role}`].value[i].colors.length - 1) {
                                msgBackground += ", "
                            } else if (j === settings.msgBackground[`${role}`].value[i].colors.length - 1) {
                                msgBackground += ")";
                            }
                        }
                    } else if (settings.msgBackground[`${role}`].value[i].type === "radial") {
                        var sortedColors = [...settings.msgBackground[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        msgBackground += `radial-gradient(${settings.msgBackground[`${role}`].value[i].size} at ${settings.msgBackground[`${role}`].value[i].x}% ${settings.msgBackground[`${role}`].value[i].y}%, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            if (sortedColors[j].type === "custom") {
                                msgBackground += `${sortedColors[j].color}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            } else if (sortedColors[j].type === "twitch") {
                                msgBackground += `${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`
                            }
                            
                            if (j < settings.msgBackground[`${role}`].value[i].colors.length - 1) {
                                msgBackground += ", "
                            } else if (j === settings.msgBackground[`${role}`].value[i].colors.length - 1) {
                                msgBackground += ")";
                            }
                        }
                    }

                    msgBackgroundPos += `calc(${settings.msgBackground[`${role}`].value[i].posX.percent}% + ${settings.msgBackground[`${role}`].value[i].posX.px}px) calc(${settings.msgBackground[`${role}`].value[i].posY.percent}% + ${settings.msgBackground[`${role}`].value[i].posY.px}px)`;
                    msgBackgroundSize += `calc(${settings.msgBackground[`${role}`].value[i].width.percent}% + ${settings.msgBackground[`${role}`].value[i].width.px}px) calc(${settings.msgBackground[`${role}`].value[i].height.percent}% + ${settings.msgBackground[`${role}`].value[i].height.px}px)`;

                    if (i < settings.msgBackground[`${role}`].value.length - 1) {
                        msgBackground += `, `;
                        msgBackgroundPos += `, `;
                        msgBackgroundSize += `, `;
                    }
                }
                
                cbxW.style.setProperty(`--msgBackground`, msgBackground);
                cbxW.style.setProperty(`--msgBackgroundPos`, msgBackgroundPos);
                cbxW.style.setProperty(`--msgBackgroundSize`, msgBackgroundSize);
            });
        }
    });
}

function updateColorSliderMsgBGBox() {
    for (let i = 0; i < document.querySelectorAll(".colorSliderMsgBGCont").length; i++) {
        if (settings.msgBackground[`${activeRole}`].value[i].type !== "solid") {
            
            var msgBGPrev = "linear-gradient(90deg, ",
                nodeList = document.querySelectorAll(".colorSliderMsgBGCont")[i].querySelectorAll(".colorSliderMsgBG"),
                colorList = settings.msgBackground[`${activeRole}`].value[i].colors;

            for (let j = 0; j < settings.msgBackground[`${activeRole}`].value[i].colors.length; j++) {
                settings.msgBackground[`${activeRole}`].value[i].colors[j].count = 0;
                colorList[j].position = parseFloat(nodeList[j].value);
                nodeList[j].style.setProperty("--value", `${nodeList[j].value}%`);
                nodeList[j].style.setProperty("--valueTxt", `"${nodeList[j].value}"`);
            }

            for (let j = 0; j < settings.msgBackground[`${activeRole}`].value[i].colors.length; j++) {
                for (let k = 0; k < settings.msgBackground[`${activeRole}`].value[i].colors.length; k++) {
                    if (k !== j) {
                        if (settings.msgBackground[`${activeRole}`].value[i].colors[j].position >= settings.msgBackground[`${activeRole}`].value[i].colors[k].position) {
                            settings.msgBackground[`${activeRole}`].value[i].colors[j].count += 1;
                        }
                    }
                }
            }

            for (let j = 0; j < settings.msgBackground[`${activeRole}`].value[i].colors.length; j++) {
                var resultElmnt = settings.msgBackground[`${activeRole}`].value[i].colors.find(findElmnt => findElmnt.count === j);
                msgBGPrev += `${resultElmnt.color}${dec2hex(resultElmnt.opacity)} ${resultElmnt.position}%`;
                
                if (j < settings.msgBackground[`${activeRole}`].value[i].colors.length - 1) {
                    msgBGPrev += ", ";
                } else {
                    msgBGPrev += ")";
                }
            }

            document.querySelectorAll(".colorSliderMsgBGCont")[i].style.backgroundImage = msgBGPrev;
        } else {
            var msgBGPrev = `${settings.msgBackground[`${activeRole}`].value[i].colors[0].color}${dec2hex(settings.msgBackground[`${activeRole}`].value[i].colors[0].opacity)}`;
            document.querySelectorAll(".colorSliderMsgBGCont")[i].style.backgroundColor = msgBGPrev;
        }
    }
    
    decompileMsgBG();
}

var activeMsgBGGrad = 0;
var activeMsgBGColor = 0;

function openColorMsgBGBox(grdNum, clrNum) {
    var open = true;

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });

    event.target.parentNode.setAttribute("data-color-show", open);

    activeMsgBGGrad = grdNum;
    activeMsgBGColor = clrNum;
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].setAttribute("data-color-show", "true");
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].setAttribute("data-set-show", "false");
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].setAttribute("data-size-show", "false");
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeInput").value = settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].color;
    if (settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].type === "custom") {
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
    } else if (settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].type === "twitch") {
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
    }
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeOpacity").value = settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].opacity;
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeOpacity").setAttribute("data-value", settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].opacity);
    document.querySelectorAll(".colorSliderMsgBG").forEach(msgCont => {
        msgCont.setAttribute("data-active", "false");
    });
    document.querySelectorAll(".colorSliderMsgBGCont")[activeMsgBGGrad].querySelectorAll(".colorSliderMsgBG")[activeMsgBGColor].setAttribute("data-active", "true");
}

function updateNameMsgBGBox() {
    for (var i = 0; i < document.querySelectorAll(".backgroundNameMsgBG").length; i++) {
        settings.msgBackground[`${activeRole}`].value[i].name = document.querySelectorAll(".backgroundNameMsgBG")[i].value;
    }
}

function updateColorMsgBGBox(type) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    if (type) {settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].type = type;}
    
    if (type === "custom") {
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");

    } else if (type === "twitch") {
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
    }
    settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].color = document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeInput").value;
    settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors[activeMsgBGColor].opacity = parseInt(document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelector(".colorChangeOpacity").value);
    updateColorSliderMsgBGBox();
    
    decompileMsgBG();
}

function deleteColorMsgBGBox() {
    settings.msgBackground[`${activeRole}`].value[activeMsgBGGrad].colors.splice(activeMsgBGColor, 1);
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelectorAll(".colorSliderMsgBG")[activeMsgBGColor].remove();
    updateColorSliderMsgBGBox();
    for (let i = 0; i < document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelectorAll(".colorSliderMsgBG").length; i++) {
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].querySelectorAll(".colorSliderMsgBG")[i].setAttribute("onpointerdown", `openColorMsgBGBox(${activeMsgBGGrad}, ${i})`);
    }
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[activeMsgBGGrad].setAttribute("data-color-show", "false");
    activeMsgBGGrad = undefined;
    activeMsgBGColor = undefined;

    for (let j = 0; j < settings.msgBackground[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.msgBackground[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorMsgBGBox(${j}, ${k})`)
        }
    }
    
    decompileMsgBG();
}

function addColorSliderMsgBG(e) {
    i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    var newSlider = document.createElement("input");newSlider.className = "colorSlider colorSliderMsgBG";newSlider.setAttribute("oninput", "updateColorSliderMsgBGBox()");newSlider.setAttribute("onpointerdown", `openColorMsgBGBox(${i}, ${e.target.parentNode.querySelectorAll(".colorSlider").length})`);newSlider.type = "range";newSlider.value = (e.layerX / e.target.clientWidth) * 100;newSlider.min = "0";newSlider.max = "100";newSlider.step = "0.1";newSlider.setAttribute("data-active", "true");
                
    document.querySelectorAll(".colorSliderMsgBGCont")[i].appendChild(newSlider);

    settings.msgBackground[`${activeRole}`].value[i].colors.push({
        position: newSlider.value, // In %
        type: "custom",
        color: "#ffffff",
        opacity: 255, // In Hex
        count: 0
    });
    updateColorSliderMsgBGBox();
    openColorMsgBGBox(i, e.target.parentNode.querySelectorAll(".colorSlider").length - 1);
    
    updateColorSliderMsgBGBox();
    
    decompileMsgBG();
}

function hideColorMsgBGBox() {
    document.querySelectorAll(".colorSliderMsgBGCont")[activeMsgBGGrad].querySelectorAll(".colorSliderMsgBG")[activeMsgBGColor].setAttribute("data-active", "false");
    activeMsgBGGrad = undefined;
    activeMsgBGColor = undefined;
    event.target.parentNode.parentNode.setAttribute("data-color-show", "false");
}

function switchSetMsgBGBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-set-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderMsgBG").forEach(msgCont => {
        msgCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-set-show", open);
}

function switchSizeMsgBGBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-size-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderMsgBG").forEach(msgCont => {
        msgCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-size-show", open);
}

function addGradientMsgBG(type, index) {
    var indexPlace;
    if (index === undefined) {
        indexPlace = 0;
        if (type === "solid") {
            settings.msgBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "solid",
                name: `Background ${settings.msgBackground[`${activeRole}`].value.length + 1}`,
                colors: [
                    {
                        position:0,
                        type: "custom",
                        color:"#ffffff",
                        opacity:255,
                        count:0
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameMsgBG backgroundName" type="text" value="${settings.msgBackground[`${activeRole}`].value[0].name}" oninput="updateNameMsgBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientMsgBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderMsgBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderMsgBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderMsgBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Solid</div>
                            <div class="colorSliderAdd colorSliderMsgBGAdd"></div>
                            <div class="colorSliderCont colorSliderMsgBGCont" style="background-color:#ffffff;">
                                <input class="colorSlider colorSliderMsgBG" oninput="updateColorSliderMsgBGBox()" onpointerdown="openColorMsgBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorMsgBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorMsgBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorMsgBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorMsgBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorMsgBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorMsgBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeMsgBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "linear") {
            settings.msgBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "linear",
                name: `Background ${settings.msgBackground[`${activeRole}`].value.length + 1}`,
                rotate: 90, // In deg
                colors: [
                    {
                        position: 0, // In %
                        type: "custom",
                        color: "#000000",
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        type: "custom",
                        color: "#ffffff",
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameMsgBG backgroundName" type="text" value="${settings.msgBackground[`${activeRole}`].value[0].name}" oninput="updateNameMsgBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientMsgBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderMsgBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderMsgBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderMsgBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Linear</div>
                            <div class="colorSliderAdd colorSliderMsgBGAdd" onclick="addColorSliderMsgBG(event)"></div>
                            <div class="colorSliderCont colorSliderMsgBGCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderMsgBG" oninput="updateColorSliderMsgBGBox()" onpointerdown="openColorMsgBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderMsgBG" oninput="updateColorSliderMsgBGBox()" onpointerdown="openColorMsgBGBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorMsgBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorMsgBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorMsgBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorMsgBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorMsgBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorMsgBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetMsgBGBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">rotation:</span>
                                <input class="numContInput" type="number" value="90" oninput="updateLinearRotMsgBG(event)">
                                <span class="numContUnit">°</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeMsgBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "radial") {
            settings.msgBackground[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "radial",
                name: `Background ${settings.msgBackground[`${activeRole}`].value.length + 1}`,
                size: "farthest-corner", // farthest/closest - corner/side, circle
                x: 50, // In %
                y: 50, // In %
                colors: [
                    {
                        position: 0, // In %
                        type: "custom",
                        color: "#000000",
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        type: "custom",
                        color: "#ffffff",
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameMsgBG backgroundName" type="text" value="${settings.msgBackground[`${activeRole}`].value[0].name}" oninput="updateNameMsgBGBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientMsgBG(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderMsgBG(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderMsgBG(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderMsgBG()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Radial</div>
                            <div class="colorSliderAdd colorSliderMsgBGAdd" onclick="addColorSliderMsgBG(event)"></div>
                            <div class="colorSliderCont colorSliderMsgBGCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderMsgBG" oninput="updateColorSliderMsgBGBox()" onpointerdown="openColorMsgBGBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderMsgBG" oninput="updateColorSliderMsgBGBox()" onpointerdown="openColorMsgBGBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorMsgBGBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <div class="colorChangeType selectItemRow">
                            <button class="icon" onclick="updateColorMsgBGBox('custom')"><input type="color" class="colorChangeInput" oninput="updateColorMsgBGBox()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Color.svg"></button>
                            <button class="icon" onclick="updateColorMsgBGBox('twitch')" title="Uses the color the user uses in the Twitch chat"><img class="iconSVG descrIconSVG" src="Icons/Diverse/TwitchColor.svg"></button>
                            <button class="icon colorDeleteBtn" onclick="deleteColorMsgBGBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorMsgBGBox()" data-value="255" title="Changes the opacity of the selected color">
                        <div class="presetCont">
                            <div class="presetList" data-delete-show="false">${insertPreset()}</div>
                            <button class="presetAdd" onclick="addPreset()"><img class="iconSVG" src="Icons/Diverse/Add.svg"></button>
                            <button class="presetShowDelete" onclick="showDeletePreset()"><img class="iconSVG" src="Icons/Diverse/Remove.svg"></button>
                        </div>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetMsgBGBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="singleChoiceList gradRadialPosContMsgBG">
                            <button data-active="true" onclick="updateRadialTypeMsgBG(event, 'farthest-corner')">Farthest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeMsgBG(event, 'farthest-side')">Farthest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeMsgBG(event, 'closest-corner')">Closest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeMsgBG(event, 'closest-side')">Closest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeMsgBG(event, 'circle')">Circle</button>
                        </div>
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">x:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosMsgBG(event, 'x')">
                                <span class="numContUnit">%</span>
                            </div>
                            <div class="numCont">
                                <span class="numContDescr">y:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosMsgBG(event, 'y')">
                                <span class="numContUnit">%</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeMsgBGBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgBGSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgBGSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgBGSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgBGSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgBGSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        }
        document.querySelector(".colorMenuColMsgBG").prepend(colorMenu);
    } else {
        indexPlace = index;

        var menuOpt = JSON.parse(JSON.stringify(settings.msgBackground[`${activeRole}`].value[indexPlace]));
        settings.msgBackground[`${activeRole}`].value.splice(indexPlace, 0, menuOpt);

        var colorMenuNode = document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[indexPlace].cloneNode(true);
        colorMenuNode.setAttribute("data-color-show", "false");
        colorMenuNode.setAttribute("data-set-show", "false");
        colorMenuNode.setAttribute("data-size-show", "false");
        document.querySelector(".colorMenuColMsgBG").insertBefore(colorMenuNode, document.querySelector(".colorMenuColMsgBG").children[indexPlace]);
    }
    
    for (var i = 0; i < document.querySelectorAll(".colorSliderMsgBGCont").length; i++) {
        for (var j = 0; j < document.querySelectorAll(".colorSliderMsgBGCont")[i].querySelectorAll(".colorSlider").length; j++) {
            document.querySelectorAll(".colorSliderMsgBGCont")[i].querySelectorAll(".colorSlider")[j].setAttribute("onpointerdown", `openColorMsgBGBox(${i}, ${j})`);
        }
    }
    
    updateColorSliderMsgBGBox();
    decompileMsgBG();
}

function removeGradientMsgBG(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode);
    if (i < activeMsgBGGrad) {
        activeMsgBGGrad -= 1;
    }
    settings.msgBackground[`${activeRole}`].value.splice(i, 1);
    document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[i].remove();
    for (let j = 0; j < document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu").length; j++) {
        for (let k = 0; k < document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider").length; k++) {
            document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorMsgBGBox(${j}, ${k})`)
        }
    }
    
    decompileMsgBG();
}

function updateRadialTypeMsgBG(e, size) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    settings.msgBackground[`${activeRole}`].value[i].size = size;
    for (let j = 0; j < settings.msgBackground[`${activeRole}`].value.length; j++) {
        if (settings.msgBackground[`${activeRole}`].value[j].type === "radial") {
            for (let k = 0; k < document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContMsgBG").querySelectorAll("button").length; k++) {
                document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContMsgBG").querySelectorAll("button")[k].setAttribute("data-active", "false");
            }
            e.target.setAttribute("data-active", "true");
        }
    }
    
    decompileMsgBG();
}

function updateLinearRotMsgBG(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    settings.msgBackground[`${activeRole}`].value[i].rotate = parseInt(e.target.value);
    
    decompileMsgBG();
}

function updateRadialPosMsgBG(e, xy) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    if (xy === "x") {
        settings.msgBackground[`${activeRole}`].value[i].x = parseInt(e.target.value);
    } else if (xy === "y") {
        settings.msgBackground[`${activeRole}`].value[i].y = parseInt(e.target.value);
    }
    
    decompileMsgBG();
}

function moveColorSliderMsgBG(e, dir) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    if (dir === "up" && i > 0) {
        var elmnt = settings.msgBackground[`${activeRole}`].value[i];
        settings.msgBackground[`${activeRole}`].value.splice(i, 1);
        settings.msgBackground[`${activeRole}`].value.splice(i - 1, 0, elmnt);
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[i - 1].before(document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[i]);
        if (activeMsgBGGrad === i) {
            activeMsgBGGrad -= 1;
        } else if (activeMsgBGGrad === i - 1) {
            activeMsgBGGrad += 1;
        }
    } else if (dir === "down" && i < settings.msgBackground[`${activeRole}`].value.length - 1) {
        var elmnt = settings.msgBackground[`${activeRole}`].value[i];
        settings.msgBackground[`${activeRole}`].value.splice(i, 1);
        settings.msgBackground[`${activeRole}`].value.splice(i + 1, 0, elmnt);
        document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[i + 1].after(document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[i]);
        if (activeMsgBGGrad === i) {
            activeMsgBGGrad += 1;
        } else if (activeMsgBGGrad === i + 1) {
            activeMsgBGGrad -= 1;
        }
    }

    for (let j = 0; j < settings.msgBackground[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.msgBackground[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColMsgBG").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorMsgBGBox(${j}, ${k})`)
        }
    }
    
    decompileMsgBG();
}

function duplicateColorSliderMsgBG() {
    activeMsgBGGrad += 1;
    var i = Array.from(event.target.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode);
    var type = settings.msgBackground[`${activeRole}`].value[i].type;

    addGradientMsgBG(type, i);
}

function updateMsgBGSizePos(cat, value) {
    var i = Array.from(event.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode.parentNode);
    if (cat === "posX") {
        if (value === "%") {
            settings.msgBackground[`${activeRole}`].value[i].posX.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackground[`${activeRole}`].value[i].posX.px = parseInt(event.target.value);
        }
    } else if (cat === "posY") {
        if (value === "%") {
            settings.msgBackground[`${activeRole}`].value[i].posY.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackground[`${activeRole}`].value[i].posY.px = parseInt(event.target.value);
        }
    } else if (cat === "width") {
        if (value === "%") {
            settings.msgBackground[`${activeRole}`].value[i].width.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackground[`${activeRole}`].value[i].width.px = parseInt(event.target.value);
        }
    } else if (cat === "height") {
        if (value === "%") {
            settings.msgBackground[`${activeRole}`].value[i].height.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackground[`${activeRole}`].value[i].height.px = parseInt(event.target.value);
        }
    }
    
    decompileMsgBG();
}

// settings.msgBackgroundMask

var activeMsgMaskGrad = 0;
var activeMsgMaskColor = 0;

function decompileMsgMask() {
    roleList.forEach(role => {
        if (settings.msgBackgroundMask[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msgBackgroundMask = "",
                    msgBackgroundMaskPos = "",
                    msgBackgroundMaskSize = "";
                for (let i = 0; i < settings.msgBackgroundMask[`${role}`].value.length; i++) {
                    if (settings.msgBackgroundMask[`${role}`].value[i].type === "solid") {
                        msgBackgroundMask += `linear-gradient(#ffffff${dec2hex(settings.msgBackgroundMask[`${role}`].value[i].colors[0].opacity)}, #ffffff${dec2hex(settings.msgBackgroundMask[`${role}`].value[i].colors[0].opacity)})`;
                    } else if (settings.msgBackgroundMask[`${role}`].value[i].type === "linear") {
                        var sortedColors = [...settings.msgBackgroundMask[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        msgBackgroundMask += `linear-gradient(${settings.msgBackgroundMask[`${role}`].value[i].rotate}deg, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            msgBackgroundMask += `#ffffff${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            
                            if (j < settings.msgBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                msgBackgroundMask += ", "
                            } else if (j === settings.msgBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                msgBackgroundMask += ")";
                            }
                        }
                    } else if (settings.msgBackgroundMask[`${role}`].value[i].type === "radial") {
                        var sortedColors = [...settings.msgBackgroundMask[`${role}`].value[i].colors].sort((a, b) => {return a.count - b.count});
                        msgBackgroundMask += `radial-gradient(${settings.msgBackgroundMask[`${role}`].value[i].size} at ${settings.msgBackgroundMask[`${role}`].value[i].x}% ${settings.msgBackgroundMask[`${role}`].value[i].y}%, `;
                        for (let j = 0; j < sortedColors.length; j++) {
                            msgBackgroundMask += `#ffffff${dec2hex(sortedColors[j].opacity)} ${sortedColors[j].position}%`;
                            
                            if (j < settings.msgBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                msgBackgroundMask += ", "
                            } else if (j === settings.msgBackgroundMask[`${role}`].value[i].colors.length - 1) {
                                msgBackgroundMask += ")";
                            }
                        }
                    }

                    msgBackgroundMaskPos += `calc(${settings.msgBackgroundMask[`${role}`].value[i].posX.percent}% + ${settings.msgBackgroundMask[`${role}`].value[i].posX.px}px) calc(${settings.msgBackgroundMask[`${role}`].value[i].posY.percent}% + ${settings.msgBackgroundMask[`${role}`].value[i].posY.px}px)`;
                    msgBackgroundMaskSize += `calc(${settings.msgBackgroundMask[`${role}`].value[i].width.percent}% + ${settings.msgBackgroundMask[`${role}`].value[i].width.px}px) calc(${settings.msgBackgroundMask[`${role}`].value[i].height.percent}% + ${settings.msgBackgroundMask[`${role}`].value[i].height.px}px)`;

                    if (i < settings.msgBackgroundMask[`${role}`].value.length - 1) {
                        msgBackgroundMask += `, `;
                        msgBackgroundMaskPos += `, `;
                        msgBackgroundMaskSize += `, `;
                    }
                }
                
                cbxW.style.setProperty(`--msgBackgroundMask`, msgBackgroundMask);
                cbxW.style.setProperty(`--msgBackgroundMaskPos`, msgBackgroundMaskPos);
                cbxW.style.setProperty(`--msgBackgroundMaskSize`, msgBackgroundMaskSize);
            });
        }
    });
}

function updateColorSliderMsgMaskBox() {
    for (let i = 0; i < document.querySelectorAll(".colorSliderMsgMaskCont").length; i++) {
        if (settings.msgBackgroundMask[`${activeRole}`].value[i].type !== "solid") {
            
            var msgMaskPrev = "linear-gradient(90deg, ",
                nodeList = document.querySelectorAll(".colorSliderMsgMaskCont")[i].querySelectorAll(".colorSliderMsgMask"),
                colorList = settings.msgBackgroundMask[`${activeRole}`].value[i].colors;

            for (let j = 0; j < settings.msgBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                settings.msgBackgroundMask[`${activeRole}`].value[i].colors[j].count = 0;
                colorList[j].position = parseFloat(nodeList[j].value);
                nodeList[j].style.setProperty("--value", `${nodeList[j].value}%`);
                nodeList[j].style.setProperty("--valueTxt", `"${nodeList[j].value}"`);
            }

            for (let j = 0; j < settings.msgBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                for (let k = 0; k < settings.msgBackgroundMask[`${activeRole}`].value[i].colors.length; k++) {
                    if (k !== j) {
                        if (settings.msgBackgroundMask[`${activeRole}`].value[i].colors[j].position >= settings.msgBackgroundMask[`${activeRole}`].value[i].colors[k].position) {
                            settings.msgBackgroundMask[`${activeRole}`].value[i].colors[j].count += 1;
                        }
                    }
                }
            }

            for (let j = 0; j < settings.msgBackgroundMask[`${activeRole}`].value[i].colors.length; j++) {
                var resultElmnt = settings.msgBackgroundMask[`${activeRole}`].value[i].colors.find(findElmnt => findElmnt.count === j);
                msgMaskPrev += `#ffffff${dec2hex(resultElmnt.opacity)} ${resultElmnt.position}%`;
                
                if (j < settings.msgBackgroundMask[`${activeRole}`].value[i].colors.length - 1) {
                    msgMaskPrev += ", ";
                } else {
                    msgMaskPrev += ")";
                }
            }

            document.querySelectorAll(".colorSliderMsgMaskCont")[i].style.backgroundImage = msgMaskPrev;
        } else {
            var msgMaskPrev = `#ffffff${dec2hex(settings.msgBackgroundMask[`${activeRole}`].value[i].colors[0].opacity)}`;
            document.querySelectorAll(".colorSliderMsgMaskCont")[i].style.backgroundColor = msgMaskPrev;
        }
    }
    decompileMsgMask();
}

function openColorMsgMaskBox(grdNum, clrNum) {
    var open = true;

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });

    event.target.parentNode.setAttribute("data-color-show", open);
    
    activeMsgMaskGrad = grdNum;
    activeMsgMaskColor = clrNum;
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].setAttribute("data-color-show", "true");
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].setAttribute("data-set-show", "false");
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].setAttribute("data-size-show", "false");
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].querySelector(".colorChangeOpacity").value = settings.msgBackgroundMask[`${activeRole}`].value[activeMsgMaskGrad].colors[activeMsgMaskColor].opacity;
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].querySelector(".colorChangeOpacity").setAttribute("data-value", settings.msgBackgroundMask[`${activeRole}`].value[activeMsgMaskGrad].colors[activeMsgMaskColor].opacity);
    document.querySelectorAll(".colorSliderMsgMask").forEach(msgCont => {
        msgCont.setAttribute("data-active", "false");
    });
    document.querySelectorAll(".colorSliderMsgMaskCont")[activeMsgMaskGrad].querySelectorAll(".colorSliderMsgMask")[activeMsgMaskColor].setAttribute("data-active", "true");
}

function updateNameMsgMaskBox() {
    for (var i = 0; i < document.querySelectorAll(".backgroundNameMsgMask").length; i++) {
        settings.msgBackgroundMask[`${activeRole}`].value[i].name = document.querySelectorAll(".backgroundNameMsgMask")[i].value;
    }
}

function updateColorMsgMaskBox(type) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    
    settings.msgBackgroundMask[`${activeRole}`].value[activeMsgMaskGrad].colors[activeMsgMaskColor].opacity = parseInt(document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].querySelector(".colorChangeOpacity").value);
    updateColorSliderMsgMaskBox();

    decompileMsgMask();
}

function deleteColorMsgMaskBox() {
    settings.msgBackgroundMask[`${activeRole}`].value[activeMsgMaskGrad].colors.splice(activeMsgMaskColor, 1);
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].querySelectorAll(".colorSliderMsgMask")[activeMsgMaskColor].remove();
    updateColorSliderMsgMaskBox();
    for (let i = 0; i < document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].querySelectorAll(".colorSliderMsgMask").length; i++) {
        document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].querySelectorAll(".colorSliderMsgMask")[i].setAttribute("onpointerdown", `openColorMsgMaskBox(${activeMsgMaskGrad}, ${i})`);
    }
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[activeMsgMaskGrad].setAttribute("data-color-show", "false");
    activeMsgMaskGrad = undefined;
    activeMsgMaskColor = undefined;

    for (let j = 0; j < settings.msgBackgroundMask[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.msgBackgroundMask[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorMsgMaskBox(${j}, ${k})`)
        }
    }

    decompileMsgMask();
}

function addColorSliderMsgMask(e) {
    i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    document.querySelectorAll(".colorSlider").forEach(slider => {
        slider.setAttribute("data-active", "false");
    })
    var newSlider = document.createElement("input");newSlider.className = "colorSlider colorSliderMsgMask";newSlider.setAttribute("oninput", "updateColorSliderMsgMaskBox()");newSlider.setAttribute("onpointerdown", `openColorMsgMaskBox(${i}, ${e.target.parentNode.querySelectorAll(".colorSlider").length})`);newSlider.type = "range";newSlider.value = (e.layerX / e.target.clientWidth) * 100;newSlider.min = "0";newSlider.max = "100";newSlider.step = "0.1";newSlider.setAttribute("data-active", "true");
                
    document.querySelectorAll(".colorSliderMsgMaskCont")[i].appendChild(newSlider);

    settings.msgBackgroundMask[`${activeRole}`].value[i].colors.push({
        position: newSlider.value, // In %
        opacity: 255, // In Hex
        count: 0
    });
    updateColorSliderMsgMaskBox();
    openColorMsgMaskBox(i, e.target.parentNode.querySelectorAll(".colorSlider").length - 1);
    
    updateColorSliderMsgMaskBox();
    
    decompileMsgMask();
}

function hideColorMsgMaskBox() {
    document.querySelectorAll(".colorSliderMsgMaskCont")[activeMsgMaskGrad].querySelectorAll(".colorSliderMsgMask")[activeMsgMaskColor].setAttribute("data-active", "false");
    activeMsgMaskGrad = undefined;
    activeMsgMaskColor = undefined;
    event.target.parentNode.parentNode.setAttribute("data-color-show", "false");
}

function switchSetMsgMaskBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-set-show") === "true") {
        open = false;
    }

    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderMsgMask").forEach(msgCont => {
        msgCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-set-show", open);
}

function switchSizeMsgMaskBox() {
    var open = true;

    if (event.target.parentNode.getAttribute("data-size-show") === "true") {
        open = false;
    }
    
    document.querySelectorAll(".colorMenu").forEach(menu => {
        menu.setAttribute("data-color-show", "false");
        menu.setAttribute("data-set-show", "false");
        menu.setAttribute("data-size-show", "false");
    });
    
    document.querySelectorAll(".colorSliderMsgMask").forEach(msgCont => {
        msgCont.setAttribute("data-active", "false");
    });

    event.target.parentNode.setAttribute("data-size-show", open);
}

function addGradientMsgMask(type, index) {
    var indexPlace;
    if (index === undefined) {
        indexPlace = 0;
        if (type === "solid") {
            settings.msgBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "solid",
                name: `Mask ${settings.msgBackgroundMask[`${activeRole}`].value.length + 1}`,
                colors: [
                    {
                        position:0,
                        opacity:255,
                        count:0
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameMsgMask backgroundName" type="text" value="${settings.msgBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameMsgMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientMsgMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderMsgMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderMsgMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderMsgMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Solid</div>
                            <div class="colorSliderAdd colorSliderMsgMaskAdd"></div>
                            <div class="colorSliderCont colorSliderMsgMaskCont" style="background-color:#ffffff;">
                                <input class="colorSlider colorSliderMsgMask" oninput="updateColorSliderMsgMaskBox()" onpointerdown="openColorMsgMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorMsgMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorMsgMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorMsgMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeMsgMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "linear") {
            settings.msgBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "linear",
                name: `Mask ${settings.msgBackgroundMask[`${activeRole}`].value.length + 1}`,
                rotate: 90, // In deg
                colors: [
                    {
                        position: 0, // In %
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameMsgMask backgroundName" type="text" value="${settings.msgBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameMsgMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientMsgMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderMsgMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderMsgMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderMsgMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Linear</div>
                            <div class="colorSliderAdd colorSliderMsgMaskAdd" onclick="addColorSliderMsgMask(event)"></div>
                            <div class="colorSliderCont colorSliderMsgMaskCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderMsgMask" oninput="updateColorSliderMsgMaskBox()" onpointerdown="openColorMsgMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderMsgMask" oninput="updateColorSliderMsgMaskBox()" onpointerdown="openColorMsgMaskBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorMsgMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorMsgMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorMsgMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetMsgMaskBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">rotation:</span>
                                <input class="numContInput" type="number" value="90" oninput="updateLinearRotMsgMask(event)">
                                <span class="numContUnit">°</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeMsgMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        } else if (type === "radial") {
            settings.msgBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, {
                type: "radial",
                name: `Mask ${settings.msgBackgroundMask[`${activeRole}`].value.length + 1}`,
                size: "farthest-corner", // farthest/closest - corner/side, circle
                x: 50, // In %
                y: 50, // In %
                colors: [
                    {
                        position: 0, // In %
                        opacity: 255, // In Hex
                        count: 0
                    }, {
                        position: 100, // In %
                        opacity: 255, // In Hex
                        count: 1
                    }
                ],
                posX: {
                    percent: 50,
                    px: 0
                },
                posY: {
                    percent: 50,
                    px: 0
                },
                width: {
                    percent: 100,
                    px: 0
                },
                height: {
                    percent: 100,
                    px: 0
                }
            });
            var colorMenu = document.createElement("div");
                colorMenu.className = "colorMenu";
                colorMenu.setAttribute("data-color-show", "false");
                colorMenu.setAttribute("data-set-show", "false");
                colorMenu.setAttribute("data-size-show", "false");
                colorMenu.innerHTML = `
                    <div class="colorSliderAddRow">
                        <input class="backgroundNameMsgMask backgroundName" type="text" value="${settings.msgBackgroundMask[`${activeRole}`].value[0].name}" oninput="updateNameMsgMaskBox()">
                        <button class="colorSliderRmv icon" onclick="removeGradientMsgMask(event)" title="Removes this background"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <div class="colorSliderAddRow">
                        <div class="colorSliderMoveCont">
                            <button class="colorSliderMoveUp icon" onclick="moveColorSliderMsgMask(event, 'up')" title="Moves this background one layer to the top"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                            <button class="colorSliderMoveDown icon" onclick="moveColorSliderMsgMask(event, 'down')" title="Moves this background one layer to the bottom"><img class="iconSVG" src="Icons/Diverse/DownLite.svg"></button>
                        </div>
                        <button class="colorSliderDuplicate icon" onclick="duplicateColorSliderMsgMask()" title="Duplicates this background to a new layer"><img class="iconSVG" src="Icons/Diverse/Copy.svg"></button>
                        <div class="colorSliderAddCont">
                            <div class="colorSliderDescr">Radial</div>
                            <div class="colorSliderAdd colorSliderMsgMaskAdd" onclick="addColorSliderMsgMask(event)"></div>
                            <div class="colorSliderCont colorSliderMsgMaskCont" style="background-image: linear-gradient(90deg, #000000 0%, #ffffff 100%);">
                                <input class="colorSlider colorSliderMsgMask" oninput="updateColorSliderMsgMaskBox()" onpointerdown="openColorMsgMaskBox(0, 0)" type="range" value="0" min="0" max="100" step="0.1">
                                <input class="colorSlider colorSliderMsgMask" oninput="updateColorSliderMsgMaskBox()" onpointerdown="openColorMsgMaskBox(0, 1)" type="range" value="100" min="0" max="100" step="0.1">
                            </div>
                        </div>
                    </div>
                    <div class="colorChangeCont">
                        <button class="hideColorBtn" onclick="hideColorMsgMaskBox()" title="Hides the color panel"><img class="iconSVG" src="Icons/Diverse/UpLite.svg"></button>
                        <input type="range" class="colorChangeOpacity" value="0" min="0" max="255" step="1" oninput="updateColorMsgMaskBox()" data-value="255" title="Changes the opacity of the selected color">
                        <button class="icon colorDeleteBtn" onclick="deleteColorMsgMaskBox()" title="Removes the selected color"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
                    </div>
                    <button class="showGradSpecBtn" onclick="switchSetMsgMaskBox()" data-active="false" title="Opens the settings specific to this type of gradient"><img class="iconSVG" src="Icons/Diverse/Settings.svg"></button>
                    <div class="gradSpecSettings">
                        <div class="singleChoiceList gradRadialPosContMsgMask">
                            <button data-active="true" onclick="updateRadialTypeMsgMask(event, 'farthest-corner')">Farthest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeMsgMask(event, 'farthest-side')">Farthest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeMsgMask(event, 'closest-corner')">Closest Corner</button>
                            <button data-active="false" onclick="updateRadialTypeMsgMask(event, 'closest-side')">Closest Edge</button>
                            <button data-active="false" onclick="updateRadialTypeMsgMask(event, 'circle')">Circle</button>
                        </div>
                        <div class="inputNumRow">
                            <div class="numCont">
                                <span class="numContDescr">x:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosMsgMask(event, 'x')">
                                <span class="numContUnit">%</span>
                            </div>
                            <div class="numCont">
                                <span class="numContDescr">y:</span>
                                <input class="numContInput" type="number" value="50" oninput="updateRadialPosMsgMask(event, 'y')">
                                <span class="numContUnit">%</span>
                            </div>
                        </div>
                    </div>
                    <button class="showBgSizeBtn" onclick="switchSizeMsgMaskBox()" title="Opens the sizing settings of this background"><img class="iconSVG" src="Icons/Diverse/Size.svg"></button>
                    <div class="bgSizeSettings">
                        <div class="numCont">
                            <span class="numContDescr">x-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgMaskSizePos('posX', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('posX', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">y-position:</span>
                            <input class="numContInput" type="number" value="50" oninput="updateMsgMaskSizePos('posY', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('posY', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">width:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgMaskSizePos('width', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('width', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                        <div class="numCont">
                            <span class="numContDescr">height:</span>
                            <input class="numContInput" type="number" value="100" oninput="updateMsgMaskSizePos('height', '%')">
                            <span class="numContUnit">%</span>
                            +
                            <input class="numContInput" type="number" value="0" oninput="updateMsgMaskSizePos('height', 'px')">
                            <span class="numContUnit">px</span>
                        </div>
                    </div>
                `;
        }
        document.querySelector(".colorMenuColMsgMask").insertBefore(colorMenu, document.querySelector(".colorMenuColMsgMask").children[indexPlace]);
    } else {
        indexPlace = index;

        var menuOpt = JSON.parse(JSON.stringify(settings.msgBackgroundMask[`${activeRole}`].value[indexPlace]));
        settings.msgBackgroundMask[`${activeRole}`].value.splice(indexPlace, 0, menuOpt);

        var colorMenuNode = document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[indexPlace].cloneNode(true);
        colorMenuNode.setAttribute("data-color-show", "false");
        colorMenuNode.setAttribute("data-set-show", "false");
        colorMenuNode.setAttribute("data-size-show", "false");
        document.querySelector(".colorMenuColMsgMask").insertBefore(colorMenuNode, document.querySelector(".colorMenuColMsgMask").children[indexPlace]);
    }
    
    for (var i = 0; i < document.querySelectorAll(".colorSliderMsgMaskCont").length; i++) {
        for (var j = 0; j < document.querySelectorAll(".colorSliderMsgMaskCont")[i].querySelectorAll(".colorSlider").length; j++) {
            document.querySelectorAll(".colorSliderMsgMaskCont")[i].querySelectorAll(".colorSlider")[j].setAttribute("onpointerdown", `openColorMsgMaskBox(${i}, ${j})`);
        }
    }
    
    updateColorSliderMsgMaskBox();
    decompileMsgMask();
}

function removeGradientMsgMask(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode);
    if (i < activeMsgMaskGrad) {
        activeMsgMaskGrad -= 1;
    }
    settings.msgBackgroundMask[`${activeRole}`].value.splice(i, 1);
    document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[i].remove();
    for (let j = 0; j < document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu").length; j++) {
        for (let k = 0; k < document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider").length; k++) {
            document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorMsgMaskBox(${j}, ${k})`)
        }
    }
    
    decompileMsgMask();
}

function updateRadialTypeMsgMask(e, size) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    settings.msgBackgroundMask[`${activeRole}`].value[i].size = size;
    for (let j = 0; j < settings.msgBackgroundMask[`${activeRole}`].value.length; j++) {
        if (settings.msgBackgroundMask[`${activeRole}`].value[j].type === "radial") {
            for (let k = 0; k < document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContMsgMask").querySelectorAll("button").length; k++) {
                document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[j].querySelector(".gradRadialPosContMsgMask").querySelectorAll("button")[k].setAttribute("data-active", "false");
            }
            e.target.setAttribute("data-active", "true");
        }
    }
    
    decompileMsgMask();
}

function updateLinearRotMsgMask(e) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    settings.msgBackgroundMask[`${activeRole}`].value[i].rotate = parseInt(e.target.value);
    
    decompileMsgMask();
}

function updateRadialPosMsgMask(e, xy) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode.parentNode);
    if (xy === "x") {
        settings.msgBackgroundMask[`${activeRole}`].value[i].x = parseInt(e.target.value);
    } else if (xy === "y") {
        settings.msgBackgroundMask[`${activeRole}`].value[i].y = parseInt(e.target.value);
    }
    
    decompileMsgMask();
}

function moveColorSliderMsgMask(e, dir) {
    var i = Array.from(e.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(e.target.parentNode.parentNode.parentNode);
    if (dir === "up" && i > 0) {
        var elmnt = settings.msgBackgroundMask[`${activeRole}`].value[i];
        settings.msgBackgroundMask[`${activeRole}`].value.splice(i, 1);
        settings.msgBackgroundMask[`${activeRole}`].value.splice(i - 1, 0, elmnt);
        document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[i - 1].before(document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[i]);
        if (activeMsgMaskGrad === i) {
            activeMsgMaskGrad -= 1;
        } else if (activeMsgMaskGrad === i - 1) {
            activeMsgMaskGrad += 1;
        }
    } else if (dir === "down" && i < settings.msgBackgroundMask[`${activeRole}`].value.length - 1) {
        var elmnt = settings.msgBackgroundMask[`${activeRole}`].value[i];
        settings.msgBackgroundMask[`${activeRole}`].value.splice(i, 1);
        settings.msgBackgroundMask[`${activeRole}`].value.splice(i + 1, 0, elmnt);
        document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[i + 1].after(document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[i]);
        if (activeMsgMaskGrad === i) {
            activeMsgMaskGrad += 1;
        } else if (activeMsgMaskGrad === i + 1) {
            activeMsgMaskGrad -= 1;
        }
    }

    for (let j = 0; j < settings.msgBackgroundMask[`${activeRole}`].value.length; j++) {
        for (let k = 0; k < settings.msgBackgroundMask[`${activeRole}`].value[j].colors.length; k++) {
            document.querySelector(".colorMenuColMsgMask").querySelectorAll(".colorMenu")[j].querySelectorAll(".colorSlider")[k].setAttribute("onpointerdown", `openColorMsgMaskBox(${j}, ${k})`)
        }
    }
    
    decompileMsgMask();
}

function duplicateColorSliderMsgMask() {
    activeMsgMaskGrad += 1;
    var i = Array.from(event.target.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode);
    var type = settings.msgBackgroundMask[`${activeRole}`].value[i].type;

    addGradientMsgMask(type, i);
}

function updateMsgMaskSizePos(cat, value) {
    var i = Array.from(event.target.parentNode.parentNode.parentNode.parentNode.children).indexOf(event.target.parentNode.parentNode.parentNode);
    if (cat === "posX") {
        if (value === "%") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].posX.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].posX.px = parseInt(event.target.value);
        }
    } else if (cat === "posY") {
        if (value === "%") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].posY.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].posY.px = parseInt(event.target.value);
        }
    } else if (cat === "width") {
        if (value === "%") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].width.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].width.px = parseInt(event.target.value);
        }
    } else if (cat === "height") {
        if (value === "%") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].height.percent = parseInt(event.target.value);
        } else if (value === "px") {
            settings.msgBackgroundMask[`${activeRole}`].value[i].height.px = parseInt(event.target.value);
        }
    }
    
    decompileMsgMask();
}

// settings.msgBorder

function decompileMsgBorder() {
    roleList.forEach(role => {
        if (settings.msgBorder[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                if (settings.msgBorder[`${role}`].value.top.color.type === "custom") {
                    msg.style.setProperty("--msgBorderTop", `${settings.msgBorder[`${role}`].value.top.type} ${settings.msgBorder[`${role}`].value.top.width}px ${settings.msgBorder[`${role}`].value.top.color.color}${dec2hex(settings.msgBorder[`${role}`].value.top.color.opacity)}`);
                } else if (settings.msgBorder[`${role}`].value.top.color.type === "twitch") {
                    msg.style.setProperty("--msgBorderTop", `${settings.msgBorder[`${role}`].value.top.type} ${settings.msgBorder[`${role}`].value.top.width}px ${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgBorder[`${role}`].value.top.color.opacity)}`);
                }

                if (settings.msgBorder[`${role}`].value.right.color.type === "custom") {
                    msg.style.setProperty("--msgBorderRight", `${settings.msgBorder[`${role}`].value.right.type} ${settings.msgBorder[`${role}`].value.right.width}px ${settings.msgBorder[`${role}`].value.right.color.color}${dec2hex(settings.msgBorder[`${role}`].value.right.color.opacity)}`);
                } else if (settings.msgBorder[`${role}`].value.right.color.type === "twitch") {
                    msg.style.setProperty("--msgBorderRight", `${settings.msgBorder[`${role}`].value.right.type} ${settings.msgBorder[`${role}`].value.right.width}px ${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgBorder[`${role}`].value.right.color.opacity)}`);
                }

                if (settings.msgBorder[`${role}`].value.bottom.color.type === "custom") {
                    msg.style.setProperty("--msgBorderBottom", `${settings.msgBorder[`${role}`].value.bottom.type} ${settings.msgBorder[`${role}`].value.bottom.width}px ${settings.msgBorder[`${role}`].value.bottom.color.color}${dec2hex(settings.msgBorder[`${role}`].value.bottom.color.opacity)}`);
                } else if (settings.msgBorder[`${role}`].value.bottom.color.type === "twitch") {
                    msg.style.setProperty("--msgBorderBottom", `${settings.msgBorder[`${role}`].value.bottom.type} ${settings.msgBorder[`${role}`].value.bottom.width}px ${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgBorder[`${role}`].value.bottom.color.opacity)}`);
                }

                if (settings.msgBorder[`${role}`].value.left.color.type === "custom") {
                    msg.style.setProperty("--msgBorderLeft", `${settings.msgBorder[`${role}`].value.left.type} ${settings.msgBorder[`${role}`].value.left.width}px ${settings.msgBorder[`${role}`].value.left.color.color}${dec2hex(settings.msgBorder[`${role}`].value.left.color.opacity)}`);
                } else if (settings.msgBorder[`${role}`].value.left.color.type === "twitch") {
                    msg.style.setProperty("--msgBorderLeft", `${settings.msgBorder[`${role}`].value.left.type} ${settings.msgBorder[`${role}`].value.left.width}px ${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgBorder[`${role}`].value.left.color.opacity)}`);
                }
            });
        }
    });
}

var activeMsgBorder = ""

function openBorderMenuMsg(pos) {
    document.querySelector("#borderGridMsg").querySelectorAll(".borderSelect").forEach(elmnt => {
        elmnt.setAttribute("data-active", "false");
    });

    event.target.setAttribute("data-active", "true");

    var borderMenu = event.target.parentNode.parentNode.parentNode.querySelector(".borderEdgeMenu"),
        cornerMenu = event.target.parentNode.parentNode.parentNode.querySelector(".borderCornerMenu");
    activeMsgBorder = pos;
    if (activeMsgBorder === "top" || activeMsgBorder === "bottom" || activeMsgBorder === "left" || activeMsgBorder === "right") {
        borderMenu.setAttribute("data-active", "true");
        cornerMenu.setAttribute("data-active", "false");

        borderMenu.querySelectorAll(".borderTypeBtn").forEach(elmnt => {
            elmnt.setAttribute("data-active", "false")
        });

        if (settings.msgBorder[`${activeRole}`].value[`${pos}`].color.type === "custom") {
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
        } else if (settings.msgBorder[`${activeRole}`].value[`${pos}`].color.type === "twitch") {
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
            borderMenu.querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
        }

        borderMenu.querySelector(`.borderTypeBtn[data-type="${settings.msgBorder[`${activeRole}`].value[`${pos}`].type}"]`).setAttribute("data-active", "true");
        borderMenu.querySelector(".borderWidthCont").querySelector(".inputNumBig").value = settings.msgBorder[`${activeRole}`].value[`${pos}`].width;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeInput").value = settings.msgBorder[`${activeRole}`].value[`${pos}`].color.color;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").value = settings.msgBorder[`${activeRole}`].value[`${pos}`].color.opacity;
        borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").setAttribute("data-value", borderMenu.querySelector(".borderColorMenu").querySelector(".colorChangeOpacity").value);
        
    } else if (activeMsgBorder === "tl" || activeMsgBorder === "tr" || activeMsgBorder === "bl" || activeMsgBorder === "br") {
        cornerMenu.setAttribute("data-active", "true");
        borderMenu.setAttribute("data-active", "false");

        cornerMenu.querySelector(".inputNumBig").value = settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`];
    }
}

function updateBorderMsg(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    if (type === "type") {
        Array.from(event.target.parentNode.parentNode.children).forEach(elmnt => {
            elmnt.setAttribute("data-active", "false");
        });
        event.target.parentNode.setAttribute("data-active", "true");
        settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].type = value;
    } else if (type === "width") {
        settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].width = parseInt(document.querySelector("#msgBorderWidth").value);
    } else if (type === "color") {
        settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.color = document.querySelector("#msgBorderColor").value;
    } else if (type === "colorType") {
        settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.type = value;
        if (value === "custom") {
            document.querySelector(".borderEdgeMenuMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".borderEdgeMenuMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".borderEdgeMenuMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".borderEdgeMenuMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "opacity") {
        settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.opacity = parseInt(document.querySelector("#msgBorderOpacity").value);
    } else if (type === "all") {
        settings.msgBorder[`${activeRole}`].value["top"].type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].type;
        settings.msgBorder[`${activeRole}`].value["bottom"].type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].type;
        settings.msgBorder[`${activeRole}`].value["left"].type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].type;
        settings.msgBorder[`${activeRole}`].value["right"].type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].type;

        settings.msgBorder[`${activeRole}`].value["top"].width = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].width;
        settings.msgBorder[`${activeRole}`].value["bottom"].width = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].width;
        settings.msgBorder[`${activeRole}`].value["left"].width = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].width;
        settings.msgBorder[`${activeRole}`].value["right"].width = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].width;
        
        settings.msgBorder[`${activeRole}`].value["top"].color.color = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.color;
        settings.msgBorder[`${activeRole}`].value["bottom"].color.color = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.color;
        settings.msgBorder[`${activeRole}`].value["left"].color.color = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.color;
        settings.msgBorder[`${activeRole}`].value["right"].color.color = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.color;

        settings.msgBorder[`${activeRole}`].value["top"].color.type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.type;
        settings.msgBorder[`${activeRole}`].value["bottom"].color.type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.type;
        settings.msgBorder[`${activeRole}`].value["left"].color.type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.type;
        settings.msgBorder[`${activeRole}`].value["right"].color.type = "" + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.type;

        settings.msgBorder[`${activeRole}`].value["top"].color.opacity = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.opacity
        settings.msgBorder[`${activeRole}`].value["bottom"].color.opacity = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.opacity
        settings.msgBorder[`${activeRole}`].value["left"].color.opacity = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.opacity
        settings.msgBorder[`${activeRole}`].value["right"].color.opacity = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`].color.opacity
    }

    decompileMsgBorder();
}

// settings.msgBorder[`${activeRole}`].value

function decompileMsgBorderRadius() {
    roleList.forEach(role => {
        if (settings.msgBorder[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                msg.style.setProperty("--msgBRtl", `${settings.msgBorder[`${role}`].value.tl}px`);
                msg.style.setProperty("--msgBRtr", `${settings.msgBorder[`${role}`].value.tr}px`);
                msg.style.setProperty("--msgBRbr", `${settings.msgBorder[`${role}`].value.br}px`);
                msg.style.setProperty("--msgBRbl", `${settings.msgBorder[`${role}`].value.bl}px`);
            });
        }
    });
}

function updateCornerMsg(type) {
    if (type === "corner") {
        settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`] = parseInt(document.querySelector("#msgCornerRadius").value);
    } else if (type === "all") {
        settings.msgBorder[`${activeRole}`].value["tl"] = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`];
        settings.msgBorder[`${activeRole}`].value["tr"] = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`];
        settings.msgBorder[`${activeRole}`].value["bl"] = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`];
        settings.msgBorder[`${activeRole}`].value["br"] = 0 + settings.msgBorder[`${activeRole}`].value[`${activeMsgBorder}`];
    }

    decompileMsgBorderRadius();
}

// settings.msgShadow

function decompileMsgShadow() {
    roleList.forEach(role => {
        if (settings.msgShadow[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                var msgShadow = "";

                for (let i = 0; i < settings.msgShadow[`${role}`].value.length; i++) {
                    msgShadow += `${settings.msgShadow[`${role}`].value[i].x}px ${settings.msgShadow[`${role}`].value[i].y}px ${settings.msgShadow[`${role}`].value[i].blur}px ${settings.msgShadow[`${role}`].value[i].expand}px `;
                    if (settings.msgShadow[`${role}`].value[i].color.type === "custom") {
                        msgShadow += `${settings.msgShadow[`${role}`].value[i].color.color}${dec2hex(settings.msgShadow[`${role}`].value[i].color.opacity)}`;
                    } else if (settings.msgShadow[`${role}`].value[i].color.type === "twitch") {
                        msgShadow += `${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgShadow[`${role}`].value[i].color.opacity)}`;
                    }
                    if (settings.msgShadow[`${role}`].value[i].inset === true) {
                        msgShadow += " inset";
                    }
                    if (i < settings.msgShadow[`${role}`].value.length - 1) {
                        msgShadow += ", ";
                    }
                }

                msg.style.setProperty("--msgBS", msgShadow);
            });
        }
    });
}

var activeMsgShadow = -1;

function openShadowMsg(triggerAdd) {
    for (let i = 0; i < settings.msgShadow[`${activeRole}`].value.length; i++) {
        document.querySelector(".shadowColMsg").querySelectorAll(".shadowElmnt")[i].setAttribute("data-active", "false");
    }
    
    if (!triggerAdd) {
        activeMsgShadow = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);
    }
    
    if (activeMsgShadow >= 0) {
        document.querySelector(".shadowSettingsMsg").setAttribute("data-active", "true");
        document.querySelector(".shadowColMsg").querySelectorAll(".shadowElmnt")[activeMsgShadow].setAttribute("data-active", "true");
        
        
        document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[0].value = settings.msgShadow[`${activeRole}`].value[activeMsgShadow].x;
        document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[1].value = settings.msgShadow[`${activeRole}`].value[activeMsgShadow].y;
        document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[2].value = settings.msgShadow[`${activeRole}`].value[activeMsgShadow].blur;
        document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[3].value = settings.msgShadow[`${activeRole}`].value[activeMsgShadow].expand;
        document.querySelector(".shadowSettingsMsg").querySelector(".msgShadowInset").setAttribute("data-active", settings.msgShadow[`${activeRole}`].value[activeMsgShadow].inset);
        
        if (settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.type === "custom") {
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.type === "twitch") {
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
        
        document.querySelector("#msgShadowOpacity").value = settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.opacity;
        document.querySelector("#msgShadowOpacity").setAttribute("data-value", settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.opacity);
        
        document.querySelector("#msgShadowColor").value = settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.color;
    } else if (activeMsgShadow === -1) {
        document.querySelector(".shadowSettingsMsg").setAttribute("data-active", "false");
    }
}

function addShadowMsg() {
    var shadowElmnt = document.createElement("div");
        shadowElmnt.className = "shadowElmnt";

        shadowElmnt.innerHTML = `
            <button class="shadowElmntBtn" onclick="openShadowMsg()"></button>
            <button class="shadowElmntRmv icon" onclick="removeShadowMsg()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
        `;

    document.querySelector(".shadowColMsg").appendChild(shadowElmnt);

    settings.msgShadow[`${activeRole}`].value.push({
        x: 0, // In px
        y: 0, // In px
        blur: 0, // In px
        expand: 0, // In px
        color: {
            type: "custom",
            color: "#000000",
            opacity: 255 // In Hex
        },
        inset: false
    });

    activeMsgShadow = settings.msgShadow[`${activeRole}`].value.length - 1;
    openShadowMsg(true);
    
    decompileMsgShadow();
}

function updateShadowMsg(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.msgShadow[`${activeRole}`].value[activeMsgShadow].x    = parseInt(document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[0].value);
    settings.msgShadow[`${activeRole}`].value[activeMsgShadow].y    = parseInt(document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[1].value);
    settings.msgShadow[`${activeRole}`].value[activeMsgShadow].blur    = parseInt(document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[2].value);
    settings.msgShadow[`${activeRole}`].value[activeMsgShadow].expand  = parseInt(document.querySelector(".shadowSettingsMsg").querySelectorAll(".numContInput")[3].value);
    
    settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.opacity = parseInt(document.querySelector("#msgShadowOpacity").value);
    document.querySelector("#msgShadowOpacity").setAttribute("data-value", document.querySelector("#msgShadowOpacity").value);
    
    if (document.querySelector(".shadowSettingsMsg").querySelector(".msgShadowInset").getAttribute("data-active") === "false") {
        settings.msgShadow[`${activeRole}`].value[activeMsgShadow].inset = false;
    } else {
        settings.msgShadow[`${activeRole}`].value[activeMsgShadow].inset = true;
    }

    if (type === "colorType") {
        settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.type = value;
        if (value === "custom") {
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".shadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "color") {
        settings.msgShadow[`${activeRole}`].value[activeMsgShadow].color.color = document.querySelector("#msgShadowColor").value;
    }

    for (let i = 0; i < settings.msgShadow[`${activeRole}`].value.length; i++) {
        var msgStyle = `${settings.msgShadow[`${activeRole}`].value[i].x}px ${settings.msgShadow[`${activeRole}`].value[i].y}px ${settings.msgShadow[`${activeRole}`].value[i].blur}px ${settings.msgShadow[`${activeRole}`].value[i].expand}px ${settings.msgShadow[`${activeRole}`].value[i].color.color}${dec2hex(settings.msgShadow[`${activeRole}`].value[i].color.opacity)}`;
        if (settings.msgShadow[`${activeRole}`].value[i].inset === true) {
            msgStyle += " inset";
        }

        document.querySelector(".shadowColMsg").querySelectorAll(".shadowElmnt")[i].style.boxShadow = msgStyle;
    }
    
    decompileMsgShadow();
}

function removeSwitchShadowMsg() {
    if (document.querySelector(".shadowColMsg").getAttribute("data-delete-active") === "false") {
        document.querySelector(".shadowColMsg").setAttribute("data-delete-active", "true");
    } else {
        document.querySelector(".shadowColMsg").setAttribute("data-delete-active", "false");
    }
    
    decompileMsgShadow();
}

function removeShadowMsg() {
    var i = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);

    if (i <= activeMsgShadow) {
        activeMsgShadow -= 1;
    }
    settings.msgShadow[`${activeRole}`].value.splice(i, 1);

    document.querySelector(".shadowColMsg").querySelectorAll(".shadowElmnt")[i].remove();

    openShadowMsg(true);
    
    decompileMsgShadow();
}

// settings.msgSpacing

function decompileMsgSpacing() {
    roleList.forEach(role => {
        if (settings.msgPosition[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                msg.style.setProperty("--msgSpacingOT", `${settings.msgPosition[`${role}`].value.spacing.outer.top}px`);
                msg.style.setProperty("--msgSpacingOR", `${settings.msgPosition[`${role}`].value.spacing.outer.right}px`);
                msg.style.setProperty("--msgSpacingOB", `${settings.msgPosition[`${role}`].value.spacing.outer.bottom}px`);
                msg.style.setProperty("--msgSpacingOL", `${settings.msgPosition[`${role}`].value.spacing.outer.left}px`);

                msg.style.setProperty("--msgSpacingIT", `${settings.msgPosition[`${role}`].value.spacing.inner.top}px`);
                msg.style.setProperty("--msgSpacingIR", `${settings.msgPosition[`${role}`].value.spacing.inner.right}px`);
                msg.style.setProperty("--msgSpacingIB", `${settings.msgPosition[`${role}`].value.spacing.inner.bottom}px`);
                msg.style.setProperty("--msgSpacingIL", `${settings.msgPosition[`${role}`].value.spacing.inner.left}px`);
            });
        }
    });
}

function updateMsgSpacing(pos) {
    if (pos === "OT") {
        settings.msgPosition[`${activeRole}`].value.spacing.outer.top = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridOuter")[0].value);
    } else if (pos === "OL") {
        settings.msgPosition[`${activeRole}`].value.spacing.outer.left = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridOuter")[1].value);
    } else if (pos === "OR") {
        settings.msgPosition[`${activeRole}`].value.spacing.outer.right = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridOuter")[2].value);
    } else if (pos === "OB") {
        settings.msgPosition[`${activeRole}`].value.spacing.outer.bottom = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridOuter")[3].value);
    } else if (pos === "IT") {
        settings.msgPosition[`${activeRole}`].value.spacing.inner.top = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridInner")[0].value);
    } else if (pos === "IL") {
        settings.msgPosition[`${activeRole}`].value.spacing.inner.left = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridInner")[1].value);
    } else if (pos === "IR") {
        settings.msgPosition[`${activeRole}`].value.spacing.inner.right = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridInner")[2].value);
    } else if (pos === "IB") {
        settings.msgPosition[`${activeRole}`].value.spacing.inner.bottom = parseInt(document.querySelector(".spacingGridMsg").querySelectorAll(".spacingGridInner")[3].value);
    }

    decompileMsgSpacing();
}

// settings.msgSizing
// settings.msgPosition

function decompileMsgSizing() {
    roleList.forEach(role => {
        if (settings.msgPosition[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                if (settings.cbxLayout[`${role}`].value.type === "column" || settings.cbxLayout[`${role}`].value.type === "column-reverse") {
                    msg.style.setProperty(`--msgSizingH`, settings.msgPosition[`${role}`].value.sizingH);
                    msg.style.setProperty(`--msgSizingV`, settings.msgPosition[`${role}`].value.sizingV);
                } else if (settings.cbxLayout[`${role}`].value.type === "row" || settings.cbxLayout[`${role}`].value.type === "row-reverse") {
                    msg.style.setProperty(`--msgSizingH`, settings.msgPosition[`${role}`].value.sizingV);
                    msg.style.setProperty(`--msgSizingV`, settings.msgPosition[`${role}`].value.sizingH);
                }
            });
        }
    });
}

function updateMsgSizingH(type) {
    if (type === "stretch") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-start") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "center") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-end") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "true");
    }
    
    settings.msgPosition[`${activeRole}`].value.sizingH = type;

    decompileMsgSizing();
}

function updateMsgSizingV(type) {
    if (type === "stretch") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-start") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "center") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "true");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "false");
    } else if (type === "flex-end") {
        event.target.parentNode.querySelectorAll("button")[0].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[1].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[2].setAttribute("data-active", "false");
        event.target.parentNode.querySelectorAll("button")[3].setAttribute("data-active", "true");
    }
    
    settings.msgPosition[`${activeRole}`].value.sizingV = type;

    decompileMsgSizing();
}

// settings.msgFont

function decompileMsgFont() {
    roleList.forEach(role => {
        if (settings.msgFont[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                msg.style.setProperty("--msgFontFamily", `"${settings.msgFont[`${role}`].value.family}"`);

                if (settings.msgFont[`${role}`].value.color.type === "custom") {
                    msg.style.setProperty("--msgFontColor", `${settings.msgFont[`${role}`].value.color.color}${dec2hex(settings.msgFont[`${role}`].value.color.opacity)}`);
                } else if (settings.msgFont[`${role}`].value.color.type === "twitch") {
                    msg.style.setProperty("--msgFontColor", `${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgFont[`${role}`].value.color.opacity)}`);
                }

                msg.style.setProperty("--msgFontSize", `${settings.msgFont[`${role}`].value.size}px`);

                msg.style.setProperty("--msgFontWeight", settings.msgFont[`${role}`].value.weight);

                if (settings.msgFont[`${role}`].value.italic === true) {
                    msg.style.setProperty("--msgFontItalic", "italic");
                } else {
                    msg.style.setProperty("--msgFontItalic", "normal");
                }

                var msgFontLines = ""

                if (settings.msgFont[`${role}`].value.lines.upperLine === true) {
                    msgFontLines += "overline "
                }
                if (settings.msgFont[`${role}`].value.lines.crossLine === true) {
                    msgFontLines += "line-through "
                }
                if (settings.msgFont[`${role}`].value.lines.underLine === true) {
                    msgFontLines += "underline"
                }

                msg.style.setProperty("--msgFontLines", msgFontLines);

                if (settings.msgFont[`${role}`].value.height.auto === true) {
                    msg.style.setProperty("--msgFontHeight", "normal");
                } else if (settings.msgFont[`${role}`].value.height.auto === false) {
                    msg.style.setProperty("--msgFontHeight", `${settings.msgFont[`${role}`].value.height.height}px`);
                }

                msg.style.setProperty("--msgFontSpacing", `${settings.msgFont[`${role}`].value.spacing}px`);

                msg.style.setProperty("--msgFontHAlign", settings.msgFont[`${role}`].value.hAlign);
            });
        }
    });
}

function updateMsgFont(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.msgFont[`${activeRole}`].value.family = document.querySelector("#msgFontFamInp").value;
    settings.msgFont[`${activeRole}`].value.size = document.querySelector("#msgFontSizeInp").value;
    settings.msgFont[`${activeRole}`].value.weight = document.querySelector("#msgFontWeightInp").value;
    settings.msgFont[`${activeRole}`].value.height.height = document.querySelector("#msgFontHeightInp").value;
    settings.msgFont[`${activeRole}`].value.spacing = document.querySelector("#msgFontSpaceInp").value;

    if (type === "style") {
        var styleRow = document.querySelector(".msgFontStyleRow");

        if (event.target.getAttribute("data-active") === "false") {
            event.target.setAttribute("data-active", "true");
        } else {
            event.target.setAttribute("data-active", "false");
        }

        if (styleRow.querySelectorAll("button")[0].getAttribute("data-active") === "true") {
            settings.msgFont[`${activeRole}`].value.lines.upperLine = true;
        } else {
            settings.msgFont[`${activeRole}`].value.lines.upperLine = false;
        }
        if (styleRow.querySelectorAll("button")[1].getAttribute("data-active") === "true") {
            settings.msgFont[`${activeRole}`].value.lines.crossLine = true;
        } else {
            settings.msgFont[`${activeRole}`].value.lines.crossLine = false;
        }
        if (styleRow.querySelectorAll("button")[2].getAttribute("data-active") === "true") {
            settings.msgFont[`${activeRole}`].value.lines.underLine = true;
        } else {
            settings.msgFont[`${activeRole}`].value.lines.underLine = false;
        }
        if (styleRow.querySelectorAll("button")[3].getAttribute("data-active") === "true") {
            settings.msgFont[`${activeRole}`].value.italic = true;
        } else {
            settings.msgFont[`${activeRole}`].value.italic = false;
        }
    } else if (type === "hAlign") {
        Array.from(event.target.parentNode.children).forEach(elmnt => {
            elmnt.setAttribute("data-active", "false");
        });
        event.target.setAttribute("data-active", "true");

        settings.msgFont[`${activeRole}`].value.hAlign = event.target.getAttribute("data-value");
    } else if (type === "autoheight") {
        if (event.target.getAttribute("data-active") === "true") {
            event.target.setAttribute("data-active", "false");
            settings.msgFont[`${activeRole}`].value.height.auto = false
        } else {
            event.target.setAttribute("data-active", "true");
            settings.msgFont[`${activeRole}`].value.height.auto = true
        }
    } else if (type === "colorType") {
        settings.msgFont[`${activeRole}`].value.color.type = value;
        if (value === "custom") {
            document.querySelector(".fontColorMsgMenu").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".fontColorMsgMenu").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (value === "twitch") {
            document.querySelector(".fontColorMsgMenu").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".fontColorMsgMenu").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
    } else if (type === "color") {
        settings.msgFont[`${activeRole}`].value.color.color = document.querySelector("#msgFontColor").value;
    }
    
    settings.msgFont[`${activeRole}`].value.color.opacity = parseInt(document.querySelector("#msgFontOpacity").value);

    decompileMsgFont();
}

// settings.msgFontShadow

function decompileMsgFontShadow() {
    roleList.forEach(role => {
        if (settings.msgFontShadow[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                var msgFontShadow = "";

                for (let i = 0; i < settings.msgFontShadow[`${role}`].value.length; i++) {
                    msgFontShadow += `${settings.msgFontShadow[`${role}`].value[i].x}px ${settings.msgFontShadow[`${role}`].value[i].y}px ${settings.msgFontShadow[`${role}`].value[i].blur}px `;
                    if (settings.msgFontShadow[`${role}`].value[i].color.type === "custom") {
                        msgFontShadow += `${settings.msgFontShadow[`${role}`].value[i].color.color}${dec2hex(settings.msgFontShadow[`${role}`].value[i].color.opacity)}`;
                    } else if (settings.msgFontShadow[`${role}`].value[i].color.type === "twitch") {
                        msgFontShadow += `${msg.parentNode.parentNode.getAttribute("data-twitch")}${dec2hex(settings.msgFontShadow[`${role}`].value[i].color.opacity)}`;
                    }
                    if (i < settings.msgFontShadow[`${role}`].value.length - 1) {
                        msgFontShadow += ", ";
                    }
                }

                msg.style.setProperty("--msgFontShadow", msgFontShadow);
            });
        }
    });
}

var activeMsgFontShadow = -1;

function openFontShadowMsg(triggerAdd) {
    for (let i = 0; i < settings.msgFontShadow[`${activeRole}`].value.length; i++) {
        document.querySelector(".fontShadowColMsg").querySelectorAll(".fontShadowElmnt")[i].setAttribute("data-active", "false");
    }
    
    if (!triggerAdd) {
        activeMsgFontShadow = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);
    }
    
    if (activeMsgFontShadow >= 0) {
        document.querySelector(".fontShadowSettingsMsg").setAttribute("data-active", "true");
        document.querySelector(".fontShadowColMsg").querySelectorAll(".fontShadowElmnt")[activeMsgFontShadow].setAttribute("data-active", "true");
        
        
        document.querySelector(".fontShadowSettingsMsg").querySelectorAll(".numContInput")[0].value = settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].x;
        document.querySelector(".fontShadowSettingsMsg").querySelectorAll(".numContInput")[1].value = settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].y;
        document.querySelector(".fontShadowSettingsMsg").querySelectorAll(".numContInput")[2].value = settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].blur;
        
        if (settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.type === "custom") {
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true")
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false")
        } else if (settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.type === "twitch") {
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true")
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false")
        }
        
        document.querySelector("#msgFontShadowOpacity").value = settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.opacity;
        document.querySelector("#msgFontShadowOpacity").setAttribute("data-value", settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.opacity);
        
        document.querySelector("#msgFontShadowColor").value = settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.color;
    } else if (activeMsgFontShadow === -1) {
        document.querySelector(".fontShadowSettingsMsg").setAttribute("data-active", "false");
    }
}

function addFontShadowMsg() {
    var fontShadowElmnt = document.createElement("div");
        fontShadowElmnt.className = "fontShadowElmnt";

        fontShadowElmnt.innerHTML = `
            <button class="fontShadowElmntBtn" onclick="openFontShadowMsg()"></button>
            <button class="fontShadowElmntRmv icon" onclick="removeFontShadowMsg()"><img class="iconSVG descrIconSVG" src="Icons/Diverse/Remove.svg"></button>
        `;

    document.querySelector(".fontShadowColMsg").appendChild(fontShadowElmnt);

    settings.msgFontShadow[`${activeRole}`].value.push({
        x: 0, // In px
        y: 0, // In px
        blur: 0, // In px
        color: {
            type: "custom",
            color: "#000000",
            opacity: 255 // In Hex
        }
    });

    activeMsgFontShadow = settings.msgFontShadow[`${activeRole}`].value.length - 1;
    openFontShadowMsg(true);
    
    decompileMsgFontShadow();
}

function updateFontShadowMsg(type, value) {
    if (event.target.classList.contains("colorChangeOpacity")) {
        event.target.setAttribute("data-value", event.target.value);
    }
    settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].x = parseInt(document.querySelector(".fontShadowSettingsMsg").querySelectorAll(".numContInput")[0].value);
    settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].y = parseInt(document.querySelector(".fontShadowSettingsMsg").querySelectorAll(".numContInput")[1].value);
    settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].blur = parseInt(document.querySelector(".fontShadowSettingsMsg").querySelectorAll(".numContInput")[2].value);
    
    settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.opacity = parseInt(document.querySelector("#msgFontShadowOpacity").value);
    
    if (type === "colorType") {
        settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.type = value;
        if (value === "custom") {
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "true");
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "false");
        } else if (value === "twitch") {
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[1].setAttribute("data-active", "true");
            document.querySelector(".fontShadowSettingsMsg").querySelector(".colorChangeType").querySelectorAll("button")[0].setAttribute("data-active", "false");
        }
    } else if (type === "color") {
        settings.msgFontShadow[`${activeRole}`].value[activeMsgFontShadow].color.color = document.querySelector("#msgFontShadowColor").value;
    }

    for (let i = 0; i < settings.msgFontShadow[`${activeRole}`].value.length; i++) {
        var msgStyle = `${settings.msgFontShadow[`${activeRole}`].value[i].x}px ${settings.msgFontShadow[`${activeRole}`].value[i].y}px ${settings.msgFontShadow[`${activeRole}`].value[i].blur}px ${settings.msgFontShadow[`${activeRole}`].value[i].color.color}${dec2hex(settings.msgFontShadow[`${activeRole}`].value[i].color.opacity)}`;
        
        document.querySelector(".fontShadowColMsg").querySelectorAll(".fontShadowElmnt")[i].style.boxShadow = msgStyle;
    }
    
    decompileMsgFontShadow();
}

function removeSwitchFontShadowMsg() {
    if (document.querySelector(".fontShadowColMsg").getAttribute("data-delete-active") === "false") {
        document.querySelector(".fontShadowColMsg").setAttribute("data-delete-active", "true");
    } else {
        document.querySelector(".fontShadowColMsg").setAttribute("data-delete-active", "false");
    }
    
    decompileMsgFontShadow();
}

function removeFontShadowMsg() {
    var i = Array.from(event.target.parentNode.parentNode.children).indexOf(event.target.parentNode);

    if (i <= activeMsgFontShadow) {
        activeMsgFontShadow -= 1;
    }
    settings.msgFontShadow[`${activeRole}`].value.splice(i, 1);

    document.querySelector(".fontShadowColMsg").querySelectorAll(".fontShadowElmnt")[i].remove();

    openFontShadowMsg(true);
    
    decompileMsgFontShadow();
}

// settings.msgContent

function decompileMsgContent() {
    roleList.forEach(role => {
        if (settings.msgContent[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");

                var msgContentFinal = "" + settings.msgContent[`${role}`].value;

                msgContentFinal = msgContentFinal.replace(/{usn}/g, msg.parentNode.parentNode.getAttribute("data-username"));

                msgContentFinal = msgContentFinal.replace(/{msg}/g, msg.parentNode.parentNode.getAttribute("data-message"));

                msgContentFinal = msgContentFinal.replace(/{streamer}/g, msg.parentNode.parentNode.getAttribute("data-streamer"));
                
                msgContentFinal = msgContentFinal.replace(/{h}/g, msg.parentNode.parentNode.getAttribute("data-h"));
                
                msgContentFinal = msgContentFinal.replace(/{hh}/g, msg.parentNode.parentNode.getAttribute("data-hh"));

                msgContentFinal = msgContentFinal.replace(/{h12}/g, msg.parentNode.parentNode.getAttribute("data-h12"));

                msgContentFinal = msgContentFinal.replace(/{hh12}/g, msg.parentNode.parentNode.getAttribute("data-hh12"));

                msgContentFinal = msgContentFinal.replace(/{apm}/g, msg.parentNode.parentNode.getAttribute("data-apm"));
                
                msgContentFinal = msgContentFinal.replace(/{m}/g, msg.parentNode.parentNode.getAttribute("data-m"));
                
                msgContentFinal = msgContentFinal.replace(/{mm}/g, msg.parentNode.parentNode.getAttribute("data-mm"));
                
                msgContentFinal = msgContentFinal.replace(/{s}/g, msg.parentNode.parentNode.getAttribute("data-s"));
                
                msgContentFinal = msgContentFinal.replace(/{ss}/g, msg.parentNode.parentNode.getAttribute("data-ss"));

                msgContentFinal = msgContentFinal.replace(/{badges}/g, msg.parentNode.parentNode.getAttribute("data-badges"));

                msg.innerHTML = msgContentFinal;
            });
        }
    });
}

function updateMsgContent() {
    settings.msgContent[`${activeRole}`].value = document.querySelector(".msgContentInp").value;

    decompileMsgContent();
}

// settings.othEmotes

function decompileOthEmotes() {
    roleList.forEach(role => {
        if (settings.othEmotes[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var msg = cbxW.querySelector(".msg");
                if (settings.othEmotes[`${role}`].value.auto === true) {
                    msg.style.setProperty("--othEmoteHeight", `${settings.msgFont[`${role}`].value.size}px`);
                } else if (settings.othEmotes[`${role}`].value.auto === false) {
                    msg.style.setProperty("--othEmoteHeight", `${settings.othEmotes[`${role}`].value.height}px`)
                }
                
                msg.style.setProperty("--othEmoteVPos", settings.othEmotes[`${role}`].value.linePos);
            });
        }
    });
}

function updateOthEmotes(type) {
    if (type === "autosize") {
        if (event.target.getAttribute("data-active") === "true") {
            event.target.setAttribute("data-active", "false");
            settings.othEmotes[`${activeRole}`].value.auto = false;
        } else {
            event.target.setAttribute("data-active", "true");
            settings.othEmotes[`${activeRole}`].value.auto = true;
        }
    } else if (type === "vAlign") {
        Array.from(event.target.parentNode.children).forEach(elmnt => {
            elmnt.setAttribute("data-active", "false");
        });

        event.target.setAttribute("data-active", "true");
        settings.othEmotes[`${activeRole}`].value.linePos = event.target.getAttribute("data-value");
    }

    settings.othEmotes[`${activeRole}`].value.height = document.querySelector("#othEmoteSizeInp").value;

    decompileOthEmotes();
}

// settings.othBadges

function decompileOthBadges() {
    roleList.forEach(role => {
        if (settings.othBadges[`${role}`].active === true) {
            document.querySelectorAll(`.cbxW.${role}`).forEach(cbxW => {
                var usn = cbxW.querySelector(".usn"),
                    msg = cbxW.querySelector(".msg");
                if (settings.othBadges[`${role}`].value.size.auto === true) {
                    usn.style.setProperty("--othBadgesSize", `var(--usnFontSize)`);
                    msg.style.setProperty("--othBadgesSize", `var(--msgFontSize)`);
                } else {
                    usn.style.setProperty("--othBadgesSize", `${settings.othBadges[`${role}`].value.size.height}px`);
                    msg.style.setProperty("--othBadgesSize", `${settings.othBadges[`${role}`].value.size.height}px`);
                }
                cbxW.style.setProperty("--othBadgesGap", `${settings.othBadges[`${role}`].value.gap}px`);
            });
        }
    });
}

function updateOthBadges(type) {
    if (type === "autosize") {
        if (event.target.getAttribute("data-active") === "true") {
            event.target.setAttribute("data-active", "false");
            settings.othBadges[`${activeRole}`].value.size.auto = false;
        } else {
            event.target.setAttribute("data-active", "true");
            settings.othBadges[`${activeRole}`].value.size.auto = true;
        }
    }

    settings.othBadges[`${activeRole}`].value.gap = parseInt(document.querySelector("#othBadgesGapInp").value);
    settings.othBadges[`${activeRole}`].value.size.height = parseInt(document.querySelector("#othBadgesHeightInp").value);

    decompileOthBadges();
}

// settings.anmTiming

function updateAnmTiming(type) {
    if (type === "Del") {
        settings.anmTiming[`${activeRole}`].value.delay = parseInt(document.querySelector("#anmTimingDelay").value);
    } else if (type === "App") {
        settings.anmTiming[`${activeRole}`].value.appearing = parseInt(document.querySelector("#anmTimingAppearing").value);
    } else if (type === "Dur") {
        if (document.querySelector("#anmTimingDuration").value === "") {
            settings.anmTiming[`${activeRole}`].value.duration = "infinite";
        } else {
            settings.anmTiming[`${activeRole}`].value.duration = parseInt(document.querySelector("#anmTimingDuration").value);
        }
    } else if (type === "Van") {
        settings.anmTiming[`${activeRole}`].value.vanishing = parseInt(document.querySelector("#anmTimingVanishing").value);
    }
}

// settings.anmShow

function openAnmShow(i) {
    document.querySelectorAll(".anmShowType")[i].setAttribute("data-active", "true");
    document.querySelectorAll(".anmShowRow")[i].setAttribute("data-show", "true");
    settings.anmShow[`${activeRole}`].value[i].active = true;
}

function updateAnmShow(i) {
    if (settings.anmShow[`${activeRole}`].value[i].type === "curve") {
        if (document.querySelector("#anmShowCurve").value.length > 0) {
            settings.anmShow[`${activeRole}`].value[i].value = document.querySelector("#anmShowCurve").value;
        } else {
            settings.anmShow[`${activeRole}`].value[i].value = "cubic-bezier(.5,0,.5,1)";
        }
    } else {
        settings.anmShow[`${activeRole}`].value[i].value = parseFloat(document.querySelectorAll(".anmShowRow")[i].querySelector("input").value);
    }
}

function removeAnmShow(i) {
    document.querySelectorAll(".anmShowType")[i].setAttribute("data-active", "false");
    document.querySelectorAll(".anmShowRow")[i].setAttribute("data-show", "false");
    settings.anmShow[`${activeRole}`].value[i].active = false;
}

// settings.anmHide

function openAnmHide(i) {
    document.querySelectorAll(".anmHideType")[i].setAttribute("data-active", "true");
    document.querySelectorAll(".anmHideRow")[i].setAttribute("data-show", "true");
    settings.anmHide[`${activeRole}`].value[i].active = true;
}

function updateAnmHide(i) {
    if (settings.anmHide[`${activeRole}`].value[i].type === "curve") {
        if (document.querySelector("#anmHideCurve").value.length > 0) {
            settings.anmHide[`${activeRole}`].value[i].value = document.querySelector("#anmHideCurve").value;
        } else {
            settings.anmHide[`${activeRole}`].value[i].value = "cubic-bezier(.5,0,.5,1)";
        }
    } else {
        settings.anmHide[`${activeRole}`].value[i].value = parseFloat(document.querySelectorAll(".anmHideRow")[i].querySelector("input").value);
    }
}

function removeAnmHide(i) {
    document.querySelectorAll(".anmHideType")[i].setAttribute("data-active", "false");
    document.querySelectorAll(".anmHideRow")[i].setAttribute("data-show", "false");
    settings.anmHide[`${activeRole}`].value[i].active = false;
}

// save settings

function saveSettings() {
    var presetSettingList = "";

    for (var i = 0; i < colorPreset.length; i++) {
        presetSettingList += `{
            color:"${colorPreset[i].color}",
            opacity:${colorPreset[i].opacity}
        }`;

        if (i < colorPreset.length - 1) {
            presetSettingList += `, `;
        }
    }

    var genStreamerListRes = "";

    for (var i = 0; i < settings.genStreamerList.length; i++) {
        genStreamerListRes += `"${settings.genStreamerList[i]}"`;
        if (i < settings.genStreamerList.length - 1) {
            genStreamerListRes += `, `;
        }
    }

    var genFilterUserRes = "";

    for (var i = 0; i < settings.genFilterUser.length; i++) {
        genFilterUserRes += `"${settings.genFilterUser[i]}"`;
        if (i < settings.genFilterUser.length - 1) {
            genFilterUserRes += `, `;
        }
    }

    var genFilterMsgRes = "";

    for (var i = 0; i < settings.genFilterMsg.length; i++) {
        genFilterMsgRes += `"${settings.genFilterMsg[i]}"`;
        if (i < settings.genFilterMsg.length - 1) {
            genFilterMsgRes += `, `;
        }
    }

    var cbxBackgroundResUser = "";

    for (var i = 0; i < settings.cbxBackground.user.value.length; i++) {
        if (settings.cbxBackground.user.value[i].type === "solid") {
            cbxBackgroundResUser += `{
                type: "solid",
                name: "${settings.cbxBackground.user.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackground.user.value[i].colors[0].position},
                        type: '${settings.cbxBackground.user.value[i].colors[0].type}',
                        color: '${settings.cbxBackground.user.value[i].colors[0].color}',
                        opacity: ${settings.cbxBackground.user.value[i].colors[0].opacity},
                        count: ${settings.cbxBackground.user.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackground.user.value[i].posX.percent},
                    px: ${settings.cbxBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.user.value[i].posY.percent},
                    px: ${settings.cbxBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.user.value[i].width.percent},
                    px: ${settings.cbxBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.user.value[i].height.percent},
                    px: ${settings.cbxBackground.user.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.user.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.user.value[i].colors[j].position},
                    type: '${settings.cbxBackground.user.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.user.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.user.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.user.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundResUser += `{
                type: "linear",
                name: "${settings.cbxBackground.user.value[i].name}",
                rotate: ${settings.cbxBackground.user.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.user.value[i].posX.percent},
                    px: ${settings.cbxBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.user.value[i].posY.percent},
                    px: ${settings.cbxBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.user.value[i].width.percent},
                    px: ${settings.cbxBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.user.value[i].height.percent},
                    px: ${settings.cbxBackground.user.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.user.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.user.value[i].colors[j].position},
                    type: '${settings.cbxBackground.user.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.user.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.user.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.user.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundResUser += `{
                type: "radial",
                name: "${settings.cbxBackground.user.value[i].name}",
                size: "${settings.cbxBackground.user.value[i].size}",
                x: ${settings.cbxBackground.user.value[i].x},
                y: ${settings.cbxBackground.user.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.user.value[i].posX.percent},
                    px: ${settings.cbxBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.user.value[i].posY.percent},
                    px: ${settings.cbxBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.user.value[i].width.percent},
                    px: ${settings.cbxBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.user.value[i].height.percent},
                    px: ${settings.cbxBackground.user.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackground.user.value.length - 1) {
            cbxBackgroundResUser += `, `;
        }
    }

    var cbxBackgroundResSub = "";

    for (var i = 0; i < settings.cbxBackground.sub.value.length; i++) {
        if (settings.cbxBackground.sub.value[i].type === "solid") {
            cbxBackgroundResSub += `{
                type: "solid",
                name: "${settings.cbxBackground.sub.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackground.sub.value[i].colors[0].position},
                        type: '${settings.cbxBackground.sub.value[i].colors[0].type}',
                        color: '${settings.cbxBackground.sub.value[i].colors[0].color}',
                        opacity: ${settings.cbxBackground.sub.value[i].colors[0].opacity},
                        count: ${settings.cbxBackground.sub.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackground.sub.value[i].posX.percent},
                    px: ${settings.cbxBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.sub.value[i].posY.percent},
                    px: ${settings.cbxBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.sub.value[i].width.percent},
                    px: ${settings.cbxBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.sub.value[i].height.percent},
                    px: ${settings.cbxBackground.sub.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.sub.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.sub.value[i].colors[j].position},
                    type: '${settings.cbxBackground.sub.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.sub.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.sub.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.sub.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundResSub += `{
                type: "linear",
                name: "${settings.cbxBackground.sub.value[i].name}",
                rotate: ${settings.cbxBackground.sub.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.sub.value[i].posX.percent},
                    px: ${settings.cbxBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.sub.value[i].posY.percent},
                    px: ${settings.cbxBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.sub.value[i].width.percent},
                    px: ${settings.cbxBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.sub.value[i].height.percent},
                    px: ${settings.cbxBackground.sub.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.sub.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.sub.value[i].colors[j].position},
                    type: '${settings.cbxBackground.sub.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.sub.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.sub.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.sub.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundResSub += `{
                type: "radial",
                name: "${settings.cbxBackground.sub.value[i].name}",
                size: "${settings.cbxBackground.sub.value[i].size}",
                x: ${settings.cbxBackground.sub.value[i].x},
                y: ${settings.cbxBackground.sub.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.sub.value[i].posX.percent},
                    px: ${settings.cbxBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.sub.value[i].posY.percent},
                    px: ${settings.cbxBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.sub.value[i].width.percent},
                    px: ${settings.cbxBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.sub.value[i].height.percent},
                    px: ${settings.cbxBackground.sub.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackground.sub.value.length - 1) {
            cbxBackgroundResSub += `, `;
        }
    }

    var cbxBackgroundResVip = "";

    for (var i = 0; i < settings.cbxBackground.vip.value.length; i++) {
        if (settings.cbxBackground.vip.value[i].type === "solid") {
            cbxBackgroundResVip += `{
                type: "solid",
                name: "${settings.cbxBackground.vip.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackground.vip.value[i].colors[0].position},
                        type: '${settings.cbxBackground.vip.value[i].colors[0].type}',
                        color: '${settings.cbxBackground.vip.value[i].colors[0].color}',
                        opacity: ${settings.cbxBackground.vip.value[i].colors[0].opacity},
                        count: ${settings.cbxBackground.vip.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackground.vip.value[i].posX.percent},
                    px: ${settings.cbxBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.vip.value[i].posY.percent},
                    px: ${settings.cbxBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.vip.value[i].width.percent},
                    px: ${settings.cbxBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.vip.value[i].height.percent},
                    px: ${settings.cbxBackground.vip.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.vip.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.vip.value[i].colors[j].position},
                    type: '${settings.cbxBackground.vip.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.vip.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.vip.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.vip.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundResVip += `{
                type: "linear",
                name: "${settings.cbxBackground.vip.value[i].name}",
                rotate: ${settings.cbxBackground.vip.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.vip.value[i].posX.percent},
                    px: ${settings.cbxBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.vip.value[i].posY.percent},
                    px: ${settings.cbxBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.vip.value[i].width.percent},
                    px: ${settings.cbxBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.vip.value[i].height.percent},
                    px: ${settings.cbxBackground.vip.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.vip.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.vip.value[i].colors[j].position},
                    type: '${settings.cbxBackground.vip.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.vip.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.vip.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.vip.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundResVip += `{
                type: "radial",
                name: "${settings.cbxBackground.vip.value[i].name}",
                size: "${settings.cbxBackground.vip.value[i].size}",
                x: ${settings.cbxBackground.vip.value[i].x},
                y: ${settings.cbxBackground.vip.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.vip.value[i].posX.percent},
                    px: ${settings.cbxBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.vip.value[i].posY.percent},
                    px: ${settings.cbxBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.vip.value[i].width.percent},
                    px: ${settings.cbxBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.vip.value[i].height.percent},
                    px: ${settings.cbxBackground.vip.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackground.vip.value.length - 1) {
            cbxBackgroundResVip += `, `;
        }
    }

    var cbxBackgroundResMod = "";

    for (var i = 0; i < settings.cbxBackground.mod.value.length; i++) {
        if (settings.cbxBackground.mod.value[i].type === "solid") {
            cbxBackgroundResMod += `{
                type: "solid",
                name: "${settings.cbxBackground.mod.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackground.mod.value[i].colors[0].position},
                        type: '${settings.cbxBackground.mod.value[i].colors[0].type}',
                        color: '${settings.cbxBackground.mod.value[i].colors[0].color}',
                        opacity: ${settings.cbxBackground.mod.value[i].colors[0].opacity},
                        count: ${settings.cbxBackground.mod.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackground.mod.value[i].posX.percent},
                    px: ${settings.cbxBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.mod.value[i].posY.percent},
                    px: ${settings.cbxBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.mod.value[i].width.percent},
                    px: ${settings.cbxBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.mod.value[i].height.percent},
                    px: ${settings.cbxBackground.mod.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.mod.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.mod.value[i].colors[j].position},
                    type: '${settings.cbxBackground.mod.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.mod.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.mod.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.mod.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundResMod += `{
                type: "linear",
                name: "${settings.cbxBackground.mod.value[i].name}",
                rotate: ${settings.cbxBackground.mod.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.mod.value[i].posX.percent},
                    px: ${settings.cbxBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.mod.value[i].posY.percent},
                    px: ${settings.cbxBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.mod.value[i].width.percent},
                    px: ${settings.cbxBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.mod.value[i].height.percent},
                    px: ${settings.cbxBackground.mod.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackground.mod.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackground.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackground.mod.value[i].colors[j].position},
                    type: '${settings.cbxBackground.mod.value[i].colors[j].type}',
                    color: '${settings.cbxBackground.mod.value[i].colors[j].color}',
                    opacity: ${settings.cbxBackground.mod.value[i].colors[j].opacity},
                    count: ${settings.cbxBackground.mod.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackground.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundResMod += `{
                type: "radial",
                name: "${settings.cbxBackground.mod.value[i].name}",
                size: "${settings.cbxBackground.mod.value[i].size}",
                x: ${settings.cbxBackground.mod.value[i].x},
                y: ${settings.cbxBackground.mod.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackground.mod.value[i].posX.percent},
                    px: ${settings.cbxBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackground.mod.value[i].posY.percent},
                    px: ${settings.cbxBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackground.mod.value[i].width.percent},
                    px: ${settings.cbxBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackground.mod.value[i].height.percent},
                    px: ${settings.cbxBackground.mod.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackground.mod.value.length - 1) {
            cbxBackgroundResMod += `, `;
        }
    }

    var cbxBackgroundMaskResUser = "";

    for (var i = 0; i < settings.cbxBackgroundMask.user.value.length; i++) {
        if (settings.cbxBackgroundMask.user.value[i].type === "solid") {
            cbxBackgroundMaskResUser += `{
                type: "solid",
                name: "${settings.cbxBackgroundMask.user.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackgroundMask.user.value[i].colors[0].position},
                        opacity: ${settings.cbxBackgroundMask.user.value[i].colors[0].opacity},
                        count: ${settings.cbxBackgroundMask.user.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.user.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.user.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.user.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.user.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundMaskResUser += `{
                type: "linear",
                name: "${settings.cbxBackgroundMask.user.value[i].name}",
                rotate: ${settings.cbxBackgroundMask.user.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.user.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.user.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.user.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.user.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundMaskResUser += `{
                type: "radial",
                name: "${settings.cbxBackgroundMask.user.value[i].name}",
                size: "${settings.cbxBackgroundMask.user.value[i].size}",
                x: ${settings.cbxBackgroundMask.user.value[i].x},
                y: ${settings.cbxBackgroundMask.user.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.user.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.user.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackgroundMask.user.value.length - 1) {
            cbxBackgroundMaskResUser += `, `;
        }
    }

    var cbxBackgroundMaskResSub = "";

    for (var i = 0; i < settings.cbxBackgroundMask.sub.value.length; i++) {
        if (settings.cbxBackgroundMask.sub.value[i].type === "solid") {
            cbxBackgroundMaskResSub += `{
                type: "solid",
                name: "${settings.cbxBackgroundMask.sub.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackgroundMask.sub.value[i].colors[0].position},
                        opacity: ${settings.cbxBackgroundMask.sub.value[i].colors[0].opacity},
                        count: ${settings.cbxBackgroundMask.sub.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.sub.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.sub.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.sub.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.sub.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundMaskResSub += `{
                type: "linear",
                name: "${settings.cbxBackgroundMask.sub.value[i].name}",
                rotate: ${settings.cbxBackgroundMask.sub.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.sub.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.sub.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.sub.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.sub.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundMaskResSub += `{
                type: "radial",
                name: "${settings.cbxBackgroundMask.sub.value[i].name}",
                size: "${settings.cbxBackgroundMask.sub.value[i].size}",
                x: ${settings.cbxBackgroundMask.sub.value[i].x},
                y: ${settings.cbxBackgroundMask.sub.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.sub.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackgroundMask.sub.value.length - 1) {
            cbxBackgroundMaskResSub += `, `;
        }
    }

    var cbxBackgroundMaskResVip = "";

    for (var i = 0; i < settings.cbxBackgroundMask.vip.value.length; i++) {
        if (settings.cbxBackgroundMask.vip.value[i].type === "solid") {
            cbxBackgroundMaskResVip += `{
                type: "solid",
                name: "${settings.cbxBackgroundMask.vip.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackgroundMask.vip.value[i].colors[0].position},
                        opacity: ${settings.cbxBackgroundMask.vip.value[i].colors[0].opacity},
                        count: ${settings.cbxBackgroundMask.vip.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.vip.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.vip.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.vip.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.vip.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundMaskResVip += `{
                type: "linear",
                name: "${settings.cbxBackgroundMask.vip.value[i].name}",
                rotate: ${settings.cbxBackgroundMask.vip.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.vip.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.vip.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.vip.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.vip.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundMaskResVip += `{
                type: "radial",
                name: "${settings.cbxBackgroundMask.vip.value[i].name}",
                size: "${settings.cbxBackgroundMask.vip.value[i].size}",
                x: ${settings.cbxBackgroundMask.vip.value[i].x},
                y: ${settings.cbxBackgroundMask.vip.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.vip.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackgroundMask.vip.value.length - 1) {
            cbxBackgroundMaskResVip += `, `;
        }
    }

    var cbxBackgroundMaskResMod = "";

    for (var i = 0; i < settings.cbxBackgroundMask.mod.value.length; i++) {
        if (settings.cbxBackgroundMask.mod.value[i].type === "solid") {
            cbxBackgroundMaskResMod += `{
                type: "solid",
                name: "${settings.cbxBackgroundMask.mod.value[i].name}",
                colors: [
                    {
                        position: ${settings.cbxBackgroundMask.mod.value[i].colors[0].position},
                        opacity: ${settings.cbxBackgroundMask.mod.value[i].colors[0].opacity},
                        count: ${settings.cbxBackgroundMask.mod.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.mod.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.mod.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.mod.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.mod.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            cbxBackgroundMaskResMod += `{
                type: "linear",
                name: "${settings.cbxBackgroundMask.mod.value[i].name}",
                rotate: ${settings.cbxBackgroundMask.mod.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].height.px}
                }
            }`;
        } else if (settings.cbxBackgroundMask.mod.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.cbxBackgroundMask.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.cbxBackgroundMask.mod.value[i].colors[j].position},
                    opacity: ${settings.cbxBackgroundMask.mod.value[i].colors[j].opacity},
                    count: ${settings.cbxBackgroundMask.mod.value[i].colors[j].count}
                }`;

                if (j < settings.cbxBackgroundMask.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            cbxBackgroundMaskResMod += `{
                type: "radial",
                name: "${settings.cbxBackgroundMask.mod.value[i].name}",
                size: "${settings.cbxBackgroundMask.mod.value[i].size}",
                x: ${settings.cbxBackgroundMask.mod.value[i].x},
                y: ${settings.cbxBackgroundMask.mod.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.cbxBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.cbxBackgroundMask.mod.value[i].height.px}
                }
            }`;
        }

        if (i < settings.cbxBackgroundMask.mod.value.length - 1) {
            cbxBackgroundMaskResMod += `, `;
        }
    }

    var cbxShadowResUser = "";

    for (var i = 0; i < settings.cbxShadow.user.value.length; i++) {
        cbxShadowResUser += `{
        x: ${settings.cbxShadow.user.value[i].x},
        y: ${settings.cbxShadow.user.value[i].y},
        blur: ${settings.cbxShadow.user.value[i].blur},
        expand: ${settings.cbxShadow.user.value[i].expand},
        inset: ${settings.cbxShadow.user.value[i].inset},
        color: {
            type: "${settings.cbxShadow.user.value[i].color.type}",
            color: "${settings.cbxShadow.user.value[i].color.color}",
            opacity: ${settings.cbxShadow.user.value[i].color.opacity}
        }
        }`;

        if (i < settings.cbxShadow.user.value.length - 1) {
            cbxShadowResUser += `, `;
        }
    }

    var cbxShadowResSub = "";

    for (var i = 0; i < settings.cbxShadow.sub.value.length; i++) {
        cbxShadowResSub += `{
        x: ${settings.cbxShadow.sub.value[i].x},
        y: ${settings.cbxShadow.sub.value[i].y},
        blur: ${settings.cbxShadow.sub.value[i].blur},
        expand: ${settings.cbxShadow.sub.value[i].expand},
        inset: ${settings.cbxShadow.sub.value[i].inset},
        color: {
            type: "${settings.cbxShadow.sub.value[i].color.type}",
            color: "${settings.cbxShadow.sub.value[i].color.color}",
            opacity: ${settings.cbxShadow.sub.value[i].color.opacity}
        }
        }`;

        if (i < settings.cbxShadow.sub.value.length - 1) {
            cbxShadowResSub += `, `;
        }
    }

    var cbxShadowResVip = "";

    for (var i = 0; i < settings.cbxShadow.vip.value.length; i++) {
        cbxShadowResVip += `{
        x: ${settings.cbxShadow.vip.value[i].x},
        y: ${settings.cbxShadow.vip.value[i].y},
        blur: ${settings.cbxShadow.vip.value[i].blur},
        expand: ${settings.cbxShadow.vip.value[i].expand},
        inset: ${settings.cbxShadow.vip.value[i].inset},
        color: {
            type: "${settings.cbxShadow.vip.value[i].color.type}",
            color: "${settings.cbxShadow.vip.value[i].color.color}",
            opacity: ${settings.cbxShadow.vip.value[i].color.opacity}
        }
        }`;

        if (i < settings.cbxShadow.vip.value.length - 1) {
            cbxShadowResVip += `, `;
        }
    }

    var cbxShadowResMod = "";

    for (var i = 0; i < settings.cbxShadow.mod.value.length; i++) {
        cbxShadowResMod += `{
        x: ${settings.cbxShadow.mod.value[i].x},
        y: ${settings.cbxShadow.mod.value[i].y},
        blur: ${settings.cbxShadow.mod.value[i].blur},
        expand: ${settings.cbxShadow.mod.value[i].expand},
        inset: ${settings.cbxShadow.mod.value[i].inset},
        color: {
            type: "${settings.cbxShadow.mod.value[i].color.type}",
            color: "${settings.cbxShadow.mod.value[i].color.color}",
            opacity: ${settings.cbxShadow.mod.value[i].color.opacity}
        }
        }`;

        if (i < settings.cbxShadow.mod.value.length - 1) {
            cbxShadowResMod += `, `;
        }
    }

    var usnBackgroundResUser = "";

    for (var i = 0; i < settings.usnBackground.user.value.length; i++) {
        if (settings.usnBackground.user.value[i].type === "solid") {
            usnBackgroundResUser += `{
                type: "solid",
                name: "${settings.usnBackground.user.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackground.user.value[i].colors[0].position},
                        type: '${settings.usnBackground.user.value[i].colors[0].type}',
                        color: '${settings.usnBackground.user.value[i].colors[0].color}',
                        opacity: ${settings.usnBackground.user.value[i].colors[0].opacity},
                        count: ${settings.usnBackground.user.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackground.user.value[i].posX.percent},
                    px: ${settings.usnBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.user.value[i].posY.percent},
                    px: ${settings.usnBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.user.value[i].width.percent},
                    px: ${settings.usnBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.user.value[i].height.percent},
                    px: ${settings.usnBackground.user.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.user.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.user.value[i].colors[j].position},
                    type: '${settings.usnBackground.user.value[i].colors[j].type}',
                    color: '${settings.usnBackground.user.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.user.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.user.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundResUser += `{
                type: "linear",
                name: "${settings.usnBackground.user.value[i].name}",
                rotate: ${settings.usnBackground.user.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.user.value[i].posX.percent},
                    px: ${settings.usnBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.user.value[i].posY.percent},
                    px: ${settings.usnBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.user.value[i].width.percent},
                    px: ${settings.usnBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.user.value[i].height.percent},
                    px: ${settings.usnBackground.user.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.user.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.user.value[i].colors[j].position},
                    type: '${settings.usnBackground.user.value[i].colors[j].type}',
                    color: '${settings.usnBackground.user.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.user.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.user.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundResUser += `{
                type: "radial",
                name: "${settings.usnBackground.user.value[i].name}",
                size: "${settings.usnBackground.user.value[i].size}",
                x: ${settings.usnBackground.user.value[i].x},
                y: ${settings.usnBackground.user.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.user.value[i].posX.percent},
                    px: ${settings.usnBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.user.value[i].posY.percent},
                    px: ${settings.usnBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.user.value[i].width.percent},
                    px: ${settings.usnBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.user.value[i].height.percent},
                    px: ${settings.usnBackground.user.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackground.user.value.length - 1) {
            usnBackgroundResUser += `, `;
        }
    }

    var usnBackgroundResSub = "";

    for (var i = 0; i < settings.usnBackground.sub.value.length; i++) {
        if (settings.usnBackground.sub.value[i].type === "solid") {
            usnBackgroundResSub += `{
                type: "solid",
                name: "${settings.usnBackground.sub.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackground.sub.value[i].colors[0].position},
                        type: '${settings.usnBackground.sub.value[i].colors[0].type}',
                        color: '${settings.usnBackground.sub.value[i].colors[0].color}',
                        opacity: ${settings.usnBackground.sub.value[i].colors[0].opacity},
                        count: ${settings.usnBackground.sub.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackground.sub.value[i].posX.percent},
                    px: ${settings.usnBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.sub.value[i].posY.percent},
                    px: ${settings.usnBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.sub.value[i].width.percent},
                    px: ${settings.usnBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.sub.value[i].height.percent},
                    px: ${settings.usnBackground.sub.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.sub.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.sub.value[i].colors[j].position},
                    type: '${settings.usnBackground.sub.value[i].colors[j].type}',
                    color: '${settings.usnBackground.sub.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.sub.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.sub.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundResSub += `{
                type: "linear",
                name: "${settings.usnBackground.sub.value[i].name}",
                rotate: ${settings.usnBackground.sub.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.sub.value[i].posX.percent},
                    px: ${settings.usnBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.sub.value[i].posY.percent},
                    px: ${settings.usnBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.sub.value[i].width.percent},
                    px: ${settings.usnBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.sub.value[i].height.percent},
                    px: ${settings.usnBackground.sub.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.sub.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.sub.value[i].colors[j].position},
                    type: '${settings.usnBackground.sub.value[i].colors[j].type}',
                    color: '${settings.usnBackground.sub.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.sub.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.sub.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundResSub += `{
                type: "radial",
                name: "${settings.usnBackground.sub.value[i].name}",
                size: "${settings.usnBackground.sub.value[i].size}",
                x: ${settings.usnBackground.sub.value[i].x},
                y: ${settings.usnBackground.sub.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.sub.value[i].posX.percent},
                    px: ${settings.usnBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.sub.value[i].posY.percent},
                    px: ${settings.usnBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.sub.value[i].width.percent},
                    px: ${settings.usnBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.sub.value[i].height.percent},
                    px: ${settings.usnBackground.sub.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackground.sub.value.length - 1) {
            usnBackgroundResSub += `, `;
        }
    }

    var usnBackgroundResVip = "";

    for (var i = 0; i < settings.usnBackground.vip.value.length; i++) {
        if (settings.usnBackground.vip.value[i].type === "solid") {
            usnBackgroundResVip += `{
                type: "solid",
                name: "${settings.usnBackground.vip.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackground.vip.value[i].colors[0].position},
                        type: '${settings.usnBackground.vip.value[i].colors[0].type}',
                        color: '${settings.usnBackground.vip.value[i].colors[0].color}',
                        opacity: ${settings.usnBackground.vip.value[i].colors[0].opacity},
                        count: ${settings.usnBackground.vip.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackground.vip.value[i].posX.percent},
                    px: ${settings.usnBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.vip.value[i].posY.percent},
                    px: ${settings.usnBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.vip.value[i].width.percent},
                    px: ${settings.usnBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.vip.value[i].height.percent},
                    px: ${settings.usnBackground.vip.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.vip.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.vip.value[i].colors[j].position},
                    type: '${settings.usnBackground.vip.value[i].colors[j].type}',
                    color: '${settings.usnBackground.vip.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.vip.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.vip.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundResVip += `{
                type: "linear",
                name: "${settings.usnBackground.vip.value[i].name}",
                rotate: ${settings.usnBackground.vip.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.vip.value[i].posX.percent},
                    px: ${settings.usnBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.vip.value[i].posY.percent},
                    px: ${settings.usnBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.vip.value[i].width.percent},
                    px: ${settings.usnBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.vip.value[i].height.percent},
                    px: ${settings.usnBackground.vip.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.vip.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.vip.value[i].colors[j].position},
                    type: '${settings.usnBackground.vip.value[i].colors[j].type}',
                    color: '${settings.usnBackground.vip.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.vip.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.vip.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundResVip += `{
                type: "radial",
                name: "${settings.usnBackground.vip.value[i].name}",
                size: "${settings.usnBackground.vip.value[i].size}",
                x: ${settings.usnBackground.vip.value[i].x},
                y: ${settings.usnBackground.vip.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.vip.value[i].posX.percent},
                    px: ${settings.usnBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.vip.value[i].posY.percent},
                    px: ${settings.usnBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.vip.value[i].width.percent},
                    px: ${settings.usnBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.vip.value[i].height.percent},
                    px: ${settings.usnBackground.vip.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackground.vip.value.length - 1) {
            usnBackgroundResVip += `, `;
        }
    }

    var usnBackgroundResMod = "";

    for (var i = 0; i < settings.usnBackground.mod.value.length; i++) {
        if (settings.usnBackground.mod.value[i].type === "solid") {
            usnBackgroundResMod += `{
                type: "solid",
                name: "${settings.usnBackground.mod.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackground.mod.value[i].colors[0].position},
                        type: '${settings.usnBackground.mod.value[i].colors[0].type}',
                        color: '${settings.usnBackground.mod.value[i].colors[0].color}',
                        opacity: ${settings.usnBackground.mod.value[i].colors[0].opacity},
                        count: ${settings.usnBackground.mod.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackground.mod.value[i].posX.percent},
                    px: ${settings.usnBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.mod.value[i].posY.percent},
                    px: ${settings.usnBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.mod.value[i].width.percent},
                    px: ${settings.usnBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.mod.value[i].height.percent},
                    px: ${settings.usnBackground.mod.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.mod.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.mod.value[i].colors[j].position},
                    type: '${settings.usnBackground.mod.value[i].colors[j].type}',
                    color: '${settings.usnBackground.mod.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.mod.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.mod.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundResMod += `{
                type: "linear",
                name: "${settings.usnBackground.mod.value[i].name}",
                rotate: ${settings.usnBackground.mod.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.mod.value[i].posX.percent},
                    px: ${settings.usnBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.mod.value[i].posY.percent},
                    px: ${settings.usnBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.mod.value[i].width.percent},
                    px: ${settings.usnBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.mod.value[i].height.percent},
                    px: ${settings.usnBackground.mod.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackground.mod.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackground.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackground.mod.value[i].colors[j].position},
                    type: '${settings.usnBackground.mod.value[i].colors[j].type}',
                    color: '${settings.usnBackground.mod.value[i].colors[j].color}',
                    opacity: ${settings.usnBackground.mod.value[i].colors[j].opacity},
                    count: ${settings.usnBackground.mod.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackground.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundResMod += `{
                type: "radial",
                name: "${settings.usnBackground.mod.value[i].name}",
                size: "${settings.usnBackground.mod.value[i].size}",
                x: ${settings.usnBackground.mod.value[i].x},
                y: ${settings.usnBackground.mod.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackground.mod.value[i].posX.percent},
                    px: ${settings.usnBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackground.mod.value[i].posY.percent},
                    px: ${settings.usnBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackground.mod.value[i].width.percent},
                    px: ${settings.usnBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackground.mod.value[i].height.percent},
                    px: ${settings.usnBackground.mod.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackground.mod.value.length - 1) {
            usnBackgroundResMod += `, `;
        }
    }

    var usnBackgroundMaskResUser = "";

    for (var i = 0; i < settings.usnBackgroundMask.user.value.length; i++) {
        if (settings.usnBackgroundMask.user.value[i].type === "solid") {
            usnBackgroundMaskResUser += `{
                type: "solid",
                name: "${settings.usnBackgroundMask.user.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackgroundMask.user.value[i].colors[0].position},
                        opacity: ${settings.usnBackgroundMask.user.value[i].colors[0].opacity},
                        count: ${settings.usnBackgroundMask.user.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.user.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.user.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.user.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.user.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.user.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.user.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundMaskResUser += `{
                type: "linear",
                name: "${settings.usnBackgroundMask.user.value[i].name}",
                rotate: ${settings.usnBackgroundMask.user.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.user.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.user.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.user.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.user.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.user.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.user.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundMaskResUser += `{
                type: "radial",
                name: "${settings.usnBackgroundMask.user.value[i].name}",
                size: "${settings.usnBackgroundMask.user.value[i].size}",
                x: ${settings.usnBackgroundMask.user.value[i].x},
                y: ${settings.usnBackgroundMask.user.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.user.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.user.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.user.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackgroundMask.user.value.length - 1) {
            usnBackgroundMaskResUser += `, `;
        }
    }

    var usnBackgroundMaskResSub = "";

    for (var i = 0; i < settings.usnBackgroundMask.sub.value.length; i++) {
        if (settings.usnBackgroundMask.sub.value[i].type === "solid") {
            usnBackgroundMaskResSub += `{
                type: "solid",
                name: "${settings.usnBackgroundMask.sub.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackgroundMask.sub.value[i].colors[0].position},
                        opacity: ${settings.usnBackgroundMask.sub.value[i].colors[0].opacity},
                        count: ${settings.usnBackgroundMask.sub.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.sub.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.sub.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.sub.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.sub.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundMaskResSub += `{
                type: "linear",
                name: "${settings.usnBackgroundMask.sub.value[i].name}",
                rotate: ${settings.usnBackgroundMask.sub.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.sub.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.sub.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.sub.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.sub.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundMaskResSub += `{
                type: "radial",
                name: "${settings.usnBackgroundMask.sub.value[i].name}",
                size: "${settings.usnBackgroundMask.sub.value[i].size}",
                x: ${settings.usnBackgroundMask.sub.value[i].x},
                y: ${settings.usnBackgroundMask.sub.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.sub.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackgroundMask.sub.value.length - 1) {
            usnBackgroundMaskResSub += `, `;
        }
    }

    var usnBackgroundMaskResVip = "";

    for (var i = 0; i < settings.usnBackgroundMask.vip.value.length; i++) {
        if (settings.usnBackgroundMask.vip.value[i].type === "solid") {
            usnBackgroundMaskResVip += `{
                type: "solid",
                name: "${settings.usnBackgroundMask.vip.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackgroundMask.vip.value[i].colors[0].position},
                        opacity: ${settings.usnBackgroundMask.vip.value[i].colors[0].opacity},
                        count: ${settings.usnBackgroundMask.vip.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.vip.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.vip.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.vip.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.vip.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundMaskResVip += `{
                type: "linear",
                name: "${settings.usnBackgroundMask.vip.value[i].name}",
                rotate: ${settings.usnBackgroundMask.vip.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.vip.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.vip.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.vip.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.vip.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundMaskResVip += `{
                type: "radial",
                name: "${settings.usnBackgroundMask.vip.value[i].name}",
                size: "${settings.usnBackgroundMask.vip.value[i].size}",
                x: ${settings.usnBackgroundMask.vip.value[i].x},
                y: ${settings.usnBackgroundMask.vip.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.vip.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackgroundMask.vip.value.length - 1) {
            usnBackgroundMaskResVip += `, `;
        }
    }

    var usnBackgroundMaskResMod = "";

    for (var i = 0; i < settings.usnBackgroundMask.mod.value.length; i++) {
        if (settings.usnBackgroundMask.mod.value[i].type === "solid") {
            usnBackgroundMaskResMod += `{
                type: "solid",
                name: "${settings.usnBackgroundMask.mod.value[i].name}",
                colors: [
                    {
                        position: ${settings.usnBackgroundMask.mod.value[i].colors[0].position},
                        opacity: ${settings.usnBackgroundMask.mod.value[i].colors[0].opacity},
                        count: ${settings.usnBackgroundMask.mod.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.mod.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.mod.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.mod.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.mod.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            usnBackgroundMaskResMod += `{
                type: "linear",
                name: "${settings.usnBackgroundMask.mod.value[i].name}",
                rotate: ${settings.usnBackgroundMask.mod.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].height.px}
                }
            }`;
        } else if (settings.usnBackgroundMask.mod.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.usnBackgroundMask.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.usnBackgroundMask.mod.value[i].colors[j].position},
                    opacity: ${settings.usnBackgroundMask.mod.value[i].colors[j].opacity},
                    count: ${settings.usnBackgroundMask.mod.value[i].colors[j].count}
                }`;

                if (j < settings.usnBackgroundMask.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            usnBackgroundMaskResMod += `{
                type: "radial",
                name: "${settings.usnBackgroundMask.mod.value[i].name}",
                size: "${settings.usnBackgroundMask.mod.value[i].size}",
                x: ${settings.usnBackgroundMask.mod.value[i].x},
                y: ${settings.usnBackgroundMask.mod.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.usnBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.usnBackgroundMask.mod.value[i].height.px}
                }
            }`;
        }

        if (i < settings.usnBackgroundMask.mod.value.length - 1) {
            usnBackgroundMaskResMod += `, `;
        }
    }

    var usnShadowResUser = "";

    for (var i = 0; i < settings.usnShadow.user.value.length; i++) {
        usnShadowResUser += `{
        x: ${settings.usnShadow.user.value[i].x},
        y: ${settings.usnShadow.user.value[i].y},
        blur: ${settings.usnShadow.user.value[i].blur},
        expand: ${settings.usnShadow.user.value[i].expand},
        inset: ${settings.usnShadow.user.value[i].inset},
        color: {
            type: "${settings.usnShadow.user.value[i].color.type}",
            color: "${settings.usnShadow.user.value[i].color.color}",
            opacity: ${settings.usnShadow.user.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnShadow.user.value.length - 1) {
            usnShadowResUser += `, `;
        }
    }

    var usnShadowResSub = "";

    for (var i = 0; i < settings.usnShadow.sub.value.length; i++) {
        usnShadowResSub += `{
        x: ${settings.usnShadow.sub.value[i].x},
        y: ${settings.usnShadow.sub.value[i].y},
        blur: ${settings.usnShadow.sub.value[i].blur},
        expand: ${settings.usnShadow.sub.value[i].expand},
        inset: ${settings.usnShadow.sub.value[i].inset},
        color: {
            type: "${settings.usnShadow.sub.value[i].color.type}",
            color: "${settings.usnShadow.sub.value[i].color.color}",
            opacity: ${settings.usnShadow.sub.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnShadow.sub.value.length - 1) {
            usnShadowResSub += `, `;
        }
    }

    var usnShadowResVip = "";

    for (var i = 0; i < settings.usnShadow.vip.value.length; i++) {
        usnShadowResVip += `{
        x: ${settings.usnShadow.vip.value[i].x},
        y: ${settings.usnShadow.vip.value[i].y},
        blur: ${settings.usnShadow.vip.value[i].blur},
        expand: ${settings.usnShadow.vip.value[i].expand},
        inset: ${settings.usnShadow.vip.value[i].inset},
        color: {
            type: "${settings.usnShadow.vip.value[i].color.type}",
            color: "${settings.usnShadow.vip.value[i].color.color}",
            opacity: ${settings.usnShadow.vip.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnShadow.vip.value.length - 1) {
            usnShadowResVip += `, `;
        }
    }

    var usnShadowResMod = "";

    for (var i = 0; i < settings.usnShadow.mod.value.length; i++) {
        usnShadowResMod += `{
        x: ${settings.usnShadow.mod.value[i].x},
        y: ${settings.usnShadow.mod.value[i].y},
        blur: ${settings.usnShadow.mod.value[i].blur},
        expand: ${settings.usnShadow.mod.value[i].expand},
        inset: ${settings.usnShadow.mod.value[i].inset},
        color: {
            type: "${settings.usnShadow.mod.value[i].color.type}",
            color: "${settings.usnShadow.mod.value[i].color.color}",
            opacity: ${settings.usnShadow.mod.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnShadow.mod.value.length - 1) {
            usnShadowResMod += `, `;
        }
    }

    var usnFontShadowResUser = "";

    for (var i = 0; i < settings.usnFontShadow.user.value.length; i++) {
        usnFontShadowResUser += `{
        x: ${settings.usnFontShadow.user.value[i].x},
        y: ${settings.usnFontShadow.user.value[i].y},
        blur: ${settings.usnFontShadow.user.value[i].blur},
        color: {
            type: "${settings.usnFontShadow.user.value[i].color.type}",
            color: "${settings.usnFontShadow.user.value[i].color.color}",
            opacity: ${settings.usnFontShadow.user.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnFontShadow.user.value.length - 1) {
            usnFontShadowResUser += `, `;
        }
    }

    var usnFontShadowResSub = "";

    for (var i = 0; i < settings.usnFontShadow.sub.value.length; i++) {
        usnFontShadowResSub += `{
        x: ${settings.usnFontShadow.sub.value[i].x},
        y: ${settings.usnFontShadow.sub.value[i].y},
        blur: ${settings.usnFontShadow.sub.value[i].blur},
        color: {
            type: "${settings.usnFontShadow.sub.value[i].color.type}",
            color: "${settings.usnFontShadow.sub.value[i].color.color}",
            opacity: ${settings.usnFontShadow.sub.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnFontShadow.sub.value.length - 1) {
            usnFontShadowResSub += `, `;
        }
    }

    var usnFontShadowResVip = "";

    for (var i = 0; i < settings.usnFontShadow.vip.value.length; i++) {
        usnFontShadowResVip += `{
        x: ${settings.usnFontShadow.vip.value[i].x},
        y: ${settings.usnFontShadow.vip.value[i].y},
        blur: ${settings.usnFontShadow.vip.value[i].blur},
        color: {
            type: "${settings.usnFontShadow.vip.value[i].color.type}",
            color: "${settings.usnFontShadow.vip.value[i].color.color}",
            opacity: ${settings.usnFontShadow.vip.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnFontShadow.vip.value.length - 1) {
            usnFontShadowResVip += `, `;
        }
    }

    var usnFontShadowResMod = "";

    for (var i = 0; i < settings.usnFontShadow.mod.value.length; i++) {
        usnFontShadowResMod += `{
        x: ${settings.usnFontShadow.mod.value[i].x},
        y: ${settings.usnFontShadow.mod.value[i].y},
        blur: ${settings.usnFontShadow.mod.value[i].blur},
        color: {
            type: "${settings.usnFontShadow.mod.value[i].color.type}",
            color: "${settings.usnFontShadow.mod.value[i].color.color}",
            opacity: ${settings.usnFontShadow.mod.value[i].color.opacity}
        }
        }`;

        if (i < settings.usnFontShadow.mod.value.length - 1) {
            usnFontShadowResMod += `, `;
        }
    }

    var msgBackgroundResUser = "";

    for (var i = 0; i < settings.msgBackground.user.value.length; i++) {
        if (settings.msgBackground.user.value[i].type === "solid") {
            msgBackgroundResUser += `{
                type: "solid",
                name: "${settings.msgBackground.user.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackground.user.value[i].colors[0].position},
                        type: '${settings.msgBackground.user.value[i].colors[0].type}',
                        color: '${settings.msgBackground.user.value[i].colors[0].color}',
                        opacity: ${settings.msgBackground.user.value[i].colors[0].opacity},
                        count: ${settings.msgBackground.user.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackground.user.value[i].posX.percent},
                    px: ${settings.msgBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.user.value[i].posY.percent},
                    px: ${settings.msgBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.user.value[i].width.percent},
                    px: ${settings.msgBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.user.value[i].height.percent},
                    px: ${settings.msgBackground.user.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.user.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.user.value[i].colors[j].position},
                    type: '${settings.msgBackground.user.value[i].colors[j].type}',
                    color: '${settings.msgBackground.user.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.user.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.user.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundResUser += `{
                type: "linear",
                name: "${settings.msgBackground.user.value[i].name}",
                rotate: ${settings.msgBackground.user.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.user.value[i].posX.percent},
                    px: ${settings.msgBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.user.value[i].posY.percent},
                    px: ${settings.msgBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.user.value[i].width.percent},
                    px: ${settings.msgBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.user.value[i].height.percent},
                    px: ${settings.msgBackground.user.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.user.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.user.value[i].colors[j].position},
                    type: '${settings.msgBackground.user.value[i].colors[j].type}',
                    color: '${settings.msgBackground.user.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.user.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.user.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundResUser += `{
                type: "radial",
                name: "${settings.msgBackground.user.value[i].name}",
                size: "${settings.msgBackground.user.value[i].size}",
                x: ${settings.msgBackground.user.value[i].x},
                y: ${settings.msgBackground.user.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.user.value[i].posX.percent},
                    px: ${settings.msgBackground.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.user.value[i].posY.percent},
                    px: ${settings.msgBackground.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.user.value[i].width.percent},
                    px: ${settings.msgBackground.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.user.value[i].height.percent},
                    px: ${settings.msgBackground.user.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackground.user.value.length - 1) {
            msgBackgroundResUser += `, `;
        }
    }

    var msgBackgroundResSub = "";

    for (var i = 0; i < settings.msgBackground.sub.value.length; i++) {
        if (settings.msgBackground.sub.value[i].type === "solid") {
            msgBackgroundResSub += `{
                type: "solid",
                name: "${settings.msgBackground.sub.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackground.sub.value[i].colors[0].position},
                        type: '${settings.msgBackground.sub.value[i].colors[0].type}',
                        color: '${settings.msgBackground.sub.value[i].colors[0].color}',
                        opacity: ${settings.msgBackground.sub.value[i].colors[0].opacity},
                        count: ${settings.msgBackground.sub.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackground.sub.value[i].posX.percent},
                    px: ${settings.msgBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.sub.value[i].posY.percent},
                    px: ${settings.msgBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.sub.value[i].width.percent},
                    px: ${settings.msgBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.sub.value[i].height.percent},
                    px: ${settings.msgBackground.sub.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.sub.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.sub.value[i].colors[j].position},
                    type: '${settings.msgBackground.sub.value[i].colors[j].type}',
                    color: '${settings.msgBackground.sub.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.sub.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.sub.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundResSub += `{
                type: "linear",
                name: "${settings.msgBackground.sub.value[i].name}",
                rotate: ${settings.msgBackground.sub.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.sub.value[i].posX.percent},
                    px: ${settings.msgBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.sub.value[i].posY.percent},
                    px: ${settings.msgBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.sub.value[i].width.percent},
                    px: ${settings.msgBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.sub.value[i].height.percent},
                    px: ${settings.msgBackground.sub.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.sub.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.sub.value[i].colors[j].position},
                    type: '${settings.msgBackground.sub.value[i].colors[j].type}',
                    color: '${settings.msgBackground.sub.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.sub.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.sub.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundResSub += `{
                type: "radial",
                name: "${settings.msgBackground.sub.value[i].name}",
                size: "${settings.msgBackground.sub.value[i].size}",
                x: ${settings.msgBackground.sub.value[i].x},
                y: ${settings.msgBackground.sub.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.sub.value[i].posX.percent},
                    px: ${settings.msgBackground.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.sub.value[i].posY.percent},
                    px: ${settings.msgBackground.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.sub.value[i].width.percent},
                    px: ${settings.msgBackground.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.sub.value[i].height.percent},
                    px: ${settings.msgBackground.sub.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackground.sub.value.length - 1) {
            msgBackgroundResSub += `, `;
        }
    }

    var msgBackgroundResVip = "";

    for (var i = 0; i < settings.msgBackground.vip.value.length; i++) {
        if (settings.msgBackground.vip.value[i].type === "solid") {
            msgBackgroundResVip += `{
                type: "solid",
                name: "${settings.msgBackground.vip.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackground.vip.value[i].colors[0].position},
                        type: '${settings.msgBackground.vip.value[i].colors[0].type}',
                        color: '${settings.msgBackground.vip.value[i].colors[0].color}',
                        opacity: ${settings.msgBackground.vip.value[i].colors[0].opacity},
                        count: ${settings.msgBackground.vip.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackground.vip.value[i].posX.percent},
                    px: ${settings.msgBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.vip.value[i].posY.percent},
                    px: ${settings.msgBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.vip.value[i].width.percent},
                    px: ${settings.msgBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.vip.value[i].height.percent},
                    px: ${settings.msgBackground.vip.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.vip.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.vip.value[i].colors[j].position},
                    type: '${settings.msgBackground.vip.value[i].colors[j].type}',
                    color: '${settings.msgBackground.vip.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.vip.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.vip.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundResVip += `{
                type: "linear",
                name: "${settings.msgBackground.vip.value[i].name}",
                rotate: ${settings.msgBackground.vip.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.vip.value[i].posX.percent},
                    px: ${settings.msgBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.vip.value[i].posY.percent},
                    px: ${settings.msgBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.vip.value[i].width.percent},
                    px: ${settings.msgBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.vip.value[i].height.percent},
                    px: ${settings.msgBackground.vip.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.vip.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.vip.value[i].colors[j].position},
                    type: '${settings.msgBackground.vip.value[i].colors[j].type}',
                    color: '${settings.msgBackground.vip.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.vip.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.vip.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundResVip += `{
                type: "radial",
                name: "${settings.msgBackground.vip.value[i].name}",
                size: "${settings.msgBackground.vip.value[i].size}",
                x: ${settings.msgBackground.vip.value[i].x},
                y: ${settings.msgBackground.vip.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.vip.value[i].posX.percent},
                    px: ${settings.msgBackground.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.vip.value[i].posY.percent},
                    px: ${settings.msgBackground.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.vip.value[i].width.percent},
                    px: ${settings.msgBackground.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.vip.value[i].height.percent},
                    px: ${settings.msgBackground.vip.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackground.vip.value.length - 1) {
            msgBackgroundResVip += `, `;
        }
    }

    var msgBackgroundResMod = "";

    for (var i = 0; i < settings.msgBackground.mod.value.length; i++) {
        if (settings.msgBackground.mod.value[i].type === "solid") {
            msgBackgroundResMod += `{
                type: "solid",
                name: "${settings.msgBackground.mod.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackground.mod.value[i].colors[0].position},
                        type: '${settings.msgBackground.mod.value[i].colors[0].type}',
                        color: '${settings.msgBackground.mod.value[i].colors[0].color}',
                        opacity: ${settings.msgBackground.mod.value[i].colors[0].opacity},
                        count: ${settings.msgBackground.mod.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackground.mod.value[i].posX.percent},
                    px: ${settings.msgBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.mod.value[i].posY.percent},
                    px: ${settings.msgBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.mod.value[i].width.percent},
                    px: ${settings.msgBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.mod.value[i].height.percent},
                    px: ${settings.msgBackground.mod.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.mod.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.mod.value[i].colors[j].position},
                    type: '${settings.msgBackground.mod.value[i].colors[j].type}',
                    color: '${settings.msgBackground.mod.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.mod.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.mod.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundResMod += `{
                type: "linear",
                name: "${settings.msgBackground.mod.value[i].name}",
                rotate: ${settings.msgBackground.mod.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.mod.value[i].posX.percent},
                    px: ${settings.msgBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.mod.value[i].posY.percent},
                    px: ${settings.msgBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.mod.value[i].width.percent},
                    px: ${settings.msgBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.mod.value[i].height.percent},
                    px: ${settings.msgBackground.mod.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackground.mod.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackground.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackground.mod.value[i].colors[j].position},
                    type: '${settings.msgBackground.mod.value[i].colors[j].type}',
                    color: '${settings.msgBackground.mod.value[i].colors[j].color}',
                    opacity: ${settings.msgBackground.mod.value[i].colors[j].opacity},
                    count: ${settings.msgBackground.mod.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackground.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundResMod += `{
                type: "radial",
                name: "${settings.msgBackground.mod.value[i].name}",
                size: "${settings.msgBackground.mod.value[i].size}",
                x: ${settings.msgBackground.mod.value[i].x},
                y: ${settings.msgBackground.mod.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackground.mod.value[i].posX.percent},
                    px: ${settings.msgBackground.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackground.mod.value[i].posY.percent},
                    px: ${settings.msgBackground.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackground.mod.value[i].width.percent},
                    px: ${settings.msgBackground.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackground.mod.value[i].height.percent},
                    px: ${settings.msgBackground.mod.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackground.mod.value.length - 1) {
            msgBackgroundResMod += `, `;
        }
    }

    var msgBackgroundMaskResUser = "";

    for (var i = 0; i < settings.msgBackgroundMask.user.value.length; i++) {
        if (settings.msgBackgroundMask.user.value[i].type === "solid") {
            msgBackgroundMaskResUser += `{
                type: "solid",
                name: "${settings.msgBackgroundMask.user.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackgroundMask.user.value[i].colors[0].position},
                        opacity: ${settings.msgBackgroundMask.user.value[i].colors[0].opacity},
                        count: ${settings.msgBackgroundMask.user.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.user.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.user.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.user.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.user.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.user.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.user.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundMaskResUser += `{
                type: "linear",
                name: "${settings.msgBackgroundMask.user.value[i].name}",
                rotate: ${settings.msgBackgroundMask.user.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.user.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.user.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.user.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.user.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.user.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.user.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.user.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.user.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundMaskResUser += `{
                type: "radial",
                name: "${settings.msgBackgroundMask.user.value[i].name}",
                size: "${settings.msgBackgroundMask.user.value[i].size}",
                x: ${settings.msgBackgroundMask.user.value[i].x},
                y: ${settings.msgBackgroundMask.user.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.user.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.user.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.user.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.user.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.user.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackgroundMask.user.value.length - 1) {
            msgBackgroundMaskResUser += `, `;
        }
    }

    var msgBackgroundMaskResSub = "";

    for (var i = 0; i < settings.msgBackgroundMask.sub.value.length; i++) {
        if (settings.msgBackgroundMask.sub.value[i].type === "solid") {
            msgBackgroundMaskResSub += `{
                type: "solid",
                name: "${settings.msgBackgroundMask.sub.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackgroundMask.sub.value[i].colors[0].position},
                        opacity: ${settings.msgBackgroundMask.sub.value[i].colors[0].opacity},
                        count: ${settings.msgBackgroundMask.sub.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.sub.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.sub.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.sub.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.sub.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundMaskResSub += `{
                type: "linear",
                name: "${settings.msgBackgroundMask.sub.value[i].name}",
                rotate: ${settings.msgBackgroundMask.sub.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.sub.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.sub.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.sub.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.sub.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.sub.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.sub.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundMaskResSub += `{
                type: "radial",
                name: "${settings.msgBackgroundMask.sub.value[i].name}",
                size: "${settings.msgBackgroundMask.sub.value[i].size}",
                x: ${settings.msgBackgroundMask.sub.value[i].x},
                y: ${settings.msgBackgroundMask.sub.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.sub.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.sub.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackgroundMask.sub.value.length - 1) {
            msgBackgroundMaskResSub += `, `;
        }
    }

    var msgBackgroundMaskResVip = "";

    for (var i = 0; i < settings.msgBackgroundMask.vip.value.length; i++) {
        if (settings.msgBackgroundMask.vip.value[i].type === "solid") {
            msgBackgroundMaskResVip += `{
                type: "solid",
                name: "${settings.msgBackgroundMask.vip.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackgroundMask.vip.value[i].colors[0].position},
                        opacity: ${settings.msgBackgroundMask.vip.value[i].colors[0].opacity},
                        count: ${settings.msgBackgroundMask.vip.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.vip.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.vip.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.vip.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.vip.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundMaskResVip += `{
                type: "linear",
                name: "${settings.msgBackgroundMask.vip.value[i].name}",
                rotate: ${settings.msgBackgroundMask.vip.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.vip.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.vip.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.vip.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.vip.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.vip.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.vip.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundMaskResVip += `{
                type: "radial",
                name: "${settings.msgBackgroundMask.vip.value[i].name}",
                size: "${settings.msgBackgroundMask.vip.value[i].size}",
                x: ${settings.msgBackgroundMask.vip.value[i].x},
                y: ${settings.msgBackgroundMask.vip.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.vip.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.vip.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackgroundMask.vip.value.length - 1) {
            msgBackgroundMaskResVip += `, `;
        }
    }

    var msgBackgroundMaskResMod = "";

    for (var i = 0; i < settings.msgBackgroundMask.mod.value.length; i++) {
        if (settings.msgBackgroundMask.mod.value[i].type === "solid") {
            msgBackgroundMaskResMod += `{
                type: "solid",
                name: "${settings.msgBackgroundMask.mod.value[i].name}",
                colors: [
                    {
                        position: ${settings.msgBackgroundMask.mod.value[i].colors[0].position},
                        opacity: ${settings.msgBackgroundMask.mod.value[i].colors[0].opacity},
                        count: ${settings.msgBackgroundMask.mod.value[i].colors[0].count}
                    }
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.mod.value[i].type === "linear") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.mod.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.mod.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.mod.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }


            msgBackgroundMaskResMod += `{
                type: "linear",
                name: "${settings.msgBackgroundMask.mod.value[i].name}",
                rotate: ${settings.msgBackgroundMask.mod.value[i].rotate},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].height.px}
                }
            }`;
        } else if (settings.msgBackgroundMask.mod.value[i].type === "radial") {
            var colorList = "";
            
            for (var j = 0; j < settings.msgBackgroundMask.mod.value[i].colors.length; j++) {
                colorList += `{
                    position: ${settings.msgBackgroundMask.mod.value[i].colors[j].position},
                    opacity: ${settings.msgBackgroundMask.mod.value[i].colors[j].opacity},
                    count: ${settings.msgBackgroundMask.mod.value[i].colors[j].count}
                }`;

                if (j < settings.msgBackgroundMask.mod.value[i].colors.length - 1) {
                    colorList += `, `;
                }
            }

            msgBackgroundMaskResMod += `{
                type: "radial",
                name: "${settings.msgBackgroundMask.mod.value[i].name}",
                size: "${settings.msgBackgroundMask.mod.value[i].size}",
                x: ${settings.msgBackgroundMask.mod.value[i].x},
                y: ${settings.msgBackgroundMask.mod.value[i].y},
                colors: [
                    ${colorList}
                ],
                posX: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].posX.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].posX.px}
                },
                posY: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].posY.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].posY.px}
                },
                width: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].width.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].width.px},
                },
                height: {
                    percent: ${settings.msgBackgroundMask.mod.value[i].height.percent},
                    px: ${settings.msgBackgroundMask.mod.value[i].height.px}
                }
            }`;
        }

        if (i < settings.msgBackgroundMask.mod.value.length - 1) {
            msgBackgroundMaskResMod += `, `;
        }
    }

    var msgShadowResUser = "";

    for (var i = 0; i < settings.msgShadow.user.value.length; i++) {
        msgShadowResUser += `{
        x: ${settings.msgShadow.user.value[i].x},
        y: ${settings.msgShadow.user.value[i].y},
        blur: ${settings.msgShadow.user.value[i].blur},
        expand: ${settings.msgShadow.user.value[i].expand},
        inset: ${settings.msgShadow.user.value[i].inset},
        color: {
            type: "${settings.msgShadow.user.value[i].color.type}",
            color: "${settings.msgShadow.user.value[i].color.color}",
            opacity: ${settings.msgShadow.user.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgShadow.user.value.length - 1) {
            msgShadowResUser += `, `;
        }
    }

    var msgShadowResSub = "";

    for (var i = 0; i < settings.msgShadow.sub.value.length; i++) {
        msgShadowResSub += `{
        x: ${settings.msgShadow.sub.value[i].x},
        y: ${settings.msgShadow.sub.value[i].y},
        blur: ${settings.msgShadow.sub.value[i].blur},
        expand: ${settings.msgShadow.sub.value[i].expand},
        inset: ${settings.msgShadow.sub.value[i].inset},
        color: {
            type: "${settings.msgShadow.sub.value[i].color.type}",
            color: "${settings.msgShadow.sub.value[i].color.color}",
            opacity: ${settings.msgShadow.sub.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgShadow.sub.value.length - 1) {
            msgShadowResSub += `, `;
        }
    }

    var msgShadowResVip = "";

    for (var i = 0; i < settings.msgShadow.vip.value.length; i++) {
        msgShadowResVip += `{
        x: ${settings.msgShadow.vip.value[i].x},
        y: ${settings.msgShadow.vip.value[i].y},
        blur: ${settings.msgShadow.vip.value[i].blur},
        expand: ${settings.msgShadow.vip.value[i].expand},
        inset: ${settings.msgShadow.vip.value[i].inset},
        color: {
            type: "${settings.msgShadow.vip.value[i].color.type}",
            color: "${settings.msgShadow.vip.value[i].color.color}",
            opacity: ${settings.msgShadow.vip.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgShadow.vip.value.length - 1) {
            msgShadowResVip += `, `;
        }
    }

    var msgShadowResMod = "";

    for (var i = 0; i < settings.msgShadow.mod.value.length; i++) {
        msgShadowResMod += `{
        x: ${settings.msgShadow.mod.value[i].x},
        y: ${settings.msgShadow.mod.value[i].y},
        blur: ${settings.msgShadow.mod.value[i].blur},
        expand: ${settings.msgShadow.mod.value[i].expand},
        inset: ${settings.msgShadow.mod.value[i].inset},
        color: {
            type: "${settings.msgShadow.mod.value[i].color.type}",
            color: "${settings.msgShadow.mod.value[i].color.color}",
            opacity: ${settings.msgShadow.mod.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgShadow.mod.value.length - 1) {
            msgShadowResMod += `, `;
        }
    }

    var msgFontShadowResUser = "";

    for (var i = 0; i < settings.msgFontShadow.user.value.length; i++) {
        msgFontShadowResUser += `{
        x: ${settings.msgFontShadow.user.value[i].x},
        y: ${settings.msgFontShadow.user.value[i].y},
        blur: ${settings.msgFontShadow.user.value[i].blur},
        color: {
            type: "${settings.msgFontShadow.user.value[i].color.type}",
            color: "${settings.msgFontShadow.user.value[i].color.color}",
            opacity: ${settings.msgFontShadow.user.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgFontShadow.user.value.length - 1) {
            msgFontShadowResUser += `, `;
        }
    }

    var msgFontShadowResSub = "";

    for (var i = 0; i < settings.msgFontShadow.sub.value.length; i++) {
        msgFontShadowResSub += `{
        x: ${settings.msgFontShadow.sub.value[i].x},
        y: ${settings.msgFontShadow.sub.value[i].y},
        blur: ${settings.msgFontShadow.sub.value[i].blur},
        color: {
            type: "${settings.msgFontShadow.sub.value[i].color.type}",
            color: "${settings.msgFontShadow.sub.value[i].color.color}",
            opacity: ${settings.msgFontShadow.sub.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgFontShadow.sub.value.length - 1) {
            msgFontShadowResSub += `, `;
        }
    }

    var msgFontShadowResVip = "";

    for (var i = 0; i < settings.msgFontShadow.vip.value.length; i++) {
        msgFontShadowResVip += `{
        x: ${settings.msgFontShadow.vip.value[i].x},
        y: ${settings.msgFontShadow.vip.value[i].y},
        blur: ${settings.msgFontShadow.vip.value[i].blur},
        color: {
            type: "${settings.msgFontShadow.vip.value[i].color.type}",
            color: "${settings.msgFontShadow.vip.value[i].color.color}",
            opacity: ${settings.msgFontShadow.vip.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgFontShadow.vip.value.length - 1) {
            msgFontShadowResVip += `, `;
        }
    }

    var msgFontShadowResMod = "";

    for (var i = 0; i < settings.msgFontShadow.mod.value.length; i++) {
        msgFontShadowResMod += `{
        x: ${settings.msgFontShadow.mod.value[i].x},
        y: ${settings.msgFontShadow.mod.value[i].y},
        blur: ${settings.msgFontShadow.mod.value[i].blur},
        color: {
            type: "${settings.msgFontShadow.mod.value[i].color.type}",
            color: "${settings.msgFontShadow.mod.value[i].color.color}",
            opacity: ${settings.msgFontShadow.mod.value[i].color.opacity}
        }
        }`;

        if (i < settings.msgFontShadow.mod.value.length - 1) {
            msgFontShadowResMod += `, `;
        }
    }

    var finalDurationUser = settings.anmTiming.user.value.duration;

    if (settings.anmTiming.user.value.duration === "infinite") {
        finalDurationUser = `"infinite"`;
    }

    var finalDurationSub = settings.anmTiming.sub.value.duration;

    if (settings.anmTiming.sub.value.duration === "infinite") {
        finalDurationSub = `"infinite"`;
    }

    var finalDurationVip = settings.anmTiming.vip.value.duration;

    if (settings.anmTiming.vip.value.duration === "infinite") {
        finalDurationVip = `"infinite"`;
    }

    var finalDurationMod = settings.anmTiming.mod.value.duration;

    if (settings.anmTiming.mod.value.duration === "infinite") {
        finalDurationMod = `"infinite"`;
    }

    exportText = `
    var colorPreset = [${presetSettingList}],
        settings = {
            genStreamerList: [${genStreamerListRes}],
            genChatDirection: "${settings.genChatDirection}",
            genFilterUser: [${genFilterUserRes}], // Kleinbuchstaben!
            genFilterMsg: [${genFilterMsgRes}],
            genMaxMessages: ${settings.genMaxMessages},
            cbxLayout: {
                user: {
                    value: {
                        type: "${settings.cbxLayout.user.value.type}",
                        layoutRowSizing: "${settings.cbxLayout.user.value.layoutRowSizing}"
                    },
                    active: ${settings.cbxLayout.user.active}
                },
    
                sub: {
                    value: {
                        type: "${settings.cbxLayout.sub.value.type}",
                        layoutRowSizing: "${settings.cbxLayout.sub.value.layoutRowSizing}"
                    },
                    active: ${settings.cbxLayout.sub.active}
                },
    
                vip: {
                    value: {
                        type: "${settings.cbxLayout.vip.value.type}",
                        layoutRowSizing: "${settings.cbxLayout.vip.value.layoutRowSizing}"
                    },
                    active: ${settings.cbxLayout.vip.active}
                },
    
                mod: {
                    value: {
                        type: "${settings.cbxLayout.mod.value.type}",
                        layoutRowSizing: "${settings.cbxLayout.mod.value.layoutRowSizing}"
                    },
                    active: ${settings.cbxLayout.mod.active}
                },
            },
            cbxBackground: {
                user: {
                    value: [${cbxBackgroundResUser}],
                    active: ${settings.cbxBackground.user.active}
                },
                sub: {
                    value: [${cbxBackgroundResSub}],
                    active: ${settings.cbxBackground.sub.active}
                },
                vip: {
                    value: [${cbxBackgroundResVip}],
                    active: ${settings.cbxBackground.vip.active}
                },
                mod: {
                    value: [${cbxBackgroundResMod}],
                    active: ${settings.cbxBackground.mod.active}
                }
            },
            cbxBackgroundMask: {
                user: {
                    value: [${cbxBackgroundMaskResUser}],
                    active: ${settings.cbxBackgroundMask.user.active}
                },
                sub: {
                    value: [${cbxBackgroundMaskResSub}],
                    active: ${settings.cbxBackgroundMask.sub.active}
                },
                vip: {
                    value: [${cbxBackgroundMaskResVip}],
                    active: ${settings.cbxBackgroundMask.vip.active}
                },
                mod: {
                    value: [${cbxBackgroundMaskResMod}],
                    active: ${settings.cbxBackgroundMask.mod.active}
                }
            },
            cbxBorder: {
                user: {
                    value: {
                        top: {
                            type: "${settings.cbxBorder.user.value.top.type}",
                            width: ${settings.cbxBorder.user.value.top.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.user.value.top.color.type}",
                                color: "${settings.cbxBorder.user.value.top.color.color}",
                                opacity: ${settings.cbxBorder.user.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.cbxBorder.user.value.bottom.type}",
                            width: ${settings.cbxBorder.user.value.bottom.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.user.value.bottom.color.type}",
                                color: "${settings.cbxBorder.user.value.bottom.color.color}",
                                opacity: ${settings.cbxBorder.user.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.cbxBorder.user.value.left.type}",
                            width: ${settings.cbxBorder.user.value.left.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.user.value.left.color.type}",
                                color: "${settings.cbxBorder.user.value.left.color.color}",
                                opacity: ${settings.cbxBorder.user.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.cbxBorder.user.value.right.type}",
                            width: ${settings.cbxBorder.user.value.right.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.user.value.right.color.type}",
                                color: "${settings.cbxBorder.user.value.right.color.color}",
                                opacity: ${settings.cbxBorder.user.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.cbxBorder.user.value.tl}, // In px
                        tr: ${settings.cbxBorder.user.value.tr}, // In px
                        bl: ${settings.cbxBorder.user.value.bl}, // In px
                        br: ${settings.cbxBorder.user.value.br}  // In px
                    },
                    active: ${settings.cbxBorder.user.active}
                },
                sub: {
                    value: {
                        top: {
                            type: "${settings.cbxBorder.sub.value.top.type}",
                            width: ${settings.cbxBorder.sub.value.top.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.sub.value.top.color.type}",
                                color: "${settings.cbxBorder.sub.value.top.color.color}",
                                opacity: ${settings.cbxBorder.sub.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.cbxBorder.sub.value.bottom.type}",
                            width: ${settings.cbxBorder.sub.value.bottom.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.sub.value.bottom.color.type}",
                                color: "${settings.cbxBorder.sub.value.bottom.color.color}",
                                opacity: ${settings.cbxBorder.sub.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.cbxBorder.sub.value.left.type}",
                            width: ${settings.cbxBorder.sub.value.left.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.sub.value.left.color.type}",
                                color: "${settings.cbxBorder.sub.value.left.color.color}",
                                opacity: ${settings.cbxBorder.sub.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.cbxBorder.sub.value.right.type}",
                            width: ${settings.cbxBorder.sub.value.right.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.sub.value.right.color.type}",
                                color: "${settings.cbxBorder.sub.value.right.color.color}",
                                opacity: ${settings.cbxBorder.sub.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.cbxBorder.sub.value.tl}, // In px
                        tr: ${settings.cbxBorder.sub.value.tr}, // In px
                        bl: ${settings.cbxBorder.sub.value.bl}, // In px
                        br: ${settings.cbxBorder.sub.value.br}  // In px
                    },
                    active: ${settings.cbxBorder.sub.active}
                },
                vip: {
                    value: {
                        top: {
                            type: "${settings.cbxBorder.vip.value.top.type}",
                            width: ${settings.cbxBorder.vip.value.top.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.vip.value.top.color.type}",
                                color: "${settings.cbxBorder.vip.value.top.color.color}",
                                opacity: ${settings.cbxBorder.vip.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.cbxBorder.vip.value.bottom.type}",
                            width: ${settings.cbxBorder.vip.value.bottom.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.vip.value.bottom.color.type}",
                                color: "${settings.cbxBorder.vip.value.bottom.color.color}",
                                opacity: ${settings.cbxBorder.vip.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.cbxBorder.vip.value.left.type}",
                            width: ${settings.cbxBorder.vip.value.left.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.vip.value.left.color.type}",
                                color: "${settings.cbxBorder.vip.value.left.color.color}",
                                opacity: ${settings.cbxBorder.vip.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.cbxBorder.vip.value.right.type}",
                            width: ${settings.cbxBorder.vip.value.right.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.vip.value.right.color.type}",
                                color: "${settings.cbxBorder.vip.value.right.color.color}",
                                opacity: ${settings.cbxBorder.vip.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.cbxBorder.vip.value.tl}, // In px
                        tr: ${settings.cbxBorder.vip.value.tr}, // In px
                        bl: ${settings.cbxBorder.vip.value.bl}, // In px
                        br: ${settings.cbxBorder.vip.value.br}  // In px
                    },
                    active: ${settings.cbxBorder.vip.active}
                },
                mod: {
                    value: {
                        top: {
                            type: "${settings.cbxBorder.mod.value.top.type}",
                            width: ${settings.cbxBorder.mod.value.top.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.mod.value.top.color.type}",
                                color: "${settings.cbxBorder.mod.value.top.color.color}",
                                opacity: ${settings.cbxBorder.mod.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.cbxBorder.mod.value.bottom.type}",
                            width: ${settings.cbxBorder.mod.value.bottom.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.mod.value.bottom.color.type}",
                                color: "${settings.cbxBorder.mod.value.bottom.color.color}",
                                opacity: ${settings.cbxBorder.mod.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.cbxBorder.mod.value.left.type}",
                            width: ${settings.cbxBorder.mod.value.left.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.mod.value.left.color.type}",
                                color: "${settings.cbxBorder.mod.value.left.color.color}",
                                opacity: ${settings.cbxBorder.mod.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.cbxBorder.mod.value.right.type}",
                            width: ${settings.cbxBorder.mod.value.right.width}, // In px
                            color: {
                                type: "${settings.cbxBorder.mod.value.right.color.type}",
                                color: "${settings.cbxBorder.mod.value.right.color.color}",
                                opacity: ${settings.cbxBorder.mod.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.cbxBorder.mod.value.tl}, // In px
                        tr: ${settings.cbxBorder.mod.value.tr}, // In px
                        bl: ${settings.cbxBorder.mod.value.bl}, // In px
                        br: ${settings.cbxBorder.mod.value.br}  // In px
                    },
                    active: ${settings.cbxBorder.mod.active}
                }
            },
            cbxShadow: {
                user: {
                    value: [${cbxShadowResUser}],
                    active: ${settings.cbxShadow.user.active}
                },
                sub: {
                    value: [${cbxShadowResSub}],
                    active: ${settings.cbxShadow.sub.active}
                },
                vip: {
                    value: [${cbxShadowResVip}],
                    active: ${settings.cbxShadow.vip.active}
                },
                mod: {
                    value: [${cbxShadowResMod}],
                    active: ${settings.cbxShadow.mod.active}
                }
            },
            cbxPosition: {
                user: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.cbxPosition.user.value.spacing.outer.top}, // In px
                                bottom: ${settings.cbxPosition.user.value.spacing.outer.bottom}, // In px
                                left: ${settings.cbxPosition.user.value.spacing.outer.left}, // In px
                                right: ${settings.cbxPosition.user.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.cbxPosition.user.value.spacing.inner.top}, // In px
                                bottom: ${settings.cbxPosition.user.value.spacing.inner.bottom}, // In px
                                left: ${settings.cbxPosition.user.value.spacing.inner.left}, // In px
                                right: ${settings.cbxPosition.user.value.spacing.inner.right}, // In px
                            }
                        },
                        sizing: "${settings.cbxPosition.user.value.sizing}"
                    },
                    active: ${settings.cbxPosition.user.active}
                },
                sub: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.cbxPosition.sub.value.spacing.outer.top}, // In px
                                bottom: ${settings.cbxPosition.sub.value.spacing.outer.bottom}, // In px
                                left: ${settings.cbxPosition.sub.value.spacing.outer.left}, // In px
                                right: ${settings.cbxPosition.sub.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.cbxPosition.sub.value.spacing.inner.top}, // In px
                                bottom: ${settings.cbxPosition.sub.value.spacing.inner.bottom}, // In px
                                left: ${settings.cbxPosition.sub.value.spacing.inner.left}, // In px
                                right: ${settings.cbxPosition.sub.value.spacing.inner.right}, // In px
                            }
                        },
                        sizing: "${settings.cbxPosition.sub.value.sizing}"
                    },
                    active: ${settings.cbxPosition.sub.active}
                },
                vip: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.cbxPosition.vip.value.spacing.outer.top}, // In px
                                bottom: ${settings.cbxPosition.vip.value.spacing.outer.bottom}, // In px
                                left: ${settings.cbxPosition.vip.value.spacing.outer.left}, // In px
                                right: ${settings.cbxPosition.vip.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.cbxPosition.vip.value.spacing.inner.top}, // In px
                                bottom: ${settings.cbxPosition.vip.value.spacing.inner.bottom}, // In px
                                left: ${settings.cbxPosition.vip.value.spacing.inner.left}, // In px
                                right: ${settings.cbxPosition.vip.value.spacing.inner.right}, // In px
                            }
                        },
                        sizing: "${settings.cbxPosition.vip.value.sizing}"
                    },
                    active: ${settings.cbxPosition.vip.active}
                },
                mod: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.cbxPosition.mod.value.spacing.outer.top}, // In px
                                bottom: ${settings.cbxPosition.mod.value.spacing.outer.bottom}, // In px
                                left: ${settings.cbxPosition.mod.value.spacing.outer.left}, // In px
                                right: ${settings.cbxPosition.mod.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.cbxPosition.mod.value.spacing.inner.top}, // In px
                                bottom: ${settings.cbxPosition.mod.value.spacing.inner.bottom}, // In px
                                left: ${settings.cbxPosition.mod.value.spacing.inner.left}, // In px
                                right: ${settings.cbxPosition.mod.value.spacing.inner.right}, // In px
                            }
                        },
                        sizing: "${settings.cbxPosition.mod.value.sizing}"
                    },
                    active: ${settings.cbxPosition.mod.active}
                }
            },
            usnBackground: {
                user: {
                    value: [${usnBackgroundResUser}],
                    active: ${settings.usnBackground.user.active}
                },
                sub: {
                    value: [${usnBackgroundResSub}],
                    active: ${settings.usnBackground.sub.active}
                },
                vip: {
                    value: [${usnBackgroundResVip}],
                    active: ${settings.usnBackground.vip.active}
                },
                mod: {
                    value: [${usnBackgroundResMod}],
                    active: ${settings.usnBackground.mod.active}
                }
            },
            usnBackgroundMask: {
                user: {
                    value: [${usnBackgroundMaskResUser}],
                    active: ${settings.usnBackgroundMask.user.active}
                },
                sub: {
                    value: [${usnBackgroundMaskResSub}],
                    active: ${settings.usnBackgroundMask.sub.active}
                },
                vip: {
                    value: [${usnBackgroundMaskResVip}],
                    active: ${settings.usnBackgroundMask.vip.active}
                },
                mod: {
                    value: [${usnBackgroundMaskResMod}],
                    active: ${settings.usnBackgroundMask.mod.active}
                }
            },
            usnBorder: {
                user: {
                    value: {
                        top: {
                            type: "${settings.usnBorder.user.value.top.type}",
                            width: ${settings.usnBorder.user.value.top.width}, // In px
                            color: {
                                type: "${settings.usnBorder.user.value.top.color.type}",
                                color: "${settings.usnBorder.user.value.top.color.color}",
                                opacity: ${settings.usnBorder.user.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.usnBorder.user.value.bottom.type}",
                            width: ${settings.usnBorder.user.value.bottom.width}, // In px
                            color: {
                                type: "${settings.usnBorder.user.value.bottom.color.type}",
                                color: "${settings.usnBorder.user.value.bottom.color.color}",
                                opacity: ${settings.usnBorder.user.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.usnBorder.user.value.left.type}",
                            width: ${settings.usnBorder.user.value.left.width}, // In px
                            color: {
                                type: "${settings.usnBorder.user.value.left.color.type}",
                                color: "${settings.usnBorder.user.value.left.color.color}",
                                opacity: ${settings.usnBorder.user.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.usnBorder.user.value.right.type}",
                            width: ${settings.usnBorder.user.value.right.width}, // In px
                            color: {
                                type: "${settings.usnBorder.user.value.right.color.type}",
                                color: "${settings.usnBorder.user.value.right.color.color}",
                                opacity: ${settings.usnBorder.user.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.usnBorder.user.value.tl}, // In px
                        tr: ${settings.usnBorder.user.value.tr}, // In px
                        bl: ${settings.usnBorder.user.value.bl}, // In px
                        br: ${settings.usnBorder.user.value.br}  // In px
                    },
                    active: ${settings.usnBorder.user.active}
                },
                sub: {
                    value: {
                        top: {
                            type: "${settings.usnBorder.sub.value.top.type}",
                            width: ${settings.usnBorder.sub.value.top.width}, // In px
                            color: {
                                type: "${settings.usnBorder.sub.value.top.color.type}",
                                color: "${settings.usnBorder.sub.value.top.color.color}",
                                opacity: ${settings.usnBorder.sub.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.usnBorder.sub.value.bottom.type}",
                            width: ${settings.usnBorder.sub.value.bottom.width}, // In px
                            color: {
                                type: "${settings.usnBorder.sub.value.bottom.color.type}",
                                color: "${settings.usnBorder.sub.value.bottom.color.color}",
                                opacity: ${settings.usnBorder.sub.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.usnBorder.sub.value.left.type}",
                            width: ${settings.usnBorder.sub.value.left.width}, // In px
                            color: {
                                type: "${settings.usnBorder.sub.value.left.color.type}",
                                color: "${settings.usnBorder.sub.value.left.color.color}",
                                opacity: ${settings.usnBorder.sub.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.usnBorder.sub.value.right.type}",
                            width: ${settings.usnBorder.sub.value.right.width}, // In px
                            color: {
                                type: "${settings.usnBorder.sub.value.right.color.type}",
                                color: "${settings.usnBorder.sub.value.right.color.color}",
                                opacity: ${settings.usnBorder.sub.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.usnBorder.sub.value.tl}, // In px
                        tr: ${settings.usnBorder.sub.value.tr}, // In px
                        bl: ${settings.usnBorder.sub.value.bl}, // In px
                        br: ${settings.usnBorder.sub.value.br}  // In px
                    },
                    active: ${settings.usnBorder.sub.active}
                },
                vip: {
                    value: {
                        top: {
                            type: "${settings.usnBorder.vip.value.top.type}",
                            width: ${settings.usnBorder.vip.value.top.width}, // In px
                            color: {
                                type: "${settings.usnBorder.vip.value.top.color.type}",
                                color: "${settings.usnBorder.vip.value.top.color.color}",
                                opacity: ${settings.usnBorder.vip.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.usnBorder.vip.value.bottom.type}",
                            width: ${settings.usnBorder.vip.value.bottom.width}, // In px
                            color: {
                                type: "${settings.usnBorder.vip.value.bottom.color.type}",
                                color: "${settings.usnBorder.vip.value.bottom.color.color}",
                                opacity: ${settings.usnBorder.vip.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.usnBorder.vip.value.left.type}",
                            width: ${settings.usnBorder.vip.value.left.width}, // In px
                            color: {
                                type: "${settings.usnBorder.vip.value.left.color.type}",
                                color: "${settings.usnBorder.vip.value.left.color.color}",
                                opacity: ${settings.usnBorder.vip.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.usnBorder.vip.value.right.type}",
                            width: ${settings.usnBorder.vip.value.right.width}, // In px
                            color: {
                                type: "${settings.usnBorder.vip.value.right.color.type}",
                                color: "${settings.usnBorder.vip.value.right.color.color}",
                                opacity: ${settings.usnBorder.vip.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.usnBorder.vip.value.tl}, // In px
                        tr: ${settings.usnBorder.vip.value.tr}, // In px
                        bl: ${settings.usnBorder.vip.value.bl}, // In px
                        br: ${settings.usnBorder.vip.value.br}  // In px
                    },
                    active: ${settings.usnBorder.vip.active}
                },
                mod: {
                    value: {
                        top: {
                            type: "${settings.usnBorder.mod.value.top.type}",
                            width: ${settings.usnBorder.mod.value.top.width}, // In px
                            color: {
                                type: "${settings.usnBorder.mod.value.top.color.type}",
                                color: "${settings.usnBorder.mod.value.top.color.color}",
                                opacity: ${settings.usnBorder.mod.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.usnBorder.mod.value.bottom.type}",
                            width: ${settings.usnBorder.mod.value.bottom.width}, // In px
                            color: {
                                type: "${settings.usnBorder.mod.value.bottom.color.type}",
                                color: "${settings.usnBorder.mod.value.bottom.color.color}",
                                opacity: ${settings.usnBorder.mod.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.usnBorder.mod.value.left.type}",
                            width: ${settings.usnBorder.mod.value.left.width}, // In px
                            color: {
                                type: "${settings.usnBorder.mod.value.left.color.type}",
                                color: "${settings.usnBorder.mod.value.left.color.color}",
                                opacity: ${settings.usnBorder.mod.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.usnBorder.mod.value.right.type}",
                            width: ${settings.usnBorder.mod.value.right.width}, // In px
                            color: {
                                type: "${settings.usnBorder.mod.value.right.color.type}",
                                color: "${settings.usnBorder.mod.value.right.color.color}",
                                opacity: ${settings.usnBorder.mod.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.usnBorder.mod.value.tl}, // In px
                        tr: ${settings.usnBorder.mod.value.tr}, // In px
                        bl: ${settings.usnBorder.mod.value.bl}, // In px
                        br: ${settings.usnBorder.mod.value.br}  // In px
                    },
                    active: ${settings.usnBorder.mod.active}
                }
            },
            usnShadow: {
                user: {
                    value: [${usnShadowResUser}],
                    active: ${settings.usnShadow.user.active}
                },
                sub: {
                    value: [${usnShadowResSub}],
                    active: ${settings.usnShadow.sub.active}
                },
                vip: {
                    value: [${usnShadowResVip}],
                    active: ${settings.usnShadow.vip.active}
                },
                mod: {
                    value: [${usnShadowResMod}],
                    active: ${settings.usnShadow.mod.active}
                }
            },
            usnPosition: {
                user: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.usnPosition.user.value.spacing.outer.top}, // In px
                                bottom: ${settings.usnPosition.user.value.spacing.outer.bottom}, // In px
                                left: ${settings.usnPosition.user.value.spacing.outer.left}, // In px
                                right: ${settings.usnPosition.user.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.usnPosition.user.value.spacing.inner.top}, // In px
                                bottom: ${settings.usnPosition.user.value.spacing.inner.bottom}, // In px
                                left: ${settings.usnPosition.user.value.spacing.inner.left}, // In px
                                right: ${settings.usnPosition.user.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.usnPosition.user.value.sizingH}",
                        sizingV: "${settings.usnPosition.user.value.sizingV}"
                    },
                    active: ${settings.usnPosition.user.active}
                },
                sub: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.usnPosition.sub.value.spacing.outer.top}, // In px
                                bottom: ${settings.usnPosition.sub.value.spacing.outer.bottom}, // In px
                                left: ${settings.usnPosition.sub.value.spacing.outer.left}, // In px
                                right: ${settings.usnPosition.sub.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.usnPosition.sub.value.spacing.inner.top}, // In px
                                bottom: ${settings.usnPosition.sub.value.spacing.inner.bottom}, // In px
                                left: ${settings.usnPosition.sub.value.spacing.inner.left}, // In px
                                right: ${settings.usnPosition.sub.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.usnPosition.sub.value.sizingH}",
                        sizingV: "${settings.usnPosition.sub.value.sizingV}"
                    },
                    active: ${settings.usnPosition.sub.active}
                },
                vip: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.usnPosition.vip.value.spacing.outer.top}, // In px
                                bottom: ${settings.usnPosition.vip.value.spacing.outer.bottom}, // In px
                                left: ${settings.usnPosition.vip.value.spacing.outer.left}, // In px
                                right: ${settings.usnPosition.vip.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.usnPosition.vip.value.spacing.inner.top}, // In px
                                bottom: ${settings.usnPosition.vip.value.spacing.inner.bottom}, // In px
                                left: ${settings.usnPosition.vip.value.spacing.inner.left}, // In px
                                right: ${settings.usnPosition.vip.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.usnPosition.vip.value.sizingH}",
                        sizingV: "${settings.usnPosition.vip.value.sizingV}"
                    },
                    active: ${settings.usnPosition.vip.active}
                },
                mod: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.usnPosition.mod.value.spacing.outer.top}, // In px
                                bottom: ${settings.usnPosition.mod.value.spacing.outer.bottom}, // In px
                                left: ${settings.usnPosition.mod.value.spacing.outer.left}, // In px
                                right: ${settings.usnPosition.mod.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.usnPosition.mod.value.spacing.inner.top}, // In px
                                bottom: ${settings.usnPosition.mod.value.spacing.inner.bottom}, // In px
                                left: ${settings.usnPosition.mod.value.spacing.inner.left}, // In px
                                right: ${settings.usnPosition.mod.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.usnPosition.mod.value.sizingH}",
                        sizingV: "${settings.usnPosition.mod.value.sizingV}"
                    },
                    active: ${settings.usnPosition.mod.active}
                }
            },
            usnFont: {
                user: {
                    value: {
                        family: "${settings.usnFont.user.value.family}",
                        size: ${settings.usnFont.user.value.size},
                        weight: ${settings.usnFont.user.value.weight},
                        height: {
                            auto: ${settings.usnFont.user.value.height.auto},
                            height: ${settings.usnFont.user.value.height.height} // In px
                        },
                        spacing: ${settings.usnFont.user.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.usnFont.user.value.lines.upperLine},
                            crossLine: ${settings.usnFont.user.value.lines.crossLine},
                            underLine: ${settings.usnFont.user.value.lines.underLine}
                        },
                        hAlign: "${settings.usnFont.user.value.hAlign}",
                        italic: ${settings.usnFont.user.value.italic},
                        color: {
                            type: "${settings.usnFont.user.value.color.type}",
                            color: "${settings.usnFont.user.value.color.color}",
                            opacity: ${settings.usnFont.user.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.usnFont.user.active}
                },
                sub: {
                    value: {
                        family: "${settings.usnFont.sub.value.family}",
                        size: ${settings.usnFont.sub.value.size},
                        weight: ${settings.usnFont.sub.value.weight},
                        height: {
                            auto: ${settings.usnFont.sub.value.height.auto},
                            height: ${settings.usnFont.sub.value.height.height} // In px
                        },
                        spacing: ${settings.usnFont.sub.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.usnFont.sub.value.lines.upperLine},
                            crossLine: ${settings.usnFont.sub.value.lines.crossLine},
                            underLine: ${settings.usnFont.sub.value.lines.underLine}
                        },
                        hAlign: "${settings.usnFont.sub.value.hAlign}",
                        italic: ${settings.usnFont.sub.value.italic},
                        color: {
                            type: "${settings.usnFont.sub.value.color.type}",
                            color: "${settings.usnFont.sub.value.color.color}",
                            opacity: ${settings.usnFont.sub.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.usnFont.sub.active}
                },
                vip: {
                    value: {
                        family: "${settings.usnFont.vip.value.family}",
                        size: ${settings.usnFont.vip.value.size},
                        weight: ${settings.usnFont.vip.value.weight},
                        height: {
                            auto: ${settings.usnFont.vip.value.height.auto},
                            height: ${settings.usnFont.vip.value.height.height} // In px
                        },
                        spacing: ${settings.usnFont.vip.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.usnFont.vip.value.lines.upperLine},
                            crossLine: ${settings.usnFont.vip.value.lines.crossLine},
                            underLine: ${settings.usnFont.vip.value.lines.underLine}
                        },
                        hAlign: "${settings.usnFont.vip.value.hAlign}",
                        italic: ${settings.usnFont.vip.value.italic},
                        color: {
                            type: "${settings.usnFont.vip.value.color.type}",
                            color: "${settings.usnFont.vip.value.color.color}",
                            opacity: ${settings.usnFont.vip.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.usnFont.vip.active}
                },
                mod: {
                    value: {
                        family: "${settings.usnFont.mod.value.family}",
                        size: ${settings.usnFont.mod.value.size},
                        weight: ${settings.usnFont.mod.value.weight},
                        height: {
                            auto: ${settings.usnFont.mod.value.height.auto},
                            height: ${settings.usnFont.mod.value.height.height} // In px
                        },
                        spacing: ${settings.usnFont.mod.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.usnFont.mod.value.lines.upperLine},
                            crossLine: ${settings.usnFont.mod.value.lines.crossLine},
                            underLine: ${settings.usnFont.mod.value.lines.underLine}
                        },
                        hAlign: "${settings.usnFont.mod.value.hAlign}",
                        italic: ${settings.usnFont.mod.value.italic},
                        color: {
                            type: "${settings.usnFont.mod.value.color.type}",
                            color: "${settings.usnFont.mod.value.color.color}",
                            opacity: ${settings.usnFont.mod.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.usnFont.mod.active}
                }
            },
            usnFontShadow: {
                user: {
                    value: [${usnFontShadowResUser}],
                    active: ${settings.usnFontShadow.user.active}
                },
                sub: {
                    value: [${usnFontShadowResSub}],
                    active: ${settings.usnFontShadow.sub.active}
                },
                vip: {
                    value: [${usnFontShadowResVip}],
                    active: ${settings.usnFontShadow.vip.active}
                },
                mod: {
                    value: [${usnFontShadowResMod}],
                    active: ${settings.usnFontShadow.mod.active}
                }
            },
            usnContent: {
                user: {
                    value: "${settings.usnContent.user.value}",
                    active: ${settings.usnContent.user.active}
                },
                sub: {
                    value: "${settings.usnContent.sub.value}",
                    active: ${settings.usnContent.sub.active}
                },
                vip: {
                    value: "${settings.usnContent.vip.value}",
                    active: ${settings.usnContent.vip.active}
                },
                mod: {
                    value: "${settings.usnContent.mod.value}",
                    active: ${settings.usnContent.mod.active}
                }
            },
            msgBackground: {
                user: {
                    value: [${msgBackgroundResUser}],
                    active: ${settings.msgBackground.user.active}
                },
                sub: {
                    value: [${msgBackgroundResSub}],
                    active: ${settings.msgBackground.sub.active}
                },
                vip: {
                    value: [${msgBackgroundResVip}],
                    active: ${settings.msgBackground.vip.active}
                },
                mod: {
                    value: [${msgBackgroundResMod}],
                    active: ${settings.msgBackground.mod.active}
                }
            },
            msgBackgroundMask: {
                user: {
                    value: [${msgBackgroundMaskResUser}],
                    active: ${settings.msgBackgroundMask.user.active}
                },
                sub: {
                    value: [${msgBackgroundMaskResSub}],
                    active: ${settings.msgBackgroundMask.sub.active}
                },
                vip: {
                    value: [${msgBackgroundMaskResVip}],
                    active: ${settings.msgBackgroundMask.vip.active}
                },
                mod: {
                    value: [${msgBackgroundMaskResMod}],
                    active: ${settings.msgBackgroundMask.mod.active}
                }
            },
            msgBorder: {
                user: {
                    value: {
                        top: {
                            type: "${settings.msgBorder.user.value.top.type}",
                            width: ${settings.msgBorder.user.value.top.width}, // In px
                            color: {
                                type: "${settings.msgBorder.user.value.top.color.type}",
                                color: "${settings.msgBorder.user.value.top.color.color}",
                                opacity: ${settings.msgBorder.user.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.msgBorder.user.value.bottom.type}",
                            width: ${settings.msgBorder.user.value.bottom.width}, // In px
                            color: {
                                type: "${settings.msgBorder.user.value.bottom.color.type}",
                                color: "${settings.msgBorder.user.value.bottom.color.color}",
                                opacity: ${settings.msgBorder.user.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.msgBorder.user.value.left.type}",
                            width: ${settings.msgBorder.user.value.left.width}, // In px
                            color: {
                                type: "${settings.msgBorder.user.value.left.color.type}",
                                color: "${settings.msgBorder.user.value.left.color.color}",
                                opacity: ${settings.msgBorder.user.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.msgBorder.user.value.right.type}",
                            width: ${settings.msgBorder.user.value.right.width}, // In px
                            color: {
                                type: "${settings.msgBorder.user.value.right.color.type}",
                                color: "${settings.msgBorder.user.value.right.color.color}",
                                opacity: ${settings.msgBorder.user.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.msgBorder.user.value.tl}, // In px
                        tr: ${settings.msgBorder.user.value.tr}, // In px
                        bl: ${settings.msgBorder.user.value.bl}, // In px
                        br: ${settings.msgBorder.user.value.br}  // In px
                    },
                    active: ${settings.msgBorder.user.active}
                },
                sub: {
                    value: {
                        top: {
                            type: "${settings.msgBorder.sub.value.top.type}",
                            width: ${settings.msgBorder.sub.value.top.width}, // In px
                            color: {
                                type: "${settings.msgBorder.sub.value.top.color.type}",
                                color: "${settings.msgBorder.sub.value.top.color.color}",
                                opacity: ${settings.msgBorder.sub.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.msgBorder.sub.value.bottom.type}",
                            width: ${settings.msgBorder.sub.value.bottom.width}, // In px
                            color: {
                                type: "${settings.msgBorder.sub.value.bottom.color.type}",
                                color: "${settings.msgBorder.sub.value.bottom.color.color}",
                                opacity: ${settings.msgBorder.sub.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.msgBorder.sub.value.left.type}",
                            width: ${settings.msgBorder.sub.value.left.width}, // In px
                            color: {
                                type: "${settings.msgBorder.sub.value.left.color.type}",
                                color: "${settings.msgBorder.sub.value.left.color.color}",
                                opacity: ${settings.msgBorder.sub.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.msgBorder.sub.value.right.type}",
                            width: ${settings.msgBorder.sub.value.right.width}, // In px
                            color: {
                                type: "${settings.msgBorder.sub.value.right.color.type}",
                                color: "${settings.msgBorder.sub.value.right.color.color}",
                                opacity: ${settings.msgBorder.sub.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.msgBorder.sub.value.tl}, // In px
                        tr: ${settings.msgBorder.sub.value.tr}, // In px
                        bl: ${settings.msgBorder.sub.value.bl}, // In px
                        br: ${settings.msgBorder.sub.value.br}  // In px
                    },
                    active: ${settings.msgBorder.sub.active}
                },
                vip: {
                    value: {
                        top: {
                            type: "${settings.msgBorder.vip.value.top.type}",
                            width: ${settings.msgBorder.vip.value.top.width}, // In px
                            color: {
                                type: "${settings.msgBorder.vip.value.top.color.type}",
                                color: "${settings.msgBorder.vip.value.top.color.color}",
                                opacity: ${settings.msgBorder.vip.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.msgBorder.vip.value.bottom.type}",
                            width: ${settings.msgBorder.vip.value.bottom.width}, // In px
                            color: {
                                type: "${settings.msgBorder.vip.value.bottom.color.type}",
                                color: "${settings.msgBorder.vip.value.bottom.color.color}",
                                opacity: ${settings.msgBorder.vip.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.msgBorder.vip.value.left.type}",
                            width: ${settings.msgBorder.vip.value.left.width}, // In px
                            color: {
                                type: "${settings.msgBorder.vip.value.left.color.type}",
                                color: "${settings.msgBorder.vip.value.left.color.color}",
                                opacity: ${settings.msgBorder.vip.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.msgBorder.vip.value.right.type}",
                            width: ${settings.msgBorder.vip.value.right.width}, // In px
                            color: {
                                type: "${settings.msgBorder.vip.value.right.color.type}",
                                color: "${settings.msgBorder.vip.value.right.color.color}",
                                opacity: ${settings.msgBorder.vip.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.msgBorder.vip.value.tl}, // In px
                        tr: ${settings.msgBorder.vip.value.tr}, // In px
                        bl: ${settings.msgBorder.vip.value.bl}, // In px
                        br: ${settings.msgBorder.vip.value.br}  // In px
                    },
                    active: ${settings.msgBorder.vip.active}
                },
                mod: {
                    value: {
                        top: {
                            type: "${settings.msgBorder.mod.value.top.type}",
                            width: ${settings.msgBorder.mod.value.top.width}, // In px
                            color: {
                                type: "${settings.msgBorder.mod.value.top.color.type}",
                                color: "${settings.msgBorder.mod.value.top.color.color}",
                                opacity: ${settings.msgBorder.mod.value.top.color.opacity} // In Hex
                            }
                        },
                        bottom: {
                            type: "${settings.msgBorder.mod.value.bottom.type}",
                            width: ${settings.msgBorder.mod.value.bottom.width}, // In px
                            color: {
                                type: "${settings.msgBorder.mod.value.bottom.color.type}",
                                color: "${settings.msgBorder.mod.value.bottom.color.color}",
                                opacity: ${settings.msgBorder.mod.value.bottom.color.opacity} // In Hex
                            }
                        },
                        left: {
                            type: "${settings.msgBorder.mod.value.left.type}",
                            width: ${settings.msgBorder.mod.value.left.width}, // In px
                            color: {
                                type: "${settings.msgBorder.mod.value.left.color.type}",
                                color: "${settings.msgBorder.mod.value.left.color.color}",
                                opacity: ${settings.msgBorder.mod.value.left.color.opacity} // In Hex
                            }
                        },
                        right: {
                            type: "${settings.msgBorder.mod.value.right.type}",
                            width: ${settings.msgBorder.mod.value.right.width}, // In px
                            color: {
                                type: "${settings.msgBorder.mod.value.right.color.type}",
                                color: "${settings.msgBorder.mod.value.right.color.color}",
                                opacity: ${settings.msgBorder.mod.value.right.color.opacity} // In Hex
                            }
                        },
                        tl: ${settings.msgBorder.mod.value.tl}, // In px
                        tr: ${settings.msgBorder.mod.value.tr}, // In px
                        bl: ${settings.msgBorder.mod.value.bl}, // In px
                        br: ${settings.msgBorder.mod.value.br}  // In px
                    },
                    active: ${settings.msgBorder.mod.active}
                }
            },
            msgShadow: {
                user: {
                    value: [${msgShadowResUser}],
                    active: ${settings.msgShadow.user.active}
                },
                sub: {
                    value: [${msgShadowResSub}],
                    active: ${settings.msgShadow.sub.active}
                },
                vip: {
                    value: [${msgShadowResVip}],
                    active: ${settings.msgShadow.vip.active}
                },
                mod: {
                    value: [${msgShadowResMod}],
                    active: ${settings.msgShadow.mod.active}
                }
            },
            msgPosition: {
                user: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.msgPosition.user.value.spacing.outer.top}, // In px
                                bottom: ${settings.msgPosition.user.value.spacing.outer.bottom}, // In px
                                left: ${settings.msgPosition.user.value.spacing.outer.left}, // In px
                                right: ${settings.msgPosition.user.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.msgPosition.user.value.spacing.inner.top}, // In px
                                bottom: ${settings.msgPosition.user.value.spacing.inner.bottom}, // In px
                                left: ${settings.msgPosition.user.value.spacing.inner.left}, // In px
                                right: ${settings.msgPosition.user.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.msgPosition.user.value.sizingH}",
                        sizingV: "${settings.msgPosition.user.value.sizingV}"
                    },
                    active: ${settings.msgPosition.user.active}
                },
                sub: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.msgPosition.sub.value.spacing.outer.top}, // In px
                                bottom: ${settings.msgPosition.sub.value.spacing.outer.bottom}, // In px
                                left: ${settings.msgPosition.sub.value.spacing.outer.left}, // In px
                                right: ${settings.msgPosition.sub.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.msgPosition.sub.value.spacing.inner.top}, // In px
                                bottom: ${settings.msgPosition.sub.value.spacing.inner.bottom}, // In px
                                left: ${settings.msgPosition.sub.value.spacing.inner.left}, // In px
                                right: ${settings.msgPosition.sub.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.msgPosition.sub.value.sizingH}",
                        sizingV: "${settings.msgPosition.sub.value.sizingV}"
                    },
                    active: ${settings.msgPosition.sub.active}
                },
                vip: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.msgPosition.vip.value.spacing.outer.top}, // In px
                                bottom: ${settings.msgPosition.vip.value.spacing.outer.bottom}, // In px
                                left: ${settings.msgPosition.vip.value.spacing.outer.left}, // In px
                                right: ${settings.msgPosition.vip.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.msgPosition.vip.value.spacing.inner.top}, // In px
                                bottom: ${settings.msgPosition.vip.value.spacing.inner.bottom}, // In px
                                left: ${settings.msgPosition.vip.value.spacing.inner.left}, // In px
                                right: ${settings.msgPosition.vip.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.msgPosition.vip.value.sizingH}",
                        sizingV: "${settings.msgPosition.vip.value.sizingV}"
                    },
                    active: ${settings.msgPosition.vip.active}
                },
                mod: {
                    value: {
                        spacing: {
                            outer: {
                                top: ${settings.msgPosition.mod.value.spacing.outer.top}, // In px
                                bottom: ${settings.msgPosition.mod.value.spacing.outer.bottom}, // In px
                                left: ${settings.msgPosition.mod.value.spacing.outer.left}, // In px
                                right: ${settings.msgPosition.mod.value.spacing.outer.right}, // In px
                            },
                            inner: {
                                top: ${settings.msgPosition.mod.value.spacing.inner.top}, // In px
                                bottom: ${settings.msgPosition.mod.value.spacing.inner.bottom}, // In px
                                left: ${settings.msgPosition.mod.value.spacing.inner.left}, // In px
                                right: ${settings.msgPosition.mod.value.spacing.inner.right}, // In px
                            }
                        },
                        sizingH: "${settings.msgPosition.mod.value.sizingH}",
                        sizingV: "${settings.msgPosition.mod.value.sizingV}"
                    },
                    active: ${settings.msgPosition.mod.active}
                }
            },
            msgFont: {
                user: {
                    value: {
                        family: "${settings.msgFont.user.value.family}",
                        size: ${settings.msgFont.user.value.size},
                        weight: ${settings.msgFont.user.value.weight},
                        height: {
                            auto: ${settings.msgFont.user.value.height.auto},
                            height: ${settings.msgFont.user.value.height.height} // In px
                        },
                        spacing: ${settings.msgFont.user.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.msgFont.user.value.lines.upperLine},
                            crossLine: ${settings.msgFont.user.value.lines.crossLine},
                            underLine: ${settings.msgFont.user.value.lines.underLine}
                        },
                        hAlign: "${settings.msgFont.user.value.hAlign}",
                        italic: ${settings.msgFont.user.value.italic},
                        color: {
                            type: "${settings.msgFont.user.value.color.type}",
                            color: "${settings.msgFont.user.value.color.color}",
                            opacity: ${settings.msgFont.user.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.msgFont.user.active}
                },
                sub: {
                    value: {
                        family: "${settings.msgFont.sub.value.family}",
                        size: ${settings.msgFont.sub.value.size},
                        weight: ${settings.msgFont.sub.value.weight},
                        height: {
                            auto: ${settings.msgFont.sub.value.height.auto},
                            height: ${settings.msgFont.sub.value.height.height} // In px
                        },
                        spacing: ${settings.msgFont.sub.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.msgFont.sub.value.lines.upperLine},
                            crossLine: ${settings.msgFont.sub.value.lines.crossLine},
                            underLine: ${settings.msgFont.sub.value.lines.underLine}
                        },
                        hAlign: "${settings.msgFont.sub.value.hAlign}",
                        italic: ${settings.msgFont.sub.value.italic},
                        color: {
                            type: "${settings.msgFont.sub.value.color.type}",
                            color: "${settings.msgFont.sub.value.color.color}",
                            opacity: ${settings.msgFont.sub.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.msgFont.sub.active}
                },
                vip: {
                    value: {
                        family: "${settings.msgFont.vip.value.family}",
                        size: ${settings.msgFont.vip.value.size},
                        weight: ${settings.msgFont.vip.value.weight},
                        height: {
                            auto: ${settings.msgFont.vip.value.height.auto},
                            height: ${settings.msgFont.vip.value.height.height} // In px
                        },
                        spacing: ${settings.msgFont.vip.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.msgFont.vip.value.lines.upperLine},
                            crossLine: ${settings.msgFont.vip.value.lines.crossLine},
                            underLine: ${settings.msgFont.vip.value.lines.underLine}
                        },
                        hAlign: "${settings.msgFont.vip.value.hAlign}",
                        italic: ${settings.msgFont.vip.value.italic},
                        color: {
                            type: "${settings.msgFont.vip.value.color.type}",
                            color: "${settings.msgFont.vip.value.color.color}",
                            opacity: ${settings.msgFont.vip.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.msgFont.vip.active}
                },
                mod: {
                    value: {
                        family: "${settings.msgFont.mod.value.family}",
                        size: ${settings.msgFont.mod.value.size},
                        weight: ${settings.msgFont.mod.value.weight},
                        height: {
                            auto: ${settings.msgFont.mod.value.height.auto},
                            height: ${settings.msgFont.mod.value.height.height} // In px
                        },
                        spacing: ${settings.msgFont.mod.value.spacing}, // In px
                        lines: {
                            upperLine: ${settings.msgFont.mod.value.lines.upperLine},
                            crossLine: ${settings.msgFont.mod.value.lines.crossLine},
                            underLine: ${settings.msgFont.mod.value.lines.underLine}
                        },
                        hAlign: "${settings.msgFont.mod.value.hAlign}",
                        italic: ${settings.msgFont.mod.value.italic},
                        color: {
                            type: "${settings.msgFont.mod.value.color.type}",
                            color: "${settings.msgFont.mod.value.color.color}",
                            opacity: ${settings.msgFont.mod.value.color.opacity} // In Hex
                        },
                    },
                    active: ${settings.msgFont.mod.active}
                }
            },
            msgFontShadow: {
                user: {
                    value: [${msgFontShadowResUser}],
                    active: ${settings.msgFontShadow.user.active}
                },
                sub: {
                    value: [${msgFontShadowResSub}],
                    active: ${settings.msgFontShadow.sub.active}
                },
                vip: {
                    value: [${msgFontShadowResVip}],
                    active: ${settings.msgFontShadow.vip.active}
                },
                mod: {
                    value: [${msgFontShadowResMod}],
                    active: ${settings.msgFontShadow.mod.active}
                }
            },
            msgContent: {
                user: {
                    value: "${settings.msgContent.user.value}",
                    active: ${settings.msgContent.user.active}
                },
                sub: {
                    value: "${settings.msgContent.sub.value}",
                    active: ${settings.msgContent.sub.active}
                },
                vip: {
                    value: "${settings.msgContent.vip.value}",
                    active: ${settings.msgContent.vip.active}
                },
                mod: {
                    value: "${settings.msgContent.mod.value}",
                    active: ${settings.msgContent.mod.active}
                }
            },
            othEmotes: {
                user: {
                    value: {
                        auto: ${settings.othEmotes.user.value.auto},
                        height: ${settings.othEmotes.user.value.height}, // In px
                        linePos: "${settings.othEmotes.user.value.linePos}" // top/middle/bottom
                    },
                    active: ${settings.othEmotes.user.active}
                },
                sub: {
                    value: {
                        auto: ${settings.othEmotes.sub.value.auto},
                        height: ${settings.othEmotes.sub.value.height}, // In px
                        linePos: "${settings.othEmotes.sub.value.linePos}" // top/middle/bottom
                    },
                    active: ${settings.othEmotes.sub.active}
                },
                vip: {
                    value: {
                        auto: ${settings.othEmotes.vip.value.auto},
                        height: ${settings.othEmotes.vip.value.height}, // In px
                        linePos: "${settings.othEmotes.vip.value.linePos}" // top/middle/bottom
                    },
                    active: ${settings.othEmotes.vip.active}
                },
                mod: {
                    value: {
                        auto: ${settings.othEmotes.mod.value.auto},
                        height: ${settings.othEmotes.mod.value.height}, // In px
                        linePos: "${settings.othEmotes.mod.value.linePos}" // top/middle/bottom
                    },
                    active: ${settings.othEmotes.mod.active}
                }
            },
            othBadges: {
                user: {
                    value: {
                        gap: ${settings.othBadges.user.value.gap}, // In px
                        size: {
                            height: ${settings.othBadges.user.value.size.height}, // In px
                            auto: ${settings.othBadges.user.value.size.auto}
                        }
                    },
                    active: ${settings.othBadges.user.active}
                },
                sub: {
                    value: {
                        gap: ${settings.othBadges.sub.value.gap}, // In px
                        size: {
                            height: ${settings.othBadges.sub.value.size.height}, // In px
                            auto: ${settings.othBadges.sub.value.size.auto}
                        }
                    },
                    active: ${settings.othBadges.sub.active}
                },
                vip: {
                    value: {
                        gap: ${settings.othBadges.vip.value.gap}, // In px
                        size: {
                            height: ${settings.othBadges.vip.value.size.height}, // In px
                            auto: ${settings.othBadges.vip.value.size.auto}
                        }
                    },
                    active: ${settings.othBadges.vip.active}
                },
                mod: {
                    value: {
                        gap: ${settings.othBadges.mod.value.gap}, // In px
                        size: {
                            height: ${settings.othBadges.mod.value.size.height}, // In px
                            auto: ${settings.othBadges.mod.value.size.auto}
                        }
                    },
                    active: ${settings.othBadges.mod.active}
                }
            },
            anmTiming: {
                user: {
                    value: {
                        delay: ${settings.anmTiming.user.value.delay},
                        appearing: ${settings.anmTiming.user.value.appearing},
                        duration: ${finalDurationUser},
                        vanishing: ${settings.anmTiming.user.value.vanishing}
                    },
                    active: ${settings.anmTiming.user.active}
                },
                sub: {
                    value: {
                        delay: ${settings.anmTiming.sub.value.delay},
                        appearing: ${settings.anmTiming.user.value.appearing},
                        duration: ${finalDurationSub},
                        vanishing: ${settings.anmTiming.user.value.vanishing}
                    },
                    active: ${settings.anmTiming.sub.active}
                },
                vip: {
                    value: {
                        delay: ${settings.anmTiming.vip.value.delay},
                        appearing: ${settings.anmTiming.user.value.appearing},
                        duration: ${finalDurationVip},
                        vanishing: ${settings.anmTiming.user.value.vanishing}
                    },
                    active: ${settings.anmTiming.vip.active}
                },
                mod: {
                    value: {
                        delay: ${settings.anmTiming.mod.value.delay},
                        appearing: ${settings.anmTiming.user.value.appearing},
                        duration: ${finalDurationMod},
                        vanishing: ${settings.anmTiming.user.value.vanishing}
                    },
                    active: ${settings.anmTiming.mod.active}
                }
            },
            anmShow: {
                user: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmShow.user.value[0].active},
                            value: ${settings.anmShow.user.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmShow.user.value[1].active},
                            value: ${settings.anmShow.user.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmShow.user.value[2].active},
                            value: ${settings.anmShow.user.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmShow.user.value[3].active},
                            value: ${settings.anmShow.user.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmShow.user.value[4].active},
                            value: ${settings.anmShow.user.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmShow.user.value[5].active},
                            value: ${settings.anmShow.user.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmShow.user.value[6].active},
                            value: ${settings.anmShow.user.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmShow.user.value[7].value}"
                        }
                    ],
                    active: ${settings.anmShow.user.active}
                },
                sub: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmShow.sub.value[0].active},
                            value: ${settings.anmShow.sub.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmShow.sub.value[1].active},
                            value: ${settings.anmShow.sub.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmShow.sub.value[2].active},
                            value: ${settings.anmShow.sub.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmShow.sub.value[3].active},
                            value: ${settings.anmShow.sub.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmShow.sub.value[4].active},
                            value: ${settings.anmShow.sub.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmShow.sub.value[5].active},
                            value: ${settings.anmShow.sub.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmShow.sub.value[6].active},
                            value: ${settings.anmShow.sub.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmShow.sub.value[7].value}"
                        }
                    ],
                    active: ${settings.anmShow.sub.active}
                },
                vip: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmShow.vip.value[0].active},
                            value: ${settings.anmShow.vip.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmShow.vip.value[1].active},
                            value: ${settings.anmShow.vip.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmShow.vip.value[2].active},
                            value: ${settings.anmShow.vip.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmShow.vip.value[3].active},
                            value: ${settings.anmShow.vip.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmShow.vip.value[4].active},
                            value: ${settings.anmShow.vip.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmShow.vip.value[5].active},
                            value: ${settings.anmShow.vip.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmShow.vip.value[6].active},
                            value: ${settings.anmShow.vip.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmShow.vip.value[7].value}"
                        }
                    ],
                    active: ${settings.anmShow.vip.active}
                },
                mod: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmShow.mod.value[0].active},
                            value: ${settings.anmShow.mod.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmShow.mod.value[1].active},
                            value: ${settings.anmShow.mod.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmShow.mod.value[2].active},
                            value: ${settings.anmShow.mod.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmShow.mod.value[3].active},
                            value: ${settings.anmShow.mod.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmShow.mod.value[4].active},
                            value: ${settings.anmShow.mod.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmShow.mod.value[5].active},
                            value: ${settings.anmShow.mod.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmShow.mod.value[6].active},
                            value: ${settings.anmShow.mod.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmShow.mod.value[7].value}"
                        }
                    ],
                    active: ${settings.anmShow.mod.active}
                }
            },
            anmHide: {
                user: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmHide.user.value[0].active},
                            value: ${settings.anmHide.user.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmHide.user.value[1].active},
                            value: ${settings.anmHide.user.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmHide.user.value[2].active},
                            value: ${settings.anmHide.user.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmHide.user.value[3].active},
                            value: ${settings.anmHide.user.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmHide.user.value[4].active},
                            value: ${settings.anmHide.user.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmHide.user.value[5].active},
                            value: ${settings.anmHide.user.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmHide.user.value[6].active},
                            value: ${settings.anmHide.user.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmHide.user.value[7].value}"
                        }
                    ],
                    active: ${settings.anmHide.user.active}
                },
                sub: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmHide.sub.value[0].active},
                            value: ${settings.anmHide.sub.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmHide.sub.value[1].active},
                            value: ${settings.anmHide.sub.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmHide.sub.value[2].active},
                            value: ${settings.anmHide.sub.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmHide.sub.value[3].active},
                            value: ${settings.anmHide.sub.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmHide.sub.value[4].active},
                            value: ${settings.anmHide.sub.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmHide.sub.value[5].active},
                            value: ${settings.anmHide.sub.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmHide.sub.value[6].active},
                            value: ${settings.anmHide.sub.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmHide.sub.value[7].value}"
                        }
                    ],
                    active: ${settings.anmHide.sub.active}
                },
                vip: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmHide.vip.value[0].active},
                            value: ${settings.anmHide.vip.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmHide.vip.value[1].active},
                            value: ${settings.anmHide.vip.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmHide.vip.value[2].active},
                            value: ${settings.anmHide.vip.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmHide.vip.value[3].active},
                            value: ${settings.anmHide.vip.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmHide.vip.value[4].active},
                            value: ${settings.anmHide.vip.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmHide.vip.value[5].active},
                            value: ${settings.anmHide.vip.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmHide.vip.value[6].active},
                            value: ${settings.anmHide.vip.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmHide.vip.value[7].value}"
                        }
                    ],
                    active: ${settings.anmHide.vip.active}
                },
                mod: {
                    value: [
                        {
                            type: "scale",
                            active: ${settings.anmHide.mod.value[0].active},
                            value: ${settings.anmHide.mod.value[0].value}
                        }, {
                            type: "moveX",
                            active: ${settings.anmHide.mod.value[1].active},
                            value: ${settings.anmHide.mod.value[1].value}
                        }, {
                            type: "moveY",
                            active: ${settings.anmHide.mod.value[2].active},
                            value: ${settings.anmHide.mod.value[2].value}
                        }, {
                            type: "rotateX",
                            active: ${settings.anmHide.mod.value[3].active},
                            value: ${settings.anmHide.mod.value[3].value}
                        }, {
                            type: "rotateY",
                            active: ${settings.anmHide.mod.value[4].active},
                            value: ${settings.anmHide.mod.value[4].value}
                        }, {
                            type: "rotateZ",
                            active: ${settings.anmHide.mod.value[5].active},
                            value: ${settings.anmHide.mod.value[5].value}
                        }, {
                            type: "opacity",
                            active: ${settings.anmHide.mod.value[6].active},
                            value: ${settings.anmHide.mod.value[6].value}
                        }, {
                            type: "curve",
                            value: "${settings.anmHide.mod.value[7].value}"
                        }
                    ],
                    active: ${settings.anmHide.mod.active}
                }
            }
        };
    `;

    console.log(exportText);
    
    blob = new Blob([exportText], {type: "text/plain;charset=utf-8"});
    saveAs(blob, "data.js");
}